<?php
class TroubleTickets_Fichier {
	
	var $id;
	var $ticket; //id
	var $projet; //id
	var $type; //1 : fichier  la cration du ticket ; 2 : fichier lors d'un change
	var $echange; //id
	var $datefichier; //datetime
	var $auteur;
	var $nom;
	var $description;
	
	//Constructeur
	function __construct($id='', $ticket='', $projet='', $type='', $echange='', $datefichier='', $auteur='', $nom='', $description='') {
		$this->id = $id;
		$this->ticket = $ticket;
		$this->projet = $projet;
		$this->type = $type; //ticket ou echange
		$this->echange = $echange;
		$this->datefichier = $datefichier;
		$this->auteur = $auteur;
		$this->nom = $nom;
		$this->description = $description;
	}
	
	/* Renvoie le chemin du fichier sur le systme de fichiers (chemin + nom du fichier) */
	function chemin() {
		if ($this->type == 1) {
			$chemin = troubletickets_cheminuploadmodule().'fichiersechangestickets/'.$this->ticket.'/'.$this->nom;
		} else {
			$chemin = troubletickets_cheminuploadmodule().'fichiersechangestickets/'.$this->ticket.'/'.$this->echange.'/'.$this->nom;
		}
		return $chemin;
	}
	
	/* Renvoie l'url de tlchargement du fichier */
	function url() {
		global $babAddonUrl;
		$url = $babAddonUrl.'user&amp;idx=telechargefichierechangeticket&amp;idfichier='.$this->id;
		return $url;
	}
	
	/* Charge les donnes enregistres dans la table de donnes dans l'objet */
	function charge() {
		$requete = "select `id`, `ticket`, `projet`, `type`, `echange`, `datefichier`, `auteur`, `nom`, `description` from `".TROUBLETICKETS_FICHIERECHANGETICKET."` where id='".$this->id."'";
		$idrequete = 0;
		$erreurs = Array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) == 1) {
			$this->ticket = $res[0]['ticket'];
			$this->projet = $res[0]['projet'];
			$this->type = $res[0]['type'];
			$this->echange = $res[0]['echange'];
			$this->datefichier = $res[0]['datefichier'];
			$this->auteur = $res[0]['auteur'];
			$this->nom = $res[0]['nom'];
			$this->description = $res[0]['description'];
		}
	}
	
	/* Enregistre les donnes du fichier */
	function enregistre() {
	if ($this->id == '') {
			/* On cr le nouveau fichier */
			$ticket = $this->ticket;
			$projet = $this->projet;
			$type = $this->type;
			$echange = $this->echange;
			$description = $this->description;
			$auteur = $this->auteur;
			$nom = $this->nom;
			$datefichier = troubletickets_datedujourdatetime(); //Date du jour avec heure
			$this->datefichier = $datefichier;
			troubletickets_echappesql($ticket);
			troubletickets_echappesql($projet);
			troubletickets_echappesql($type);
			troubletickets_echappesql($echange);
			troubletickets_echappesql($description);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($nom);
			troubletickets_echappesql($datefichier);
			$requete = "insert into `".TROUBLETICKETS_FICHIERECHANGETICKET."` ( `id`, `ticket`, `projet`, `type`, `echange`, `datefichier`, `auteur`, `nom`, `description` )
							  values ( '' , '$ticket' , '$projet' , '$type' , '$echange' , '$datefichier' , '$auteur' , '$nom' , '$description' )
							";
			$idrequete = 0;
			troubletickets_sql($requete, $erreurs, $idrequete);
			if (count($erreurs) == 0) {
				//On met  jour l'id
				$this->id = troubletickets_sqlid($idrequete);
				$erreurs[] = "Save done";
				return $this->id;
			}
		} else {
			/* On met  jour le ticket */
			$id = $this->id;
			$ticket = $this->ticket;
			$projet = $this->projet;
			$type = $this->type;
			$echange = $this->echange;
			$description = $this->description;
			$auteur = $this->auteur;
			$nom = $this->nom;
			$datefichier = $this->datefichier;
			troubletickets_echappesql($id);
			troubletickets_echappesql($ticket);
			troubletickets_echappesql($projet);
			troubletickets_echappesql($type);
			troubletickets_echappesql($echange);
			troubletickets_echappesql($description);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($nom);
			troubletickets_echappesql($datefichier);
			$requete = "update `".TROUBLETICKETS_FICHIERECHANGETICKET."` set `ticket`='".$ticket."',`projet`='".$projet."',`type`='".$type."',`echange`='".$echange."',`datefichier`='".$datefichier."',`auteur`='".$auteur."',`nom`='".$nom."',`description`='".$description."' where id='".$id."'";
			troubletickets_sql($requete, $erreurs, $idrequete="");
			if (count($erreurs) == 0) {
				$erreurs[] = "Save done";
			}
			return $this->id;
		}
	}
	
	/* Supprime l'objet */
	function supprime() {
		$chemin = $this->chemin();
		troubletickets_supprimefichier($chemin);
	}
	
	/* Dplace le fichier dans un autre projet */
	function deplace($idprojet = '') {
		if ($this->id != '' && $idprojet != '' && is_numeric($idprojet)) {
			$this->projet = $idprojet;
			$this->enregistre();
		}
	}
	
}
?>