<?php
class TroubleTickets_HistoriqueTicket {
	
	//Variables
	var $id;
	var $ticket; //id
	var $projet; //id
	var $auteur; //id
	var $statutticket; //id
	var $description;
	var $gravite;
	var $datehistorique;
	var $type; //Type 1 : client ; Type 2 : intervenant
	var $datemodification; /* Datetime : si la valeur n'est pas 0000-00-00 l'change a t modifi */
	
	//Constructeur
	function __construct($id='', $ticket='', $projet='', $auteur='', $statutticket='',$description='',$gravite='', $datehistorique='', $type='', $datemodification='') {
		$this->id = $id;
		$this->ticket = $ticket;
		$this->projet = $projet;
		$this->auteur = $auteur;
		$this->statutticket = $statutticket;
		$this->description = $description;
		$this->gravite = $gravite;
		$this->datehistorique = $datehistorique;
		$this->type = $type;
		$this->datemodification = $datemodification;
	}
	
	/* Charge les donnes enregistres dans la table de donnes dans l'objet */
	function charge() {
		$requete = "select `id`, `ticket`, `projet`, `auteur`, `statutticket`, `description`, `gravite`, `datehistorique`, `type`, `datemodification` from `".TROUBLETICKETS_HISTORIQUETICKET."` where id='".$this->id."'";
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) == 1) {
			$this->ticket = $res[0]['ticket'];
			$this->projet = $res[0]['projet'];
			$this->auteur = $res[0]['auteur'];
			$this->statutticket = $res[0]['statutticket'];
			$this->description = $res[0]['description'];
			$this->gravite = $res[0]['gravite'];
			$this->datehistorique = $res[0]['datehistorique'];
			$this->type = $res[0]['type'];
			$this->datemodification = $res[0]['datemodification'];
			
			return true;
		}
		
		return false;
	}

	/* Enregistre les donnes de l'historique */
	function enregistre($date='') {
	/* Traite les problmes d'encodage :
		 * Lorsqu'on installe TroubleTickets sur un site en ISO-8859-15, si une personne renseigne du contenu contenant des caractres
		 * non ISO dans un textarea (par exemple un copier-coller d'Outlook, Excel... qui sont en encodage Windows-1252)
		 * le navigateur retourne des caractres en htmlentities (les apostrophes de Word sont renvoyes en &#8217;) */
		if (bab_Charset::getIso() !== bab_Charset::UTF_8 && function_exists('iconv')) {
			$this->description = @iconv(bab_Charset::getIso(), bab_Charset::UTF_8, $this->description);
			$this->description = html_entity_decode($this->description, ENT_QUOTES, bab_Charset::UTF_8);
			$this->description = @iconv(bab_Charset::UTF_8, bab_Charset::getIso() .'//TRANSLIT', $this->description);
		}
		
		if ($this->id == '') {
			/* On cr le nouvel historique */
			$ticket = $this->ticket;
			$projet = $this->projet;
			$auteur = $this->auteur;
			$statutticket = $this->statutticket;
			$description = $this->description;
			$gravite = $this->gravite;
			/* Si la date est passe en paramtre  la fonction, on ne prend pas la date du jour */
			if ($date != '') {
				$datehistorique = $date;
			} else {
				$datehistorique = troubletickets_datedujourdatetime(); //Date du jour avec heure
			}
			$this->datehistorique = $datehistorique;
			$type = $this->type;
			$datemodification = $this->datemodification;
			troubletickets_echappesql($ticket);
			troubletickets_echappesql($projet);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($statutticket);
			troubletickets_echappesql($description);
			troubletickets_echappesql($gravite);
			troubletickets_echappesql($datehistorique);
			troubletickets_echappesql($type);
			troubletickets_echappesql($datemodification);
			$requete = "insert into `".TROUBLETICKETS_HISTORIQUETICKET."` ( `id` , `ticket` , `projet` , `auteur` , `statutticket` , `description` , `gravite`, `datehistorique`, `type` , `datemodification` )
							  values ( '' , '$ticket' , '$projet' , '$auteur' , '$statutticket' , '$description', '$gravite' , '$datehistorique' , '$type', '$datemodification' )
							";
			$idrequete = 0;
			troubletickets_sql($requete, $erreurs, $idrequete);
			if (count($erreurs) == 0) {
				//On met  jour l'id
				$this->id = troubletickets_sqlid($idrequete);
				return $this->id;
			}
		} else {
			/* On met  jour l'historique */
			$id = $this->id;
			$ticket = $this->ticket;
			$projet = $this->projet;
			$auteur = $this->auteur;
			$statutticket = $this->statutticket;
			$description = $this->description;
			$gravite = $this->gravite;
			/* Si la date est passe en paramtre  la fonction, on ne prend pas la date du jour */
			if ($date != '') {
				$datehistorique = $date;
			} else {
				$datehistorique = $this->datehistorique;
			}
			$type = $this->type;
			$datemodification = $this->datemodification;
			troubletickets_echappesql($id);
			troubletickets_echappesql($ticket);
			troubletickets_echappesql($projet);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($statutticket);
			troubletickets_echappesql($description);
			troubletickets_echappesql($gravite);
			troubletickets_echappesql($datehistorique);
			troubletickets_echappesql($type);
			troubletickets_echappesql($datemodification);
			$requete = "update `".TROUBLETICKETS_HISTORIQUETICKET."` set `ticket`='".$ticket."',`projet`='".$projet."',`auteur`='".$auteur."',`statutticket`='".$statutticket."',`description`='".$description."',`gravite`='".$gravite."',`datehistorique`='".$datehistorique."',`type`='".$type."',`datemodification`='".$datemodification."' where id='".$id."'";
			troubletickets_sql($requete, $erreurs, $idrequete="");
			if (count($erreurs) == 0) {
				$erreurs[] = "Save done";
			}
		}
	}
	
	/* Retourne la liste des destinataires sous forme d'objets ContactAnnuaire
	   Cette fonction est utilise pour connatre les destinataires dans le cas d'un historique par le client
	   ou pour initialiser les destinataires lors d'un historique cr par un intervenant */
	function destinataires() {
		$destinataires = array();
		
		/* Chargement des objets */
		$projet = troubletickets_listeprojets($this->projet);
		$ticket = new TroubleTickets_Ticket($this->ticket);
		$ticket->charge();
		
		if ($this->type == '1') {
			//L'historique vient du client
			//On envoie  ceux qui ont le droit de recevoir les mails des historiques clients
			$idutilisateurs = array(); /* stocke les identifiants des utilisateurs pour viter les doublons */
			$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUECLIENTS, $this->projet);
			$idmembres = array_keys($membres);//retourne les cls du tableau
			$nbIdMembres = count($idmembres);
			for ($k=0;$k<=$nbIdMembres-1;$k++) {
				if (!in_array($idmembres[$k], $idutilisateurs)) {
					$idutilisateurs[] = $idmembres[$k];
					$contact = new TroubleTickets_ContactAnnuaire('', $idmembres[$k], $this->id, $membres[$idmembres[$k]]['lastname'], $membres[$idmembres[$k]]['firstname'], $membres[$idmembres[$k]]['email'], '', '');
					$destinataires[] = $contact;
				}
			}
		}
		if ($this->type == '2') {
			/* L'historique vient de l'intervenant donc on envoie aux clients
               Selon l'option dans le projet, on envoie  tous les interlocuteurs clients ou uniquement  l'auteur du ticket */
			$idutilisateurs = array(); /* stocke les identifiants des utilisateurs pour viter les doublons */
			if ($projet[0]->notifiertouslesinterlocuteurs == 1) {
				/* Tous les interlocuteurs sont notifis */
				$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_CLIENTS, $this->projet);
				$idmembres = array_keys($membres);//retourne les cls du tableau
				$nbIdMembres = count($idmembres);
				for ($k=0;$k<=$nbIdMembres-1;$k++) {
					if (!in_array($idmembres[$k], $idutilisateurs)) {
						$idutilisateurs[] = $idmembres[$k];
						$contact = new TroubleTickets_ContactAnnuaire('', $idmembres[$k], $this->id, $membres[$idmembres[$k]]['lastname'], $membres[$idmembres[$k]]['firstname'], $membres[$idmembres[$k]]['email'], '', '');
						$destinataires[] = $contact;
					}
				}
			} else {
				/* Seul l'auteur du ticket est notifi */
				$idauteur = $ticket->auteur;
				$auteur = troubletickets_ficheannuaire($idauteur);
				$destinataires[] = new TroubleTickets_ContactAnnuaire('', $this->auteur, '', $auteur['sn'], $auteur['givenname'], $auteur['email'], '', '');
				$idutilisateurs[] = $this->auteur;
			}
			
			//On envoie  ceux qui ont le droit de recevoir les mails des historiques intervenants
			$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUEINTERVENANTS, $this->projet);
			$idmembres = array_keys($membres);//retourne les cls du tableau
			$nbIdMembres = count($idmembres);
			for ($k=0;$k<=$nbIdMembres-1;$k++) {
				if (!in_array($idmembres[$k], $idutilisateurs)) {
					$idutilisateurs[] = $idmembres[$k];
					$contact = new TroubleTickets_ContactAnnuaire('', $idmembres[$k], $this->id, $membres[$idmembres[$k]]['lastname'], $membres[$idmembres[$k]]['firstname'], $membres[$idmembres[$k]]['email'], '', '');
					$destinataires[] = $contact;
				}
			}
		}
		
		//Nouveau filtre des destinataires sur les adresses mails afin d'viter l'envoi en doublons si plusieurs comptes ont la mme adresse
		$adressesmails = array();
		$destinatairestmp = array();
		$nbDestinataires = count($destinataires);
		for ($k=0;$k<=$nbDestinataires-1;$k++) {
			if (!in_array($destinataires[$k]->email, $adressesmails)) {
				$destinatairestmp[] = $destinataires[$k];
				$adressesmails[] = $destinataires[$k]->email;
			}
		}
		$destinataires = $destinatairestmp;
		
		return $destinataires;
	}
	
	/* Envoie des mails en rapport au contexte
	   les paramtres contiennent uniquement des adresses spares par des virgules (ou espaces) et sont utiliss
	   lorsqu'un intervenant envoie un mail */
	function mail($destinatairesv='', $destinatairesencopiev='', $destinatairesencopiecacheev='') {
		/* Chargement des objets */
		$projet = troubletickets_listeprojets($this->projet);
		$client = troubletickets_listeclients($projet[0]->client);
		$ticket = new TroubleTickets_Ticket($this->ticket);
		$ticket->charge();
		
		/* Si c'est un historique cr par un client, on rcupre les destinataires d'origine, si c'est un historique
		   cr par un intervenant, on utilise les valeurs passes en paramtres */
		if ($this->type == '1') {
			$destinataires = $this->destinataires();
		}
		
		//Construction du mail
		//Titre du mail : pas besoin de protection html
		$entree = '';
		switch($this->statutticket) {
			case '1':
				if ($this->type == '1') {
					$entree = troubletickets_traduire('New ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				if ($this->type == '2') {
					$entree = troubletickets_traduire('New information from ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				break;
			case '2':
				if ($this->type == '1') {
					$entree = troubletickets_traduire('New information from ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				if ($this->type == '2') {
					$entree = troubletickets_traduire('The ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' '.troubletickets_traduire('is under treatment').' : '.$ticket->titre;
				}
				break;
			case '5':
				if ($this->type == '2') {
					$entree = troubletickets_traduire('Demand of close on the ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				break;
			case '6':
				if ($this->type == '1') {
					$entree = troubletickets_traduire('Demand of close accepted on the ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				if ($this->type == '2') {
					$entree = troubletickets_traduire('New information from ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				break;
			case '7':
				if ($this->type == '1') {
					$entree = troubletickets_traduire('Demand of close refused on the ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				if ($this->type == '2') {
					$entree = troubletickets_traduire('New information from ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				break;
			case '8':
				if ($this->type == '1') {
					$entree = troubletickets_traduire('New information from ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				}
				if ($this->type == '2') {
					$entree = troubletickets_traduire('The ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' '.troubletickets_traduire("is not accepted").' : '.$ticket->titre;
				}
				break;
			case '9':
				if ($this->type == '1') {
					$entree = troubletickets_traduire('The ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' '.troubletickets_traduire("is closed").' : '.$ticket->titre;
				}
				if ($this->type == '2') {
					$entree = troubletickets_traduire('The ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' '.troubletickets_traduire("is closed").' : '.$ticket->titre;
				}
				break;
			default:
				$entree = troubletickets_traduire('New information from ticket').' '.$ticket->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$ticket->titre;
				break;
		}
		$titre = $entree;
		
		//Rcupration de l'expditeur
		$resultats = troubletickets_configurationmodule();
		$expediteur = $resultats['expediteur_nom'];
		$expediteurmail = $resultats['expediteur_mail'];
		if ($resultats['mails_intervenants_sans_contenus'] == 2) {
			$mails_intervenants_sans_contenus = true;
		} else {
			$mails_intervenants_sans_contenus = false;
		}
		
		$texte = '<b>'.troubletickets_traduire('Project').' : </b>'.$projet[0]->nom.'<br />';
		$auteur = troubletickets_ficheannuaire($this->auteur);
		$texte .= '<b>'.troubletickets_traduire('Author').' : </b>'.troubletickets_protegehtml($auteur['givenname']).' <span style="text-transform: uppercase;">'.troubletickets_protegehtml($auteur['sn']).'</span><br />';
		$texte .= '<b>'.troubletickets_traduire('Subject of ticket').' : </b>'.troubletickets_protegehtml($ticket->titre).'<br />';
		
		/* On envoie pas la description, ni le lien dtail si le mail est envoy par un intervenant et si l'option a t coche par l'administrateur */
		if ($this->type == '2' && $mails_intervenants_sans_contenus) {
			global $babAddonUrl;
			$url = $babAddonUrl.'user&amp;idx=detailticket&amp;idticket='.$this->ticket;
			$texte .= '<br />'.troubletickets_traduire('This ticket evolved. To consult the detail of answer and to exchange in your turn, click on this link:').' </b><a href="'.$url.'">'.$url.'</a><br />';
			$texte .= troubletickets_traduire('Remark: you must be authenticated on the site beforehand.').'<br />';
		} else {
			$texte .= '<b>'.troubletickets_traduire('Description').' : </b>'.troubletickets_protegehtml($this->description).'<br />';
			$texte .= '<b>'.troubletickets_traduire('Severity').' : </b>'.$ticket->nomgravite().'<br />';	
			$texte .= '<b>'.troubletickets_traduire('Statute').' : </b>'.$ticket->nomstatut().'<br />';
			
			//Lien vers le dtail sur le site
			global $babAddonUrl;
			$url = $babAddonUrl.'user&amp;idx=detailticket&amp;idticket='.$this->ticket;
			$texte .= '<br /><b>'.troubletickets_traduire('You can consult the detail of the ticket by clicking this link').' : </b><a href="'.$url.'">'.$url.'</a><br />';
			$texte .= troubletickets_traduire('Remark: you must be authenticated on the site beforehand.').'<br />';
		}
		
		//Envoi des mails
		if ($this->type == '1') { //Echange cr par le client
			for ($i=0;$i<=count($destinataires)-1;$i++) {
				//Historique du client : on envoie pas de pices jointes
				troubletickets_envoimail($titre, $texte, $expediteur, $expediteurmail, $destinataires[$i]->nom.' '.$destinataires[$i]->prenom, $destinataires[$i]->email, array(), true);
			}
		} else {
			//Historique de l'intervenant : y'a pas de pices jointes
			//Recontruction des mails sous forme de tableaux et validation des adresses
			$destinataires = $this->valideadresses($destinatairesv);
			$destinatairesencopie = $this->valideadresses($destinatairesencopiev);
			$destinatairesencopiecachee = $this->valideadresses($destinatairesencopiecacheev);
			for ($i=0;$i<=count($destinataires)-1;$i++) {
				troubletickets_envoimail($titre, $texte, $expediteur, $expediteurmail, '', $destinataires[$i], array(), true);
			}
			for ($i=0;$i<=count($destinatairesencopie)-1;$i++) {
				troubletickets_envoimail($titre, $texte, $expediteur, $expediteurmail, '', $destinatairesencopie[$i], array(), true);
			}
			for ($i=0;$i<=count($destinatairesencopiecachee)-1;$i++) {
				troubletickets_envoimail($titre, $texte, $expediteur, $expediteurmail, '', $destinatairesencopiecachee[$i], array(), true);
			}
		}
		
	}
	
	/* Dplace l'historique dans un autre projet */
	function deplace($idprojet = '') {
		if ($this->id != '' && $idprojet != '' && is_numeric($idprojet)) {
			$this->projet = $idprojet;
			$this->enregistre();
		}
	}
	
	/* Retourne un tableau avec les adresses mails valides  partir d'une chane
	   La chane en paramtre contient des adresses spares par des virgules ou des espaces ou des points virgules */
	function valideadresses($destinatairesv='') {
		/* met en minuscules la chaine */
		$destinataires = strtolower($destinatairesv);
		/* remplace tous les espaces par des virgules afin de grer les adresses spares par des espaces */
		$destinataires = str_replace(" ", ",", $destinataires);		
		/* remplace les points virgules par des virgules */
		$destinataires = str_replace(";", ",", $destinataires);	
		/* spare les lments entre virgules */
		$tab = explode(",", $destinataires);
		/* supprime les lments vides du tableau */
		$tab2 = array();
		for ($i=0;$i<=count($tab)-1;$i++) {
			if ($tab[$i] != '') {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		/* valide si chaque lment est bien une adresse mail */
		$tab2 = array();
		for ($i=0;$i<=count($tab)-1;$i++) {
			if (troubletickets_valideadressemail($tab[$i])) {
				$tab2[] = $tab[$i];
			}
		}
		$tab = $tab2;
		return $tab;
	}
	
}

