<?php
/* Cr une image Camembert3D avec la librairie jpGraph */

class TroubleTickets_StatistiquesCamembert {

	//Variables
	var $titre; /* titre et sous-titre du graphique */
	var $soustitre;
	var $largeur; /* largeur et hauteur de l'image */
	var $hauteur;
	var $donnees; /* valeurs en pourcentage, $donnees est un tableau */
	var $legendes; /* tableau indiquant les titres lis aux valeurs dans $donnees */
	var $librairiejpgraphchargee; /* valeur booleen  */

	//Constructeur
	function __construct($titre, $soustitre, $largeur, $hauteur, $donnees=array(), $legendes) {
		$this->titre = $titre;
		$this->soustitre = $soustitre;
		$this->largeur = $largeur;
		$this->hauteur = $hauteur;
		$this->donnees = $donnees;
		$this->legendes = $legendes;

		/* Appel de la fonctionnalit jpGraphPhp5 */
		$jpGraph = bab_functionality::get('jpGraphPhp5');
		if ($jpGraph !== false) {
			$this->librairiejpgraphchargee = true;
			$jpGraph->includeLibrary();
			$jpGraph->includeUtilityClass('jpgraph_pie');
			$jpGraph->includeUtilityClass('jpgraph_pie3d');
			$jpGraph->includeUtilityClass('jpgraph_error');
		} else {
			$this->librairiejpgraphchargee = false;
		}
	}

	function affiche() {
		if ($this->librairiejpgraphchargee) {
			//Cration du graphe
			$graph = new PieGraph($this->largeur,$this->hauteur,"auto");
			$graph->SetShadow();
			$graph->title->Set($this->titre);
			$graph->title->SetFont(FF_FONT2,FS_BOLD);
			$graph->title->SetColor("darkblue");
			if ($this->soustitre != '') {
				$graph->footer->center->Set($this->soustitre);
				$graph->footer->center->SetFont(FF_FONT2,FS_BOLD);
				$graph->footer->center->SetColor("darkblue");
			}
			$graph->legend->Pos(0.05,0.2);

			$graph->SetAntiAliasing();

			//Application des donnes
			$p1 = new PiePlot3D($this->donnees);
			$p1->SetTheme("sand");
			$p1->SetCenter(0.3);
			$p1->SetSize(80);

			//Angle de vue
			$p1->SetAngle(80);
			$p1->SetStartAngle(45);

//			$p1->guideline = new LineProperty();
//			$p1->SetGuideLines();
//			$p1->ExplodeAll(5);

			//Affichage des rsultats
			$p1->SetLabelType(PIE_VALUE_ABS);
			$p1->value->SetFormat("%d");
			$p1->value->Show();

			//Couleurs
			$p1->value->SetFont(FF_FONT1,FS_BOLD);
			$p1->value->SetColor("navy");
			$p1->SetEdge("navy");

			//Axe des x
			$p1->SetLegends($this->legendes);

			$graph->Add($p1);
			$graph->Stroke(); //Affiche l'image
		}
	}

}
