<?php
class TroubleTickets_Ticket {
	
	var $id;
	var $projet;
	var $reference;
	var $auteur;
	var $titre;
	var $description;
	var $statutticket;
	var $statutechange; /* Valeur du dernier statut des changes : 3 ou 4 */
	var $gravite; /* 1: Minor ; 2 : Blocking ; 3 : Engrave ; 4 : Improvement */
	var $dateticket;
	var $couleur; /* valeur hxadcimale calcule par rapport au statut du ticket : n'est pas crite en base de donnes */
	var $ticketcreeparintervenant; /* boolen permettant de savoir si le ticket a t cr par l'intervenant ou le client */
	var $niveauintervenants; /* identifiant (entier) du niveau d'intervenants */
	var $dernierintervenant; /* identifiant utilisateur du dernier intervenant sur le ticket (changes ou historiques) */
	var $datederniereoperation; /* date de la dernire opration sur le ticket : cration du ticket, change client ou intervenant, historique client ou intervenant */
	var $categoriecloture;/* categorie de la cloture*/
	
	//Constructeur
	function __construct($id='', $projet='', $reference='', $auteur='', $titre='', $description='', $statutticket='', $gravite='', $date='', $ticketcreeparintervenant=false, $niveauintervenants='', $dernierintervenant='', $statutechange='', $datederniereoperation='', $categoriecloture=false) {
		$this->id = $id;
		$this->projet = $projet;
		$this->reference = $reference;
		$this->auteur = $auteur;
		$this->titre = $titre;
		$this->description = $description;
		$this->statutticket = $statutticket;
		$this->statutechange = $statutechange;
		if ($this->statutechange == '') {
			$this->statutechange = 4;
		}
		$this->gravite = $gravite;
		$this->dateticket = $date;
		$this->couleur = 'white';
		$this->ticketcreeparintervenant = $ticketcreeparintervenant;
		$this->niveauintervenants = $niveauintervenants;
		if ($this->niveauintervenants == '') {
			$niveauprincipal = troubletickets_niveauintervenantsprincipal();
			$this->niveauintervenants = $niveauprincipal->id;
		}
		$this->dernierintervenant = $dernierintervenant;
		if ($this->dernierintervenant == 0) {
			$this->dernierintervenant = '';
		}
		$this->datederniereoperation = $datederniereoperation;
		$this->categoriecloture = $categoriecloture;
	}
	
	/* Enregistre les donnes du ticket : attention en modification, la date de la dernire opration n'est pas mise  jour automatiquement */
	function enregistre() {
		/* Traite les problmes d'encodage :
		 * Lorsqu'on installe TroubleTickets sur un site en ISO-8859-15, si une personne renseigne du contenu contenant des caractres
		 * non ISO dans un textarea (par exemple un copier-coller d'Outlook, Excel... qui sont en encodage Windows-1252)
		 * le navigateur retourne des caractres en htmlentities (les apostrophes de Word sont renvoyes en &#8217;) */
		if (bab_Charset::getIso() !== bab_Charset::UTF_8 && function_exists('iconv')) {
			$this->titre = @iconv(bab_Charset::getIso(), bab_Charset::UTF_8, $this->titre);
			$this->titre = html_entity_decode($this->titre, ENT_QUOTES, bab_Charset::UTF_8);
			$this->titre = @iconv(bab_Charset::UTF_8, bab_Charset::getIso() .'//TRANSLIT', $this->titre);
			$this->description = @iconv(bab_Charset::getIso(), bab_Charset::UTF_8, $this->description);
			$this->description = html_entity_decode($this->description, ENT_QUOTES, bab_Charset::UTF_8);
			$this->description = @iconv(bab_Charset::UTF_8, bab_Charset::getIso() .'//TRANSLIT', $this->description);
		}
		
		if ($this->id == '') {
			/* On cr le nouveau ticket */
			$projet = $this->projet;
			$reference = $this->reference;
			$auteur = $this->auteur;
			$titre = $this->titre;
			$description = $this->description;
			
			/* Le statut est en cours de traitement si c'est l'intervenant qui cr le ticket */
			if ($this->ticketcreeparintervenant) {
				$statutticket = 2;
				$this->statutticket = 2;
			} else {
				$statutticket = 1;
				$this->statutticket = 1;
			}
			$this->statutechange = 4; /* Infos complmentaires */
			$gravite = $this->gravite;
			$dateticket = troubletickets_datedujourdatetime(); //Date du jour avec heure
			$this->dateticket = $dateticket;
			if ($this->ticketcreeparintervenant) {
				$ticketcreeparintervenant = 2;
			} else {
				$ticketcreeparintervenant = 1;
			}
			$niveauintervenants = $this->niveauintervenants;
			$dernierintervenant = $this->dernierintervenant;
			$datederniereoperation = troubletickets_datedujourdatetime(); /* Date de la dernire opration : ici cration du ticket */
			$this->datederniereoperation = $datederniereoperation;
			$categoriecloture = $this->categoriecloture;
			if($categoriecloture !== false){
				troubletickets_echappesql($categoriecloture);
			}
			
			troubletickets_echappesql($projet);
			troubletickets_echappesql($reference);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($titre);
			troubletickets_echappesql($description);
			troubletickets_echappesql($statutticket);
			troubletickets_echappesql($statutechange);
			troubletickets_echappesql($gravite);
			troubletickets_echappesql($dateticket);
			troubletickets_echappesql($ticketcreeparintervenant);
			troubletickets_echappesql($niveauintervenants);
			troubletickets_echappesql($dernierintervenant);
			troubletickets_echappesql($datederniereoperation);
			
			if($categoriecloture === false){
				$requete = "insert into `".TROUBLETICKETS_TICKET."` ( `id` , `projet` , `reference` , `auteur` , `titre` , `description` , `statutticket` , `gravite` , `dateticket`, `ticketcreeparintervenant`, `niveauintervenants`, `dernierintervenant`, `statutechange`, `datederniereoperation` )
								  values ( '' , '$projet' , '$reference' , '$auteur' , '$titre' , '$description' , '$statutticket' , '$gravite' , '$dateticket', '$ticketcreeparintervenant', '$niveauintervenants', '$dernierintervenant', '$statutechange', '$datederniereoperation' )
								";
			}else{
				$requete = "insert into `".TROUBLETICKETS_TICKET."` ( `id` , `projet` , `reference` , `auteur` , `titre` , `description` , `statutticket` , `gravite` , `dateticket`, `ticketcreeparintervenant`, `niveauintervenants`, `dernierintervenant`, `statutechange`, `datederniereoperation`, `categoriecloture` )
								values ( '' , '$projet' , '$reference' , '$auteur' , '$titre' , '$description' , '$statutticket' , '$gravite' , '$dateticket', '$ticketcreeparintervenant', '$niveauintervenants', '$dernierintervenant', '$statutechange', '$datederniereoperation', $categoriecloture )
								";
			}
			
			$idrequete = 0;
			troubletickets_sql($requete, $erreurs, $idrequete);
			if (count($erreurs) == 0) {
				//On ajoute la rfrence
				$this->id = troubletickets_sqlid($idrequete);
				$this->reference = 'T'.$this->id;
				$this->enregistre();
			}
			return $this->id;
		} else {
			/* On met  jour le ticket */			
			$id = $this->id;
			$projet = $this->projet;
			$reference = $this->reference;
			$auteur = $this->auteur;
			$titre = $this->titre;
			$description = $this->description;
			$statutticket = $this->statutticket;
			$statutechange = $this->statutechange;
			if ($statutechange == '') {
				$statutechange = 4; /* Infos complmentaires */
			}
			$gravite = $this->gravite;
			$dateticket = $this->dateticket;
			if ($this->ticketcreeparintervenant) {
				$ticketcreeparintervenant = 2;
			} else {
				$ticketcreeparintervenant = 1;
			}
			$niveauintervenants = $this->niveauintervenants;
			$dernierintervenant = $this->dernierintervenant;
			/* la date de la dernire opration n'est pas mise  jour automatiquement */
			$datederniereoperation = $this->datederniereoperation;
			
			/* 
			 * Si le statutticket passe en demande de clture (5), on passe alors le statutechange  Infos complmentaires (4)
			 * afin d'viter qu'aprs une rponse du client, le ticket reste en demande d'infos complmentaires (statut change)
			 */
			if ($statutticket == 5) {
				$statutechange = 4;
				$this->statutechange = 4;
			}
			
			$categoriecloture = $this->categoriecloture;
			if($categoriecloture !== false){
				troubletickets_echappesql($categoriecloture);
			}
			
			troubletickets_echappesql($id);
			troubletickets_echappesql($projet);
			troubletickets_echappesql($reference);
			troubletickets_echappesql($auteur);
			troubletickets_echappesql($titre);
			troubletickets_echappesql($description);
			troubletickets_echappesql($statutticket);
			troubletickets_echappesql($statutechange);
			troubletickets_echappesql($gravite);
			troubletickets_echappesql($dateticket);
			troubletickets_echappesql($niveauintervenants);
			troubletickets_echappesql($dernierintervenant);
			troubletickets_echappesql($datederniereoperation);
			
			if($categoriecloture === false){
				$requete = "update `".TROUBLETICKETS_TICKET."` set `projet`='".$projet."',`reference`='".$reference."',`auteur`='".$auteur."',`titre`='".$titre."',`description`='".$description."',`statutticket`='".$statutticket."',`gravite`='".$gravite."',`dateticket`='".$dateticket."',`ticketcreeparintervenant`='".$ticketcreeparintervenant."',`niveauintervenants`='".$niveauintervenants."',`dernierintervenant`='".$dernierintervenant."',`statutechange`='".$statutechange."',`datederniereoperation`='".$datederniereoperation."' where id='".$id."'";
			}else{
				$requete = "update `".TROUBLETICKETS_TICKET."` set `projet`='".$projet."',`reference`='".$reference."',`auteur`='".$auteur."',`titre`='".$titre."',`description`='".$description."',`statutticket`='".$statutticket."',`gravite`='".$gravite."',`dateticket`='".$dateticket."',`ticketcreeparintervenant`='".$ticketcreeparintervenant."',`niveauintervenants`='".$niveauintervenants."',`dernierintervenant`='".$dernierintervenant."',`statutechange`='".$statutechange."',`datederniereoperation`='".$datederniereoperation."',`categoriecloture`='".$categoriecloture."' where id='".$id."'";
			}
			troubletickets_sql($requete, $erreurs, $idrequete="");
			if (count($erreurs) == 0) {
				$erreurs[] = "Save done";
			}
			return $this->id;
		}
	}
	
	/* Retourne le nom du statut courant en texte */
	function nomstatut() {
		$nom = troubletickets_listestatutstickets($this->statutticket);
		return $nom[0]['nom'];
	}
	
	/* Retourne le nom de la gravit courante en texte */
	function nomgravite() {
		$nom = troubletickets_listegravites($this->gravite);
		return $nom[0]['nom'];
	}
	
	/* Retourne le nom de la catgorie de la cloture en texte */
	function nomcategoriecloture() {
		$nom = troubletickets_listcategoriesclotures($this->categoriecloture);
		return $nom[0]['nom'];
	}
	
	/* Retourne la liste des destinataires sous forme d'objets ContactAnnuaire */
	function destinataires() {
		/* Les mails des tickets correspondent uniquement aux mails de cration de tickets
		 * destinataires : l'auteur du ticket et ceux qui ont des droits d'tre notifis des nouveaux tickets
		 */
		$destinataires = array();
		
		//Ajoute l'auteur du ticket comme destinataire
		$auteur = troubletickets_ficheannuaire($this->auteur);
		$destinataires[] = new TroubleTickets_ContactAnnuaire('', $this->auteur, '', $auteur['sn'], $auteur['givenname'], $auteur['email'], '', '');
		$idutilisateurs = array(); /* stocke les identifiants des utilisateurs pour viter les doublons */
		$idutilisateurs[] = $this->auteur; //Ajoute l'id de l'auteur
		
		//Droits nouveaux tickets
		if ($this->ticketcreeparintervenant) {
			$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS, $this->projet);
		} else {
			$membres = troubletickets_membresdroit(TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS, $this->projet);
		}
		$idmembres = array_keys($membres);//retourne les cls du tableau
		$nbIdMembres = count($idmembres);
		for ($k=0;$k<=$nbIdMembres-1;$k++) {
			if (!in_array($idmembres[$k], $idutilisateurs)) {
				$idutilisateurs[] = $idmembres[$k];
				$contact = new TroubleTickets_ContactAnnuaire('', $idmembres[$k], $this->id, $membres[$idmembres[$k]]['lastname'], $membres[$idmembres[$k]]['firstname'], $membres[$idmembres[$k]]['email'], '', '');
				$destinataires[] = $contact;
			}
		}
		
		//Nouveau filtre des destinataires sur les adresses mails afin d'viter l'envoi en doublons si plusieurs comptes ont la mme adresse
		$adressesmails = array();
		$destinatairestmp = array();
		$nbDestinataires = count($destinataires);
		for ($k=0;$k<=$nbDestinataires-1;$k++) {
			if (!in_array($destinataires[$k]->email, $adressesmails)) {
				$destinatairestmp[] = $destinataires[$k];
				$adressesmails[] = $destinataires[$k]->email;
			}
		}
		$destinataires = $destinatairestmp;
		
		return $destinataires;
	}
	
	/* Envoie un mail avec les informations du ticket */
	function mail() {
		/* Les mails des tickets correspondent uniquement aux mails de cration de tickets
		 * destinataires : l'auteur du ticket et ceux qui ont des droits d'tre notifis des nouveaux tickets
		 */
		$destinataires = $this->destinataires();
		
		//Construction du mail
		$projet = troubletickets_listeprojets($this->projet);
		$client = troubletickets_listeclients($projet[0]->client);
		$sujet = troubletickets_traduire('New ticket').' '.$this->reference.' '.troubletickets_traduire('from customer').' '.$client[0]->nom.' : '.$this->titre;
		$texte = '<b>'.troubletickets_traduire('Project').' : </b>'.$projet[0]->nom.'<br />';
		$auteur = troubletickets_ficheannuaire($this->auteur);
		$texte = $texte.'<b>'.troubletickets_traduire('Author').' : </b>'.troubletickets_protegehtml($auteur['givenname']).' <span style="text-transform: uppercase;">'.troubletickets_protegehtml($auteur['sn']).'</span> ('.troubletickets_protegehtml($auteur['email']).')<br />';
		$texte = $texte.'<b>'.troubletickets_traduire('Subject').' : </b>'.troubletickets_protegehtml($this->titre).'<br />';
		$texte = $texte.'<b>'.troubletickets_traduire('Description').' : </b>'.troubletickets_protegehtml($this->description).'<br />';
		$texte = $texte.'<b>'.troubletickets_traduire('Severity').' : </b>'.$this->nomgravite().'<br />';	
		//Pices jointes : on ne les envoie pas  la cration du ticket
		$fichiersj = $this->fichiers('', 1);	
		$fichiers = array();
		for ($i=0;$i<=count($fichiersj)-1;$i++) {
			$fichiers[] = array('chemin' => $fichiersj[$i]->chemin(), 'nom' => troubletickets_protegehtml($fichiersj[$i]->nom), 'type' => '');
		}
		$texte = $texte.'<b>'.troubletickets_traduire('Number of attached files').' : </b>'.count($fichiers).'<br />';	
		
		//Rcupration de l'expditeur
		$resultats = troubletickets_configurationmodule();
		$expediteur = $resultats['expediteur_nom'];
		$expediteurmail = $resultats['expediteur_mail'];
		
		//Lien vers le dtail sur le site
		global $babAddonUrl;
		$url = $babAddonUrl.'user&amp;idx=detailticket&amp;idticket='.$this->id;
		$texte = $texte.'<br /><b>'.troubletickets_traduire('You can consult the detail of the ticket by clicking this link').' : </b><a href="'.$url.'">'.$url.'</a><br />';
		$texte = $texte.troubletickets_traduire('Remark: you must be authenticated on the site beforehand.').'<br />';
		
		//Envoi du mail		
		for ($i=0;$i<=count($destinataires)-1;$i++) {
			troubletickets_envoimail($sujet, $texte, $expediteur, $expediteurmail, $destinataires[$i]->nom.' '.$destinataires[$i]->prenom, $destinataires[$i]->email, array(), true);
		}
	}
	
	/* Renvoie la liste des catgories de clture d'un ticket */
	function categoriesclotures(){
		$categories[] = array('id' => 0, 'nom' => troubletickets_traduire('Undifined'));
		$categories[] = array('id' => 1, 'nom' => troubletickets_traduire('Integration Bug'));
		$categories[] = array('id' => 2, 'nom' => troubletickets_traduire('Coding Bug'));
		$categories[] = array('id' => 3, 'nom' => troubletickets_traduire('Usage issue'));
		$categories[] = array('id' => 4, 'nom' => troubletickets_traduire('Enhancement'));
		
		return $categories;
	}
	
	/* Renvoie la liste des statuts tickets selon le contexte */
	function statutstickets($profil='') {
		$statuts = array();
		if ($profil == '') {
			$statuts = troubletickets_listestatutstickets();
		}
		if ($profil == 'clients' || $profil == 'client') {
			switch($this->statutticket) {
				case '1':
					$statuts[] = array('id' => 1, 'nom' => troubletickets_traduire('In waiting of consideration'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '2':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '5':
					$statuts[] = array('id' => 6, 'nom' => troubletickets_traduire('Demand of close accepted'));
					$statuts[] = array('id' => 7, 'nom' => troubletickets_traduire('Demand of close refused'));
					break;
				case '6':
					$statuts[] = array('id' => 6, 'nom' => troubletickets_traduire('Demand of close accepted'));
					$statuts[] = array('id' => 7, 'nom' => troubletickets_traduire('Demand of close refused'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '7':
					$statuts[] = array('id' => 6, 'nom' => troubletickets_traduire('Demand of close accepted'));
					$statuts[] = array('id' => 7, 'nom' => troubletickets_traduire('Demand of close refused'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '8': //Non accept
					$statuts[] = array('id' => 1, 'nom' => troubletickets_traduire('In waiting of consideration'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					break;
				case '9': //Ferm
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
			}
		}
		if ($profil == 'intervenants' || $profil == 'intervenant') {
			switch($this->statutticket) {
				case '1':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					break;
				case '2':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '5':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '6':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
					$statuts[] = array('id' => 6, 'nom' => troubletickets_traduire('Demand of close accepted'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '7':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '8':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
				case '9':
					$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
					$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
					$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
					$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
					break;
			}
		}
		return $statuts;
	}

	/* Renvoie la liste des statuts des changes en rapport au contexte */
	function statutsechanges($profil='') {
		$dernierstatutechange = $this->dernierstatutechanges();
		
		$statuts = array();
		if ($profil == '') {
			$statuts = troubletickets_listestatutsechanges();
		}
		if ($profil == 'clients' || $profil == 'client') {
			switch($dernierstatutechange) {
				case '3':
					$statuts[] = array('id' => 4, 'nom' => troubletickets_traduire('Complementary information'));
					break;
				case '4':
					$statuts[] = array('id' => 4, 'nom' => troubletickets_traduire('Complementary information'));
					break;
			}
		}
		if ($profil == 'intervenants' || $profil == 'intervenant') {
			switch($dernierstatutechange) {
				case '3':
					$statuts[] = array('id' => 3, 'nom' => troubletickets_traduire('Demand of complementary information'));
					$statuts[] = array('id' => 4, 'nom' => troubletickets_traduire('Complementary information'));
					break;
				case '4':
					$statuts[] = array('id' => 3, 'nom' => troubletickets_traduire('Demand of complementary information'));
					$statuts[] = array('id' => 4, 'nom' => troubletickets_traduire('Complementary information'));
					break;
			}
		}
		return $statuts;
	}	
	
	/* Charge les donnes enregistres dans la table de donnes dans l'objet */
	function charge() {
		$requete = "select `id`, `projet`, `reference`, `auteur`, `titre`, `description`, `statutticket`, `gravite`, `dateticket`, `ticketcreeparintervenant`, `niveauintervenants`, `dernierintervenant`, `statutechange`, `datederniereoperation`, `categoriecloture` from `".TROUBLETICKETS_TICKET."` where id='".$this->id."'";
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) == 1) {
			$this->projet = $res[0]['projet'];
			$this->reference = $res[0]['reference'];
			$this->auteur = $res[0]['auteur'];
			$this->titre = $res[0]['titre'];
			$this->description = $res[0]['description'];
			$this->statutticket = $res[0]['statutticket'];
			$this->statutechange = $res[0]['statutechange'];
			$this->gravite = $res[0]['gravite'];
			$this->dateticket = $res[0]['dateticket'];
			$this->categoriecloture = $res[0]['categoriecloture'];
			if ($res[0]['ticketcreeparintervenant'] == 2) {
				$this->ticketcreeparintervenant = true;
			} else {
				$this->ticketcreeparintervenant = false;
			}
			$this->niveauintervenants = $res[0]['niveauintervenants'];
			$this->dernierintervenant = $res[0]['dernierintervenant'];
			if ($this->dernierintervenant == 0) {
				$this->dernierintervenant = '';
			}
			$this->datederniereoperation = $res[0]['datederniereoperation'];
			return true;
		} else {
			return false;
		}
	}
	
	/* Retourne la liste ordonne par dates dcroissantes des changes du ticket */
	function echanges($echange='') {
		$echanges = array();
		$requete = "select `id`, `ticket`, `projet`, `auteur`, `description`, `dateechange`, `type`, `statutechange`, `datemodification` from `".TROUBLETICKETS_ECHANGETICKET."` where ticket='".$this->id."'";
		if ($echange != '') {
			$requete = $requete." and id='$echange'";
		}
		$requete = $requete." order by dateechange DESC";
		
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) != 0) {
			//Construction des objets Echange
			$nb = count($res);
			for ($i=0;$i<=$nb-1;$i++) {
				$echanges[] = new TroubleTickets_Echange($res[$i]['id'], $res[$i]['ticket'], $res[$i]['projet'], $res[$i]['auteur'], $res[$i]['description'], $res[$i]['dateechange'], $res[$i]['type'], $res[$i]['statutechange'], $res[$i]['datemodification']);
			}
		}
		return $echanges;
	}
	
	/* Retourne la liste ordonne par dates croissantes des fichiers du ticket et des changes du ticket */
	function fichiers($fichier='', $type='') {
		$fichiers = array();
		$requete = "select `id`, `ticket`, `projet`, `type`, `echange`, `datefichier`, `auteur`, `nom`, `description` from `".TROUBLETICKETS_FICHIERECHANGETICKET."` where ticket='".$this->id."'";
		if ($fichier != '') {
			$requete = $requete." and id='$fichier'";
		}
		if ($type != '') {
			$requete = $requete." and type='$type'";
		}
		$requete = $requete." order by datefichier, nom ASC";
		
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) != 0) {
			//Construction des objets Fichier
			for ($i=0;$i<=count($res)-1;$i++) {
				$fichiers[] = new TroubleTickets_Fichier($res[$i]['id'], $res[$i]['ticket'], $res[$i]['projet'], $res[$i]['type'], $res[$i]['echange'], $res[$i]['datefichier'], $res[$i]['auteur'], $res[$i]['nom'], $res[$i]['description']);
			}
		}
		return $fichiers;
	}
	
	/* Renvoie la liste ordonne par dates dcroissantes des historiques du ticket
	 */
	function historique($idhistorique='') {
		$historique = array();
		$requete = "select `id`, `ticket`, `projet`, `auteur`, `statutticket`, `description`, `gravite`, `datehistorique`, `type`, `datemodification` from `".TROUBLETICKETS_HISTORIQUETICKET."` where ticket='".$this->id."'";
		if ($idhistorique != '') {
			$requete = $requete." and id='$idhistorique'";
		}
		$requete = $requete." order by datehistorique DESC";
		
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) != 0) {
			//Construction des objets HistoriqueTicket
			for ($i=0;$i<=count($res)-1;$i++) {
				$historique[] = new TroubleTickets_HistoriqueTicket($res[$i]['id'], $res[$i]['ticket'], $res[$i]['projet'], $res[$i]['auteur'], $res[$i]['statutticket'], $res[$i]['description'], $res[$i]['gravite'], $res[$i]['datehistorique'], $res[$i]['type'], $res[$i]['datemodification']);
			}
		}	
		return $historique;
	}
	
	/* Renvoie le numro du dernier statut des changes
	 * Retourne 3 ou 4 */
	function dernierstatutechanges() {
		$requete = "select `statutechange` from `".TROUBLETICKETS_ECHANGETICKET."` where ticket='$this->id' order by dateechange desc";
		$idrequete = 0;
		$erreurs = array();
		$res = troubletickets_sql($requete, $erreurs, $idrequete);
		if (count($res) != 0) {
			return $res[0]['statutechange'];
		} else {
			return 4; /* retourne 4 (informations complmentaires) par dfaut */
		}
	}
	
	/* Retourne la couleur du ticket par rapport  son statut et le type de l'utilisateur qui le regarde
	 * Couleur bleue : le ticket est en attente de rponse de l'autre entit
	 * Couleur verte : le ticket est trait
	 * Couleur rouge : le ticket est en attente d'une rponse de notre part
	 */
	function couleur($typeutilisateur='client') {
		$couleur = '#F5F5F5';
		if ($typeutilisateur == 'client') {
			switch($this->statutticket) {
				case '1': /* en attente de prise en compte */
				case '7': /* demande de clture refuse */
					$couleur = 'blue';
					break;
				case '2': /* en cours de traitement */
					$couleur = 'blue';
					/* la couleur peut tre rouge si le dernier change est en demande d'infos complmentaires */
					$statutechange = $this->dernierstatutechanges();
					if ($statutechange == 3) {
						$couleur = 'red';
					}
					break;
				case '6': /* demande de clture accepte */
				case '9': /* ticket ferm */
					$couleur = 'green';
					break;
				case '5': /* demande de clture */
				case '8': /* ticket non accept */
					$couleur = 'red';
					break;
			}
		} else {
			switch($this->statutticket) {
				case '1': /* en attente de prise en compte */
				case '7': /* demande de clture refuse */
					$couleur = 'red';
					break;
				case '2': /* en cours de traitement */
					$couleur = 'orange';
					/* la couleur peut tre bleue si le dernier change est en demande d'infos complmentaires */
					$statutechange = $this->dernierstatutechanges();
					if ($statutechange == 3) {
						$couleur = 'blue';
					}
					break;
				case '6': /* demande de clture accepte */
				case '9': /* ticket ferm */
					$couleur = 'green';
					break;
				case '5': /* demande de clture */
				case '8': /* ticket non accept */
					$couleur = 'blue';
					break;
			}
		}
		return $couleur;
	}
	
	/* Supprime l'objet */
	function supprime() {
		if ($this->id != '') {
			/* Suppression des fichiers du ticket */
			$fichiers = $this->fichiers();
			for ($i=0;$i<=count($fichiers)-1;$i++) {
				$fichiers[$i]->supprime();
			}
			
			/* Suppression du ticket */
			$requete = "delete from `".TROUBLETICKETS_TICKET."` where id='".$this->id."'";
			$idrequete = 0;
			$erreurs = array();
			$res = troubletickets_sql($requete, $erreurs, $idrequete);
		}
	}
	
	/* Dplace le ticket dans un autre projet : actuellement on ne peut dplacer que dans un projet de mme client */
	function deplace($idprojet = '') {
		if ($this->id != '' && $idprojet != '' && is_numeric($idprojet)) {
			//Vrifie que le projet cible fait partie du mme client
			$projet = new TroubleTickets_Projet($this->projet);
			$projet->charge();
			$clientticket = new TroubleTickets_Client($projet->client);
			$projetcible = new TroubleTickets_Projet($idprojet);
			$projetcible->charge();
			if ($projetcible->client == $clientticket->id) {
				//Rcupration des echanges du ticket
				$echanges = $this->echanges();
				//Rcupration des historiques du ticket
				$historiques = $this->historique();
				//Rcupration des fichiers du ticket
				$fichiers = $this->fichiers();
				
				//Dplacement des echanges
				for ($i=0;$i<=count($echanges)-1;$i++) {
					$echanges[$i]->deplace($idprojet);
				}
				//Dplacement des historiques
				for ($i=0;$i<=count($historiques)-1;$i++) {
					$historiques[$i]->deplace($idprojet);
				}
				//Dplacement des fichiers
				for ($i=0;$i<=count($fichiers)-1;$i++) {
					$fichiers[$i]->deplace($idprojet);
				}
				//Dplacement du ticket
				$this->projet = $idprojet;
				$this->enregistre();
			}			
		}
	}
	
	/* Retourne l'id utilisateur du dernier intervenant sur le ticket (changes et historiques)
	   La valeur est recalcule  chaque appel de la fonction */
	function dernierintervenant() {
		$dernierintervenant = '';
		/* On parcourt tous les changes et historiques  la recherche d'envois d'un intervenant, et on prend le plus rcent */
		$timestamprecent = 0;
		$echanges = $this->echanges();
		$historiques = $this->historique();
		$nb = count($echanges);
		for ($i=0;$i<=$nb-1;$i++) {
			if ($echanges[$i]->type == 2) { /* cr par un intervenant */
				if (troubletickets_timestampdatetime($echanges[$i]->dateechange) > $timestamprecent) {
					$dernierintervenant = $echanges[$i]->auteur;
					$timestamprecent = troubletickets_timestampdatetime($echanges[$i]->dateechange);
				}
			}
		}
		$nb2 = count($historiques);
		for ($i=0;$i<=$nb2-1;$i++) {
			if ($historiques[$i]->type == 2) { /* cr par un intervenant */
				if (troubletickets_timestampdatetime($historiques[$i]->datehistorique) > $timestamprecent) {
					$dernierintervenant = $historiques[$i]->auteur;
					$timestamprecent = troubletickets_timestampdatetime($historiques[$i]->datehistorique);
				}
			}
		}
		return $dernierintervenant;
	}
	
	/* Retourne en code HTML la liste des changes et historiques du ticket classe par dates dcroissantes */
	function melangeechangeshistoriques() {
		$melangeechangeshistoriques = '';
		$afficheechanges = array();
		$affichehistoriques = array();
		
		$estIntervenant = false;
		if (troubletickets_adroitsprojets('intervenants', $this->projet)) {
        	$estIntervenant = true;
      	}
		
		//Reconstruit chaque echange et historique
		$echanges = $this->echanges();
		$nbechanges = count($echanges);
		for($i=0;$i<=$nbechanges-1;$i++) {
			$auteur = troubletickets_ficheannuaire($echanges[$i]->auteur);
			$idechange = troubletickets_protegehtml($echanges[$i]->id);
			$auteurechange = troubletickets_protegehtml($auteur['givenname'].' '.$auteur['sn']);
			$descriptionechange = troubletickets_protegehtml($echanges[$i]->description);
			$dateechange = troubletickets_formatedatetime($echanges[$i]->dateechange);
			$datemodification = troubletickets_formatedatetime($echanges[$i]->datemodification);
			$tstatutechange = troubletickets_traduire('Statute');
			$statut = troubletickets_listestatutsechanges($echanges[$i]->statutechange);
			$statutechange = $statut[0]['nom'];
			//Liste des fichiers de l'change
			$tfichiersechange = troubletickets_traduire('Attached files');
			$fichiersechange = $echanges[$i]->fichiers();
			
			if ($echanges[$i]->type == '1') {
				$texte = '<table cellpadding="0" cellspacing="0" class="troubletickets_echangeclientticket" width="100%" id="troubletickets_idechange_'.$idechange.'">';
			} else {
				$texte = '<table cellpadding="0" cellspacing="0" class="troubletickets_echangeintervenantticket" width="100%" id="troubletickets_idechange_'.$idechange.'">';
			}
			$texte .= '<tr>
						<td>';
			if ($estIntervenant) { /* Lien de modification de l'change */
				$texte .= '
					<div class="troubletickets_echange_datemodification">
						<a href="'.$GLOBALS['babPhpSelf'].'?tg='.$GLOBALS['babAddonTarget'].'/user&idx=modifieechange&idechange='.$idechange.'">'.troubletickets_traduire('Modify').'</a>
					</div>
				';
			}
			$texte .= '		<table border="0">
								<tr>';
			/* Affiche l'avatar */
			$compte = new TroubleTickets_CompteUtilisateur('', $echanges[$i]->auteur);
			$compte->charge();
			if ($compte->avatarexiste()) {
				$afficheavatar = true;
				global $babAddonUrl;
				$photoutilisateur = $babAddonUrl.'user&amp;idx=afficheavatar50&amp;idutilisateur='.$echanges[$i]->auteur;
			} else {
				$afficheavatar = false;
				$photoutilisateur = '';
			}
			if ($afficheavatar) {
					$texte .= '<td width="51" valign="top" style="border: black 0px solid;">
									<img src="'.$photoutilisateur.'" alt="'.$auteurechange.'" style="border: #dedede 1px solid;">
							   </td>';
			}
			$texte .= '
							<td style="border: 0px solid #dedede;"><h3 class="troubletickets_titreechangeintervenantticket">'.$auteurechange.' | '.$dateechange.'</h3></td>
							</tr>
							</table>
							<b>'.$tstatutechange.' :</b> '.$statutechange.'<br />
							'.$descriptionechange.'<br />';
							if (count($fichiersechange) != 0) {
								$texte .= '<br />
								<fieldset>
								<legend><b>'.$tfichiersechange.'</b></legend>';
								$nbFichiersEchanges = count($fichiersechange);
								for ($k=0;$k<=$nbFichiersEchanges-1;$k++) {
									$texte .= '<a href="'.$fichiersechange[$k]->url().'"><span class="troubletickets_champimportant">'.$fichiersechange[$k]->nom.'</span></a> ('.troubletickets_taillefichier($fichiersechange[$k]->chemin(), 'Ko').' Ko)';
									if ($fichiersechange[$k]->description != '') {
										$texte .= '| '.troubletickets_protegehtml($fichiersechange[$k]->description);
									}
									/* Teste si le fichier est une image */
									if (troubletickets_typeimage($fichiersechange[$k]->chemin()) != '') {
										$urlimgimage = troubletickets_urltemplatesmodule().'images/png.gif';
										$tfichierimage = troubletickets_traduire('The file is a picture');
										$tvoirapercu = troubletickets_traduire('See a preview');
										global $babAddonUrl;
										$urlapercuimage = $babAddonUrl.'user&amp;idx=apercuimage&amp;idfichier='.$fichiersechange[$k]->id;
										$texte .= '<br />
												   <img src="'.$urlimgimage.'" alt="" title="" style="position:relative;top:4px;" /> <b>'.$tfichierimage.' :</b> <a href="'.$urlapercuimage.'" target="_blank" onclick="bab_popup(this.href);return false;">'.$tvoirapercu.'</a>';
									}
									$texte .= '<br />';
								}
								$texte .= '</fieldset>';
							}
							/* Affiche la date de modification de l'change */
							if ($datemodification != '0000-00-00 00:00:00' && $datemodification != '') {
								$texte .= '
								<div class="troubletickets_echange_datemodification">
									change modifi par l\'intervenant le '.$datemodification.'
								</div>
								';
							}
					$texte .= '	</td>
					</tr>
				</table>
				<br />';
			$date = $echanges[$i]->dateechange;
			$date = substr($date,0,4).substr($date,5,2).substr($date,8,2).substr($date,11,5);
			$afficheechanges[] = array($date, $texte);
		}
		$historique = $this->historique();
		$nbHistorique = count($historique);
		for($i=0;$i<=$nbHistorique-1;$i++) {
			$idhistorique = troubletickets_protegehtml($historique[$i]->id);
			$auteur = troubletickets_ficheannuaire($historique[$i]->auteur);
			$auteurhistorique = troubletickets_protegehtml($auteur['givenname'].' '.$auteur['sn']);
			$descriptionhistorique = troubletickets_protegehtml($historique[$i]->description);
			$datemodification = troubletickets_formatedatetime($historique[$i]->datemodification);
			$datehistorique = troubletickets_formatedatetime($historique[$i]->datehistorique);
			$tstatuthistorique = troubletickets_traduire('Statute');
			$statut = troubletickets_listestatutstickets($historique[$i]->statutticket);
			$statuthistorique = $statut[0]['nom'];
			$tgravitehistorique = troubletickets_traduire("Severity");
			$gravite = troubletickets_listegravites($historique[$i]->gravite);
			$gravitehistorique = $gravite[0]['nom'];
			
			if ($historique[$i]->type == '1') {
				$texte = '<table cellpadding="0" cellspacing="0" class="troubletickets_historiqueclientticket" width="100%" id="troubletickets_idhistorique_'.$idhistorique.'">';
			} else {
				$texte = '<table cellpadding="0" cellspacing="0" class="troubletickets_historiqueintervenantticket" width="100%" id="troubletickets_idhistorique_'.$idhistorique.'">';
			}
			$texte .= '<tr>
						<td>';
			if ($estIntervenant) { /* Lien de modification de l'historique */
				$texte .= '
					<div class="troubletickets_echange_datemodification">
						<a href="'.$GLOBALS['babPhpSelf'].'?tg='.$GLOBALS['babAddonTarget'].'/user&idx=modifiehistoriqueticket&idhistorique='.$idhistorique.'">'.troubletickets_traduire('Modify').'</a>
					</div>
				';
			}
			$texte .= '		<table>
								<tr>';
			/* Affiche l'avatar */
			$compte = new TroubleTickets_CompteUtilisateur('', $historique[$i]->auteur);
			$compte->charge();
			if ($compte->avatarexiste()) {
				$afficheavatar = true;
				global $babAddonUrl;
				$photoutilisateur = $babAddonUrl.'user&amp;idx=afficheavatar50&amp;idutilisateur='.$historique[$i]->auteur;
			} else {
				$afficheavatar = false;
				$photoutilisateur = '';
			}
			if ($afficheavatar) {
					$texte .= '<td width="51" valign="top" style="border: black 0px solid;">
							<img src="'.$photoutilisateur.'" alt="'.$auteurhistorique.'" style="border: #dedede 1px solid;">
						</td>';
			}
					$texte .= '	
							<td style="border: 0px solid #dedede;"><h3 class="troubletickets_titrehistoriqueintervenantticket">'.$auteurhistorique.' | '.$datehistorique.'</h3></td>
							</tr>
							</table>
							<b>'.$tstatuthistorique.' :</b> '.$statuthistorique.'<br />
							<b>'.$tgravitehistorique.' :</b> '.$gravitehistorique.'<br />
							'.$descriptionhistorique.'<br />';
					/* Affiche la date de modification de l'historique */
					if ($datemodification != '0000-00-00 00:00:00' && $datemodification != '') {
						$texte .= '
						<div class="troubletickets_echange_datemodification">
							Historique modifi par l\'intervenant le '.$datemodification.'
						</div>
						';
					}
					$texte .= '	</td>
					</tr>
				</table>
				<br />';
			$date = $historique[$i]->datehistorique;
			$date = substr($date,0,4).substr($date,5,2).substr($date,8,2).substr($date,11,5);
			$affichehistoriques[] = array($date, $texte);
		}
		//Tri les tableaux par dates
		$nbAfficheEchanges = count($afficheechanges);
		for ($i=0;$i<=$nbAfficheEchanges-1;$i++) {
			for ($k=0;$k<=$nbAfficheEchanges-1;$k++) {
				if ($k > 0) {
					if (strcmp(strtolower($afficheechanges[$k][0]), strtolower($afficheechanges[$k-1][0])) > 0) {
						$copie = $afficheechanges[$k-1];
						$afficheechanges[$k-1] = $afficheechanges[$k];
						$afficheechanges[$k] = $copie;
					}					 
				}
			}
		}
		$nbAfficheHistorique = count($affichehistoriques);
		for ($i=0;$i<=$nbAfficheHistorique-1;$i++) {
			for ($k=0;$k<=$nbAfficheHistorique-1;$k++) {
				if ($k > 0) {
					if (strcmp(strtolower($affichehistoriques[$k][0]), strtolower($affichehistoriques[$k-1][0])) > 0) {
						$copie = $affichehistoriques[$k-1];
						$affichehistoriques[$k-1] = $affichehistoriques[$k];
						$affichehistoriques[$k] = $copie;
					}					 
				}
			}
		}
		//Regroupe les donnes dans une chane
		$indexe = 0;
		$indexh = 0;
		for ($i=0;$i<=$nbAfficheEchanges+$nbAfficheHistorique-1;$i++) {
			if (isset($afficheechanges[$indexe])) {
				if (isset($affichehistoriques[$indexh])) {
					//On vrifie la date la plus rcente entre l'change et l'historique
					if (strcmp(strtolower($afficheechanges[$indexe][0]), strtolower($affichehistoriques[$indexh][0])) > 0) {
						$melangeechangeshistoriques .= $afficheechanges[$indexe][1];
						$indexe++;
					} else {
						$melangeechangeshistoriques .= $affichehistoriques[$indexh][1];
						$indexh++;
					}
				} else {
					//Il n'y a plus d'historiques, on rcupre donc les derniers echanges
					$melangeechangeshistoriques .= $afficheechanges[$indexe][1];
					$indexe++;
				}
			} else {
				//Il n'y a plus d'echanges, on rcupre donc les derniers historiques
				$melangeechangeshistoriques .= $affichehistoriques[$indexh][1];
				$indexh++;
			}
		}
		return $melangeechangeshistoriques;
	}
	
	/* Retourne en code HTML le dtail, la liste des changes et historiques du ticket classe par dates dcroissantes
	 * (contient le retour de la fonction melangeechangeshistoriques()) */
	function melangedetailechangeshistoriques() {
		$melangeechangeshistoriques = $this->melangeechangeshistoriques();
		
		/* Ajoute le dtail du ticket */
		$auteur = troubletickets_ficheannuaire($this->auteur);
		$auteurdetail = troubletickets_protegehtml($auteur['givenname'].' '.$auteur['sn']);
		$tsujetdetail = troubletickets_traduire("Subject");
		$sujetdetail = $this->titre;
		$descriptiondetail = troubletickets_protegehtml($this->description);
		$datedetail = troubletickets_formatedatetime($this->dateticket);
		$tstatutdetail = troubletickets_traduire('Statute');
		$statut = troubletickets_listestatutstickets($this->statutticket);
		$statutdetail = $statut[0]['nom'];
		$tgravitedetail = troubletickets_traduire("Severity");
		$gravite = troubletickets_listegravites($this->gravite);
		$gravitedetail = $gravite[0]['nom'];
		
		//Liste des fichiers
		$tfichiersdetail = troubletickets_traduire('Attached files');
		$fichiersdetail = $this->fichiers();
		
		$texte = '<table cellpadding="0" cellspacing="0" class="troubletickets_historiqueclientticket" width="100%">';
		$texte .= '<tr>
					<td>
						<table>
							<tr>';
		/* Affiche l'avatar */
		$compte = new TroubleTickets_CompteUtilisateur('', $this->auteur);
		$compte->charge();
		if ($compte->avatarexiste()) {
			$afficheavatar = true;
			global $babAddonUrl;
			$photoutilisateur = $babAddonUrl.'user&amp;idx=afficheavatar50&amp;idutilisateur='.$this->auteur;
		} else {
			$afficheavatar = false;
			$photoutilisateur = '';
		}
		if ($afficheavatar) {
				$texte .= '<td width="51" valign="top" style="border: black 0px solid;">
						<img src="'.$photoutilisateur.'" alt="'.$auteurdetail.'" style="border: #dedede 1px solid;">
					</td>';
		}
				$texte .= '	
						<td style="border: 0px solid #dedede;"><h3 class="troubletickets_titredetailintervenantticket">'.$auteurdetail.' | '.$datedetail.'</h3></td>
						</tr>
						</table>
						<b>'.$tstatutdetail.' :</b> '.$statutdetail.'<br />
						<b>'.$tgravitedetail.' :</b> '.$gravitedetail.'<br />
						<b>'.$tsujetdetail.' :</b> '.$sujetdetail.'<br />
						'.$descriptiondetail.'<br />';
						if (count($fichiersdetail) != 0) {
							$texte .= '<br />
							<fieldset>
							<legend><b>'.$tfichiersdetail.'</b></legend>';
							$nb = count($fichiersdetail);
							for ($k=0;$k<=$nb-1;$k++) {
								$texte .= '<a href="'.$fichiersdetail[$k]->url().'"><span class="troubletickets_champimportant">'.$fichiersdetail[$k]->nom.'</span></a> ('.troubletickets_taillefichier($fichiersdetail[$k]->chemin(), 'Ko').' Ko)';
								if ($fichiersdetail[$k]->description != '') {
									$texte .= '| '.troubletickets_protegehtml($fichiersdetail[$k]->description);
								}
								/* Teste si le fichier est une image */
								if (troubletickets_typeimage($fichiersdetail[$k]->chemin()) != '') {
									$urlimgimage = troubletickets_urltemplatesmodule().'images/png.gif';
									$tfichierimage = troubletickets_traduire('The file is a picture');
									$tvoirapercu = troubletickets_traduire('See a preview');
									global $babAddonUrl;
									$urlapercuimage = $babAddonUrl.'user&amp;idx=apercuimage&amp;idfichier='.$fichiersdetail[$k]->id;
									$texte .= '<br />
											   <img src="'.$urlimgimage.'" alt="" title="" style="position:relative;top:4px;" /> <b>'.$tfichierimage.' :</b> <a href="'.$urlapercuimage.'" target="_blank" onclick="bab_popup(this.href);return false;">'.$tvoirapercu.'</a>';
								}
								$texte .= '<br />';
							}
							$texte .= '</fieldset>';
						}
				$texte .= '	</td>
				</tr>
			</table>';	
		
		$melangeechangeshistoriques .= $texte;
		
		return $melangeechangeshistoriques;
	}

}
