<?php
/************************************************************************
 * OVIDENTIA http://www.ovidentia.org                                   *
 ************************************************************************
 * Copyright (c) 2008 by CANTICO ( http://www.cantico.fr )              *
 ************************************************************************/
include_once 'base.php';
@include_once $GLOBALS['babInstallPath'].'utilit/registerglobals.php';


//Chargement des fonctions
global $babAddonPhpPath;
global $babInstallPath;
include_once $babAddonPhpPath.'fonctionsgen.php';

//Dfinition des constantes
//Tables de donnes
define ('TROUBLETICKETS_DROITSGEST', 'troubletickets_droitsgest');
define ('TROUBLETICKETS_CONFIGURATION', 'troubletickets_configuration');
define ('TROUBLETICKETS_PROJET', 'troubletickets_projet');
define ('TROUBLETICKETS_HISTORIQUEPROJET', 'troubletickets_historiqueprojet');
define ('TROUBLETICKETS_DROITSPROJETS_CLIENTS', 'troubletickets_droitsprojets_clients');
define ('TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS', 'troubletickets_droitsprojets_lecturetickets');
define ('TROUBLETICKETS_DROITSPROJETS_INTERVENANTS', 'troubletickets_droitsprojets_intervenants');
define ('TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS', 'troubletickets_droitsprojets_mailsnouveauxtickets');
define ('TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS', 'troubletickets_droitsprojets_mailsnouveauxticketsintervenants');
define ('TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESCLIENTS', 'troubletickets_droitsprojets_mailsechangesclients');
define ('TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESINTERVENANTS', 'troubletickets_droitsprojets_mailsechangesintervenants');
define ('TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUECLIENTS', 'troubletickets_droitsprojets_mailshistoriqueclients');
define ('TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUEINTERVENANTS', 'troubletickets_droitsprojets_mailshistoriqueintervenants');
define ('TROUBLETICKETS_CLIENT', 'troubletickets_client');
define ('TROUBLETICKETS_TICKET', 'troubletickets_ticket');
define ('TROUBLETICKETS_HISTORIQUETICKET', 'troubletickets_historiqueticket');
define ('TROUBLETICKETS_ECHANGETICKET', 'troubletickets_echangeticket');
define ('TROUBLETICKETS_FICHIERECHANGETICKET', 'troubletickets_fichierechangeticket');
define ('TROUBLETICKETS_ANTIF5', 'troubletickets_antif5');
define ('TROUBLETICKETS_CONTACTANNUAIRE', 'troubletickets_contactannuaire');
define ('TROUBLETICKETS_COMPTEUTILISATEUR', 'troubletickets_compteutilisateur');
define ('TROUBLETICKETS_NIVEAUINTERVENANTS', 'troubletickets_niveauintervenants');

//Chargement des classes
include_once $babAddonPhpPath.'TroubleTickets_Client.php';
include_once $babAddonPhpPath.'TroubleTickets_Echange.php';
include_once $babAddonPhpPath.'TroubleTickets_Projet.php';
include_once $babAddonPhpPath.'TroubleTickets_Ticket.php';
include_once $babAddonPhpPath.'TroubleTickets_HistoriqueTicket.php';
include_once $babAddonPhpPath.'TroubleTickets_Fichier.php';
include_once $babAddonPhpPath.'TroubleTickets_Filtre.php';
include_once $babAddonPhpPath.'TroubleTickets_MantisConnect.php';
include_once $babAddonPhpPath.'TroubleTickets_MantisConnect_Bug.php';
include_once $babAddonPhpPath.'TroubleTickets_StatistiquesCamembert.php';
include_once $babAddonPhpPath.'TroubleTickets_ContactAnnuaire.php';
include_once $babAddonPhpPath.'TroubleTickets_Annuaire.php';
include_once $babAddonPhpPath.'TroubleTickets_CompteUtilisateur.php';
include_once $babAddonPhpPath.'TroubleTickets_NiveauIntervenants.php';
include_once $babAddonPhpPath.'TroubleTickets_Aide.php';
include_once $babAddonPhpPath.'TroubleTickets_AideChapitre.php';
include_once $babAddonPhpPath.'TroubleTickets_AideArticle.php';

//Fonctions

/* Vrifie si l'utilisateur courant est gestionnaire du module */
function troubletickets_estgestionnaire() {
	if (troubletickets_verifieacl(1, TROUBLETICKETS_DROITSGEST)) {
		return true;
	}
	return false;
}

/* Vrifie si l'utilisateur courant a au moins un des droits d'accs sur au moins un projet
 * Valeurs de $droit : clients, intervenants, lecturetickets
 */
function troubletickets_adroitsprojets($droit='', $idprojet='') {
	//Liste les projets
	$projets = array();
	if ($idprojet == '') {
		$projets = troubletickets_listeprojets();
	} else {
		$projets = troubletickets_listeprojets($idprojet);
	}
	foreach ($projets as $projet) {
		//Vrifie les droits pour chaque projet
		if ($droit != '') {
			if ($projet->alesdroits($droit)) {
				return true;
			}
		} else {
			if ($projet->alesdroits()) {
				return true;
			}
		}
	}
	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs sur le ticket en lecture
 * Vrifie les droits sur le projet ainsi que l'option 'Droits d'accs des interlocuteurs clients sur les tickets des autres auteurs'
 */
function troubletickets_adroitsAccesSurTicket_Lecture($idticket) {
	if (!is_numeric($idticket)) {
		return false;
	}
	$ticket = new TroubleTickets_Ticket($idticket);
	$res = $ticket->charge();
	if ($res !== false) {
		/* rcupre le projet */
		$projet = new TroubleTickets_Projet($ticket->projet);
		$res2 = $projet->charge();
		if ($res2 !== false) {
			/* Vrifie si l'utilisateur est intervenant ou a des droits de lecture */
			if (troubletickets_adroitsprojets('intervenants', $projet->id) || troubletickets_adroitsprojets('lecturetickets', $projet->id)) {
				return true;
			} else {
				if (troubletickets_adroitsprojets('clients', $projet->id)) {
					if ($projet->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs == 'interlocuteurpeutvoirlesticketsdesautres') {
						return true;
					} else {
						/* Ne peut voir que ses tickets */
						$idUtilisateurCourant = troubletickets_idusercourant();
						if ($ticket->auteur == $idUtilisateurCourant) {
							return true;
						}
					}
				}
			}
		}
	}

	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs sur le ticket en cration d'changes
 * Vrifie les droits sur le projet ainsi que l'option 'Droits d'accs des interlocuteurs clients sur les tickets des autres auteurs'
 */
function troubletickets_adroitsAccesSurTicket_AjoutEchange($idticket) {
	if (!is_numeric($idticket)) {
		return false;
	}
	$ticket = new TroubleTickets_Ticket($idticket);
	$res = $ticket->charge();
	if ($res !== false) {
		/* rcupre le projet */
		$projet = new TroubleTickets_Projet($ticket->projet);
		$res2 = $projet->charge();
		if ($res2 !== false) {
			/* Vrifie si l'utilisateur est intervenant ou pas */
			if (troubletickets_adroitsprojets('intervenants', $projet->id)) {
				return true;
			} else {
				if (troubletickets_adroitsprojets('lecturetickets', $projet->id)) {
					return true;
				} else {
					if (troubletickets_adroitsprojets('clients', $projet->id)) {
						if ($projet->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs == 'interlocuteurpeutvoirlesticketsdesautres') {
							return true;
						} else {
							/* Ne peut voir que ses tickets */
							$idUtilisateurCourant = troubletickets_idusercourant();
							if ($ticket->auteur == $idUtilisateurCourant) {
								return true;
							}
						}
					}
				}
			}
		}
	}

	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs sur le ticket en cration d'historiques
 * Vrifie les droits sur le projet ainsi que l'option 'Droits d'accs des interlocuteurs clients sur les tickets des autres auteurs'
 */
function troubletickets_adroitsAccesSurTicket_AjoutHistorique($idticket) {
	if (!is_numeric($idticket)) {
		return false;
	}
	$ticket = new TroubleTickets_Ticket($idticket);
	$res = $ticket->charge();
	if ($res !== false) {
		/* rcupre le projet */
		$projet = new TroubleTickets_Projet($ticket->projet);
		$res2 = $projet->charge();
		if ($res2 !== false) {
			/* Vrifie si l'utilisateur est intervenant ou pas */
			if (troubletickets_adroitsprojets('intervenants', $projet->id)) {
				return true;
			} else {
				if (troubletickets_adroitsprojets('clients', $projet->id)) {
					if ($projet->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs == 'interlocuteurpeutvoirlesticketsdesautres') {
						return true;
					} else {
						/* Ne peut voir que ses tickets */
						$idUtilisateurCourant = troubletickets_idusercourant();
						if ($ticket->auteur == $idUtilisateurCourant) {
							return true;
						}
					}
				}
			}
		}
	}

	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs sur le ticket en suppression
 */
function troubletickets_adroitsAccesSurTicket_SupprimeTicket($idticket) {
	if (!is_numeric($idticket)) {
		return false;
	}
	$ticket = new TroubleTickets_Ticket($idticket);
	$res = $ticket->charge();
	if ($res !== false) {
		/* Vrifie si l'utilisateur est intervenant ou pas */
		if (troubletickets_adroitsprojets('intervenants', $ticket->projet)) {
			return true;
		}
	}

	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs sur le ticket en dplacement
 */
function troubletickets_adroitsAccesSurTicket_DeplaceTicket($idticket) {
	if (!is_numeric($idticket)) {
		return false;
	}
	$ticket = new TroubleTickets_Ticket($idticket);
	$res = $ticket->charge();
	if ($res !== false) {
		/* Vrifie si l'utilisateur est intervenant ou pas */
		if (troubletickets_adroitsprojets('intervenants', $ticket->projet)) {
			return true;
		}
	}

	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs pour modifier un change
 */
function troubletickets_adroitsAccesSurEchange_ModifieEchange($idechange) {
	if (!is_numeric($idechange)) {
		return false;
	}
	$echange = new TroubleTickets_Echange($idechange);
	$res = $echange->charge();
	if ($res !== false) {
		/* Vrifie si l'utilisateur est intervenant ou pas */
		if (troubletickets_adroitsprojets('intervenants', $echange->projet)) {
			return true;
		}
	}

	return false;
}

/* Vrifie si l'utilisateur courant a des droits d'accs pour modifier un historique de ticket
 */
function troubletickets_adroitsAccesSurHistoriqueTicket_ModifieHistorique($idhistorique) {
	if (!is_numeric($idhistorique)) {
		return false;
	}
	$historique = new TroubleTickets_HistoriqueTicket($idhistorique);
	$res = $historique->charge();
	if ($res !== false) {
		/* Vrifie si l'utilisateur est intervenant ou pas */
		if (troubletickets_adroitsprojets('intervenants', $historique->projet)) {
			return true;
		}
	}

	return false;
}

/* Renvoie la liste de tous les projets (ne tient pas compte des droits d'accs)
 * $IDprojets contient les identifiants des projets, spars par des virgules
 */
function troubletickets_listeprojets($IDprojets='', $client='') {
	$projets = array();
	$requete = "select `id`, `nom`, `type`, `client`, `statut`, `auteur`, `notifiertouslesinterlocuteurs`, `droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs` from `".TROUBLETICKETS_PROJET."`";
	$where = false;
	if ($IDprojets != '') {
		$requete = $requete." where id in($IDprojets)";
		$where = true;
	}
	if ($client != '') {
		if ($where) {
			$requete = $requete." and client='$client'";
		} else {
			$requete = $requete." where client='$client'";
		}
	}
	$requete = $requete.' order by nom';
	$idrequete = 0;
	$erreurs = array();
	$res = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($res) != 0) {
		//Construction des objets Projet
		$nbRes = count($res);
		for ($i=0;$i<=$nbRes-1;$i++) {
			if ($res[$i]['notifiertouslesinterlocuteurs'] != 1 && $res[$i]['notifiertouslesinterlocuteurs'] != 2) {
				$res[$i]['notifiertouslesinterlocuteurs'] = 1;
			}
			$projets[] = new TroubleTickets_Projet($res[$i]['id'], $res[$i]['nom'], $res[$i]['type'], $res[$i]['client'], $res[$i]['statut'], $res[$i]['auteur'], $res[$i]['notifiertouslesinterlocuteurs'], $res[$i]['droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs']);
		}
	}
	return $projets;
}

/* Renvoie la configuration du module */
function troubletickets_configurationmodule() {
	//Recherche de la valeur enregistre dans la base
	$requete = "select `lien`, `expediteur_nom`, `expediteur_mail`, `permettre_modification_compte`, `mails_intervenants_sans_contenus` from ".TROUBLETICKETS_CONFIGURATION;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete="");
	$lien = $resultats[0]['lien'];
	$expediteur_nom = $resultats[0]['expediteur_nom'];
	$expediteur_mail = $resultats[0]['expediteur_mail'];
	$permettre_modification_compte = $resultats[0]['permettre_modification_compte'];
	$mails_intervenants_sans_contenus = $resultats[0]['mails_intervenants_sans_contenus'];
	$tab = array('lien' => $lien, 'expediteur_nom' => $expediteur_nom, 'expediteur_mail' => $expediteur_mail, 'permettre_modification_compte' => $permettre_modification_compte, 'mails_intervenants_sans_contenus' => $mails_intervenants_sans_contenus);
	return $tab;
}

/* Renvoie la liste de tous les clients */
function troubletickets_listeclients($client='') {
	$clients = array();
	$requete = "select `id`, `nom`, `description` from `".TROUBLETICKETS_CLIENT."`";
	if ($client != '') {
		$requete = $requete." where id='$client'";
	}
	$requete = $requete." order by nom";
	$idrequete = 0;
	$erreurs = array();
	$res = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($res) != 0) {
		//Construction des objets Client
		$nbRes = count($res);
		for ($i=0;$i<=$nbRes-1;$i++) {
			$clients[] = new TroubleTickets_Client($res[$i]['id'], $res[$i]['nom'], $res[$i]['description']);
		}
	}
	return $clients;
}

function troubletickets_listcategoriesclotures($categorie = '') {
	$categories = array();
	if ($categories === '') {
		$categories[] = array('id' => 0, 'nom' => troubletickets_traduire('Undifined'));
		$categories[] = array('id' => 1, 'nom' => troubletickets_traduire('Integration Bug'));
		$categories[] = array('id' => 2, 'nom' => troubletickets_traduire('Coding Bug'));
		$categories[] = array('id' => 3, 'nom' => troubletickets_traduire('Usage issue'));
		$categories[] = array('id' => 4, 'nom' => troubletickets_traduire('Enhancement'));
	}else{
		switch($categorie) {
			case '0':
				$categories[] = array('id' => 1, 'nom' => troubletickets_traduire('Undifined'));
				break;
			case '1':
				$categories[] = array('id' => 1, 'nom' => troubletickets_traduire('Integration Bug'));
				break;
			case '2':
				$categories[] = array('id' => 2, 'nom' => troubletickets_traduire('Coding Bug'));
				break;
			case '3':
				$categories[] = array('id' => 3, 'nom' => troubletickets_traduire('Usage issue'));
				break;
			case '4':
				$categories[] = array('id' => 4, 'nom' => troubletickets_traduire('Enhancement'));
				break;
		}
	}
	
	return $categories;
}

/* Renvoie la liste des gravits */
function troubletickets_listegravites($gravite='') {
	$gravites = array();
	if ($gravite == '') {
		$gravites[] = array('id' => 1, 'nom' => troubletickets_traduire('Minor'));
		$gravites[] = array('id' => 2, 'nom' => troubletickets_traduire('Blocking'));
		$gravites[] = array('id' => 3, 'nom' => troubletickets_traduire('Engrave'));
		$gravites[] = array('id' => 4, 'nom' => troubletickets_traduire('Improvement'));
	} else {
		switch($gravite) {
			case '1':
				$gravites[] = array('id' => 1, 'nom' => troubletickets_traduire('Minor'));
				break;
			case '2':
				$gravites[] = array('id' => 2, 'nom' => troubletickets_traduire('Blocking'));
				break;
			case '3':
				$gravites[] = array('id' => 3, 'nom' => troubletickets_traduire('Engrave'));
				break;
			case '4':
				$gravites[] = array('id' => 4, 'nom' => troubletickets_traduire('Improvement'));
				break;
		}
	}
	return $gravites;
}

/* Renvoie la liste des tickets (peut tenir compte des droits d'accs et des filtres)
 * $ordreobjet : id, statutticket, gravite, dateticket, datederniereoperation
 * $ordretype : asc ou desc
 * $filtrestatut : ouvert (statuts 1,2,3,4,5,6,7) ou liste des id de statuts spars par des virgules ou chaine 'aucun'
 * 				    1 : en attente de prise en compte
 * 					2 : en cours de traitement
 *					3 : demande d'informations complmentaires
 *					4 : informations complmentaires
 *					5 : demande de clture
 *					6 : demande de clture accepte
 *					7 : demande de clture refuse
 *					8 : ticket non accept
 *					9 : ticket ferm
 * $filtregravite : id gravit (1, 2, 3 ou 4) ou liste des id de statuts spars par des virgules ou chaine 'aucun'
 * 					1 : mineur
 * 					2 : bloquant
 * 					3 : grave
 * 					4 : amlioration
 * $filtrerecherchetype : titres ou descriptions
 * $filtredatemode : creation ou derniereoperation : permet de spcifier
 * $filtredatedebut / $filtredatefin : indique la priode d'analyse : les dates doivent tre au format SQL DATETIME (2008-03-03 17:12:26)
 * $tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs : option prsente dans les projets
 * !!!! Attention : cette fonction est utilise par les containers OVML : ne pas modifier les valeurs des filtres
 * !!!! Attention : toute modification dans cette fonction doit tre reporte dans la fonction troubletickets_nbtickets */
function troubletickets_listetickets($ordreobjet='', $ordretype='', $filtreprojet='', $filtreclient='', $filtrestatut='', $filtregravite='', $filtreinterlocuteur='', $filtrerecherche='', $filtrerecherchetype='', $pagecourante='', $nbticketsparpages='', $filtreniveauintervenants='', $filtredernierintervenant='', $filtredatemode='creation', $filtredatedebut='', $filtredatefin='', $tientCompteDesDroitsDAcces=true, $tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs=true, $filtrecategoriescloture='') {
	//Echappement des donnes
	troubletickets_echappesql($ordreobjet);
	troubletickets_echappesql($ordretype);
	troubletickets_echappesql($filtreprojet);
	troubletickets_echappesql($filtreclient);
	troubletickets_echappesql($filtrestatut);
	troubletickets_echappesql($filtregravite);
	troubletickets_echappesql($filtrecategoriescloture);
	troubletickets_echappesql($filtreinterlocuteur);
	troubletickets_echappesql($filtrerecherche);
	troubletickets_echappesql($filtrerecherchetype);
	troubletickets_echappesql($pagecourante);
	troubletickets_echappesql($nbticketsparpages);
	troubletickets_echappesql($filtreniveauintervenants);
	troubletickets_echappesql($filtredernierintervenant);

	/* Vrifie les donnes */
	if (!is_numeric($filtreprojet)) {
		$filtreprojet = '';
	}
	if (!is_numeric($filtreclient)) {
		$filtreclient = '';
	}
	if ($filtrestatut != 'ouvert' && $filtrestatut != 'aucun' && $filtrestatut != 'tous') {
		/* $filtrestatut contient 0, un ou plusieurs identifiants de statuts */
		$filtrestatut = explode(",", $filtrestatut);
		/* Supprime les espaces et les valeurs non numriques */
		$filtretmp = $filtrestatut;
		$nbStatuts = count($filtrestatut);
		for ($i=0;$i<=$nbStatuts-1;$i++) {
			$filtrestatut[$i] = trim($filtrestatut[$i]);
			if (is_numeric($filtrestatut[$i])) {
				$filtretmp[] = $filtrestatut[$i];
			}
		}
		$filtrestatut = $filtretmp;
		if (count($filtrestatut) == 0) {
			$filtrestatut = '';
		}
	}
	/* $filtregravite contient un ou plusieurs identifiants de gravites ou la chaine 'aucun' */
	if ($filtregravite != 'aucun' && $filtregravite != 'tous') {
		$filtregravite = explode(",", $filtregravite);
		/* Supprime les espaces et les valeurs non numriques */
		$filtretmp = $filtregravite;
		$nbGravites = count($filtregravite);
		for ($i=0;$i<=$nbGravites-1;$i++) {
			$filtregravite[$i] = trim($filtregravite[$i]);
			if (is_numeric($filtregravite[$i])) {
				$filtretmp[] = $filtregravite[$i];
			}
		}
		$filtregravite = $filtretmp;
		if (count($filtregravite) == 0) {
			$filtregravite = '';
		}
	}
	/* $filtrecategoriescloture contient un ou plusieurs identifiants de catgorie de clture ou la chaine 'aucun' */
	if ($filtrecategoriescloture != 'aucun' && $filtrecategoriescloture != 'tous') {
		$filtrecategoriescloture = explode(",", $filtrecategoriescloture);
		/* Supprime les espaces et les valeurs non numriques */
		$filtretmp = $filtrecategoriescloture;
		$nbCategories = count($filtrecategoriescloture);
		for ($i=0;$i<=$nbCategories-1;$i++) {
			$filtrecategoriescloture[$i] = trim($filtrecategoriescloture[$i]);
			if (is_numeric($filtrecategoriescloture[$i])) {
				$filtretmp[] = $filtrecategoriescloture[$i];
			}
		}
		$filtrecategoriescloture = $filtretmp;
		if (count($filtrecategoriescloture) == 0) {
			$filtrecategoriescloture = '';
		}
	}
	if (!is_numeric($filtreinterlocuteur)) {
		$filtreinterlocuteur = '';
	}
	if (!is_numeric($filtreniveauintervenants)) {
		$filtreniveauintervenants = '';
	}
	if (!is_numeric($filtredernierintervenant)) {
		$filtredernierintervenant = '';
	}

	$tickets = array();
	$requete = "select `id`, `projet`, `reference`, `auteur`, `titre`, `description`, `statutticket`, `gravite`, `dateticket`, `ticketcreeparintervenant`, `niveauintervenants`, `dernierintervenant`, `statutechange`, `datederniereoperation` from `".TROUBLETICKETS_TICKET."`";
	$projetsUtilisateur = '';
	$estUtilisateurIntervenantDansProjets = array(); /* tableau index par les IDs des projets */
	if ($tientCompteDesDroitsDAcces) {
		//Droits d'accs sur les projets
		$projets = troubletickets_listeprojets();
		$nbProjets = count($projets);
		for ($i=0;$i<=$nbProjets-1;$i++) {
			$estUtilisateurIntervenantDansProjets[$projets[$i]->id] = troubletickets_adroitsprojets('intervenants', $projets[$i]->id);
			if (troubletickets_adroitsprojets('clients', $projets[$i]->id) || $estUtilisateurIntervenantDansProjets[$projets[$i]->id] || troubletickets_adroitsprojets('lecturetickets', $projets[$i]->id)) {
				if ($projetsUtilisateur == '') {
					$projetsUtilisateur = $projets[$i]->id;
				} else {
					$projetsUtilisateur .= ','.$projets[$i]->id;
				}
			}
		}
	}

	$whereexiste = false;

	if ($tientCompteDesDroitsDAcces) {
		if ($projetsUtilisateur != '') {
			$whereexiste = true;
			$requete .= " where `projet` IN($projetsUtilisateur)";
		} else {
			/* Rsultat impossible : permet d'avoir un filtre lorsque le client n'a pas de projets */
			$whereexiste = true;
			$requete .= " where `projet` = '1' and `projet` = '2'";
		}
	}

	/*
	 * Il faut vrifier si l'option est active pour chacun des projets
	 * Le filtre est actif uniquement si l'utilisateur est un interlocuteur client !
	 * un intervenant doit continuer  voir les tickets des autres interlocuteurs
	 */
	if ($tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs) {
		$idUtilisateurCourant = troubletickets_idusercourant();
		if ($filtreprojet != '' && is_numeric($filtreprojet)) {
			$projetsTmp = troubletickets_listeprojets($filtreprojet);
		} else {
			$projetsTmp = troubletickets_listeprojets($projetsUtilisateur); /* Si $projetsUtilisateur = '', on rcupre tous les projets */
		}
		$IDProjetsAFiltrer = '';
		$IDProjetsANePasFiltrer = '';
		foreach ($projetsTmp as $projetTmp) {
			/* Vrifie que l'utilisateur n'est pas intervenant dans le projet */
			if (!isset($estUtilisateurIntervenantDansProjets[$projetTmp->id])) {
				$estUtilisateurIntervenantDansProjets[$projetTmp->id] = troubletickets_adroitsprojets('intervenants', $projetTmp->id);
			}
			if ($projetTmp->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs == 'nevoitquelesticketsdontilestauteur' && !$estUtilisateurIntervenantDansProjets[$projetTmp->id]) {
				if ($IDProjetsAFiltrer == '') {
					$IDProjetsAFiltrer = $projetTmp->id;
				} else {
					$IDProjetsAFiltrer .= ','.$projetTmp->id;
				}
			} else {
				if ($IDProjetsANePasFiltrer == '') {
					$IDProjetsANePasFiltrer = $projetTmp->id;
				} else {
					$IDProjetsANePasFiltrer .= ','.$projetTmp->id;
				}
			}
		}
		if ($whereexiste) {
			$requete .= ' and ';
		} else {
			$whereexiste = true;
			$requete .= ' where ';
		}
		if ($IDProjetsAFiltrer == '') {
			if ($IDProjetsANePasFiltrer != '') {
				$requete .= ' (`projet` in('.$IDProjetsANePasFiltrer.'))';
			}
		} else {
			if ($IDProjetsANePasFiltrer == '') {
				$requete .= ' (`projet` in('.$IDProjetsAFiltrer.') and `auteur`=\''.$idUtilisateurCourant.'\')';
			} else {
				$requete .= ' (   (`projet` in('.$IDProjetsAFiltrer.') and `auteur`=\''.$idUtilisateurCourant.'\')   OR   (`projet` in('.$IDProjetsANePasFiltrer.'))   )';
			}
		}
	}

	//Filtres
	if ($filtreprojet != '') {
		if (is_numeric($filtreprojet)) {
			if ($whereexiste) {
				$requete .= " and `projet`=$filtreprojet";
			} else {
				$requete .= " where `projet`=$filtreprojet";
				$whereexiste = true;
			}
		}
	}
	if ($filtreclient != '') {
		if (is_numeric($filtreclient)) {
			//Rcupre les interlocuteurs du client
			$client = new TroubleTickets_Client($filtreclient);
			$interlocuteursclient = $client->interlocuteurs();
			$interlocuteurs = '';
			$nbInterlocuteurs = count($interlocuteursclient);
			for ($i=0;$i<=$nbInterlocuteurs-1;$i++) {
				if ($interlocuteurs == '') {
					$interlocuteurs = $interlocuteursclient[$i]->idutilisateur;
				} else {
					$interlocuteurs = $interlocuteurs.','.$interlocuteurs = $interlocuteursclient[$i]->idutilisateur;
				}
			}
			if ($interlocuteurs != '') {
				if ($whereexiste) {
					$requete .= " and `auteur` IN($interlocuteurs)";
				} else {
					$requete .= " where `auteur` IN($interlocuteurs)";
					$whereexiste = true;
				}
			} else {
				//Rsultat impossible : permet d'avoir un filtre lorsque le client n'a pas d'interlocuteurs
				if ($whereexiste) {
					$requete .= " and `auteur`='1' and `auteur`='2'";
				} else {
					$requete .= " where `auteur`='1' and `auteur`='2'";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtrestatut !== '') { //Si vide on rcupre tous les statuts
		if (is_array($filtrestatut)) { /* Tableau contenant les identifiants de statuts */
			/* Statuts du tickets : 1,2,5,6,7,8,9     ;     3,4 sont des statuts d'changes */
			/* Recherche de statuts */
			$statuttickettrouve = false;
			$statutechangetrouve = false;
			$statutsticket = array(1,2,5,6,7,8,9);
			$statutsechange = array(3,4);
			$requetestatutsticket = '';
			$requetestatutsechange = '';
			$nbStatuts = count($filtrestatut);
			for ($i=0;$i<=$nbStatuts-1;$i++) {
				if (in_array($filtrestatut[$i], $statutsticket)) {
					/* Statut ticket */
					if (!$statuttickettrouve) {
						$statuttickettrouve = true;
						if ($whereexiste) {
							$requetestatutsticket .= " and `statutticket` IN('$filtrestatut[$i]'";
						} else {
							$requetestatutsticket .= " where `statutticket` IN('$filtrestatut[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetestatutsticket .= ",'".$filtrestatut[$i]."'";
					}
				}
				if (in_array($filtrestatut[$i], $statutsechange)) {
					/* Statut change */
					if (!$statutechangetrouve) {
						$statutechangetrouve = true;
						if ($whereexiste) {
							$requetestatutsechange .= " and `statutechange` IN('$filtrestatut[$i]'";
						} else {
							$requetestatutsechange .= " where `statutechange` IN('$filtrestatut[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetestatutsechange .= ",'".$filtrestatut[$i]."'";
					}
				}
			}
			if ($statuttickettrouve) {
				$requete .= $requetestatutsticket.')';
			}
			if ($statutechangetrouve) {
				$requete .= $requetestatutsechange.')';
			}
		} else {
			if ($filtrestatut == 'ouvert') {
				if ($whereexiste) {
					$requete .= " and `statutticket` IN('1','2','3','4','5','6','7')";
				} else {
					$requete .= " where `statutticket` IN('1','2','3','4','5','6','7')";
					$whereexiste = true;
				}
			}
			if ($filtrestatut == 'aucun') {
				if ($whereexiste) {
					$requete .= " and `statutticket` = '1' and `statutticket` = '2'";
				} else {
					$requete .= " where `statutticket` = '1' and `statutticket` = '2'";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtregravite !== '') { //Si vode on rcupre toutes les gravits
		if (is_array($filtregravite)) { /* Tableau contenant les identifiants de gravites */
			/* gravites du tickets : 1,2,3,4 */
			/* Recherche de gravites */
			$gravitetickettrouve = false;
			$gravitesticket = array(1,2,3,4);
			$requetegravitesticket = '';
			$nbGravites = count($filtregravite);
			for ($i=0;$i<=$nbGravites-1;$i++) {
				if (in_array($filtregravite[$i], $gravitesticket)) {
					/* gravite ticket */
					if (!$gravitetickettrouve) {
						$gravitetickettrouve = true;
						if ($whereexiste) {
							$requetegravitesticket .= " and `gravite` IN('$filtregravite[$i]'";
						} else {
							$requetegravitesticket .= " where `gravite` IN('$filtregravite[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetegravitesticket .= ",'".$filtregravite[$i]."'";
					}
				}
			}
			if ($gravitetickettrouve) {
				$requete .= $requetegravitesticket.')';
			}
		} else {
			if ($filtregravite == 'aucun') {
				if ($whereexiste) {
					$requete .= " and `statutgravite` = '1' and `statutgravite` = '2'";
				} else {
					$requete .= " where `statutgravite` = '1' and `statutgravite` = '2'";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtrecategoriescloture !== '') { //Si vode on rcupre toutes les catgorie de clture
		if (is_array($filtrecategoriescloture)) { /* Tableau contenant les identifiants de catgorie de clture */
			/* gravites du tickets : 0,1,2,3,4 */
			/* Recherche de catgorie de clture */
			$categoriecloturetickettrouve = false;
			$categoriecloturesticket = array(0,1,2,3,4);
			$requetecategoriecloturesticket = '';
			$nbCategories = count($filtrecategoriescloture);
			for ($i=0;$i<=$nbCategories-1;$i++) {
				if (in_array($filtrecategoriescloture[$i], $categoriecloturesticket)) {
					/* categoriecloture ticket */
					if (!$categoriecloturetickettrouve) {
						$categoriecloturetickettrouve = true;
						if ($whereexiste) {
							$requetecategoriecloturesticket .= " and `categoriecloture` IN('$filtrecategoriescloture[$i]'";
						} else {
							$requetecategoriecloturesticket .= " where `categoriecloture` IN('$filtrecategoriescloture[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetecategoriecloturesticket .= ",'".$filtrecategoriescloture[$i]."'";
					}
				}
			}
			if ($categoriecloturetickettrouve) {
				$requete .= $requetecategoriecloturesticket.')';
			}
		} else {
			if ($filtrecategoriescloture == 'aucun') {//si aucn selectionn aucun ticket ne peux tre retourn
				if ($whereexiste) {
					$requete .= " and 0 ";
				} else {
					$requete .= " where 0 ";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtreinterlocuteur != '') {
		if (is_numeric($filtreinterlocuteur)) {
			if ($whereexiste) {
				$requete .= " and `auteur`='$filtreinterlocuteur'";
			} else {
				$requete .= " where `auteur`='$filtreinterlocuteur'";
				$whereexiste = true;
			}
		}
	}
	if ($filtrerecherche != '') {
		if ($filtrerecherchetype == 'titres') {
			if ($whereexiste) {
				$requete .= " and `titre` like '%$filtrerecherche%'";
			} else {
				$requete .= " where `titre` like '%$filtrerecherche%'";
				$whereexiste = true;
			}
		}
		if ($filtrerecherchetype == 'descriptions') {
			if ($whereexiste) {
				$requete .= " and `description` like '%$filtrerecherche%'";
			} else {
				$requete .= " where `description` like '%$filtrerecherche%'";
				$whereexiste = true;
			}
		}
	}
	if ($filtreniveauintervenants != '') {
		if (is_numeric($filtreniveauintervenants)) {
			if ($whereexiste) {
				$requete .= " and `niveauintervenants`='$filtreniveauintervenants'";
			} else {
				$requete .= " where `niveauintervenants`='$filtreniveauintervenants'";
				$whereexiste = true;
			}
		}
	}
	if ($filtredernierintervenant != '') {
		if (is_numeric($filtredernierintervenant)) {
			if ($whereexiste) {
				$requete .= " and `dernierintervenant`='$filtredernierintervenant'";
			} else {
				$requete .= " where `dernierintervenant`='$filtredernierintervenant'";
				$whereexiste = true;
			}
		}
	}
	/* Filtre priode dates */
	if ($filtredatedebut != '' && $filtredatefin != '') {
		if ($filtredatemode == 'creation') {
			/* Filtre sur la date de cration du ticket */
			if ($whereexiste) {
				$requete .= " and `dateticket` >= '$filtredatedebut' and `dateticket` <= '$filtredatefin'";
			} else {
				$requete .= " where `dateticket` >= '$filtredatedebut' and `dateticket` <= '$filtredatefin'";
			}
		} else {
			/* Filtre sur la date de dernire opration du ticket */
			if ($whereexiste) {
				$requete .= " and `datederniereoperation` >= '$filtredatedebut' and `datederniereoperation` <= '$filtredatefin'";
			} else {
				$requete .= " where `datederniereoperation` >= '$filtredatedebut' and `datederniereoperation` <= '$filtredatefin'";
			}
		}
	}

	//Ordre
	if ($ordreobjet != '') {
		//Vrifie le filtre
		$filtres = array('id', 'statutticket', 'gravite', 'dateticket', 'datederniereoperation');
		if (in_array($ordreobjet, $filtres)) {
			$requete .= " order by $ordreobjet";
		} else {
			$requete .= " order by id";
		}
	} else {
		$requete .= " order by id";
	}
	if ($ordretype != '') {
		//Vrifie le filtre
		$filtres = array('asc', 'desc');
		if (in_array($ordretype, $filtres)) {
			$requete .= " $ordretype";
		} else {
			$requete .= " asc";
		}
	} else {
		$requete .= " desc";
	}

	//Multipages
	if ($nbticketsparpages != '' && $nbticketsparpages != 0) {
		if (is_numeric($pagecourante)) {
			/* Calcul de l'index */
			$index = ($nbticketsparpages * ($pagecourante - 1));
			$requete .= " limit ".$index." , ".$nbticketsparpages;
		}
	}

//	bab_debug($requete);

	$idrequete = 0;
	$erreurs = array();
	$res = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($res) != 0) {
		//Construction des objets Tickets
		$nbRes = count($res);
		for ($i=0;$i<=$nbRes-1;$i++) {
			if ($res[$i]['ticketcreeparintervenant'] == 2) {
				$res[$i]['ticketcreeparintervenant'] = true;
			} else {
				$res[$i]['ticketcreeparintervenant'] = false;
			}
			if ($res[$i]['dernierintervenant'] === 0) {
				$res[$i]['dernierintervenant'] = '';
			}
			$tickets[] = new TroubleTickets_Ticket($res[$i]['id'], $res[$i]['projet'], $res[$i]['reference'], $res[$i]['auteur'], $res[$i]['titre'], $res[$i]['description'], $res[$i]['statutticket'], $res[$i]['gravite'], $res[$i]['dateticket'], $res[$i]['ticketcreeparintervenant'], $res[$i]['niveauintervenants'], $res[$i]['dernierintervenant'], $res[$i]['statutechange'], $res[$i]['datederniereoperation']);
		}
	}
	return $tickets;
}

/* Renvoie le nombre de tickets (hors multipages) (peut tenir compte des droits d'accs et des filtres)
 * $ordretype : asc ou desc
 * $ordreobjet : id, statutticket, gravite, dateticket, datederniereoperation
 * $filtregravite : id gravit (1, 2, 3 ou 4) ou liste des id de statuts spars par des virgules ou chaine 'aucun'
 * 					1 : mineur
 * 					2 : bloquant
 * 					3 : grave
 * 					4 : amlioration
 * $filtrestatut : ouvert (statuts 1,2,3,4,5,6,7) ou liste des id de statuts spars par des virgules ou chaine 'aucun'
 * 				    1 : en attente de prise en compte
 * 					2 : en cours de traitement
 *					3 : demande d'informations complmentaires
 *					4 : informations complmentaires
 *					5 : demande de clture
 *					6 : demande de clture accepte
 *					7 : demande de clture refuse
 *					8 : ticket non accept
 *					9 : ticket ferm
 * $filtrerecherchetype : titres ou descriptions
 * $filtredatemode : creation ou derniereoperation : permet de spcifier
 * $filtredatedebut / $filtredatefin : indique la priode d'analyse : les dates doivent tre au format SQL DATETIME
 * $tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs : option prsente dans les projets
 * !!!! Attention : toute modification dans cette fonction doit tre reporte dans la fonction troubletickets_listetickets */
function troubletickets_nbtickets($ordreobjet='', $ordretype='', $filtreprojet='', $filtreclient='', $filtrestatut='', $filtregravite='', $filtreinterlocuteur='', $filtrerecherche='', $filtrerecherchetype='', $pagecourante='', $nbticketsparpages='', $filtreniveauintervenants='', $filtredernierintervenant='', $filtredatemode='', $filtredatedebut='', $filtredatefin='', $tientCompteDesDroitsDAcces=true, $tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs=true, $filtrecategoriescloture='') {
	//Echappement des donnes
	troubletickets_echappesql($ordreobjet);
	troubletickets_echappesql($ordretype);
	troubletickets_echappesql($filtreprojet);
	troubletickets_echappesql($filtreclient);
	troubletickets_echappesql($filtrestatut);
	troubletickets_echappesql($filtregravite);
	troubletickets_echappesql($filtrecategoriescloture);
	troubletickets_echappesql($filtreinterlocuteur);
	troubletickets_echappesql($filtrerecherche);
	troubletickets_echappesql($filtrerecherchetype);
	troubletickets_echappesql($pagecourante);
	troubletickets_echappesql($nbticketsparpages);
	troubletickets_echappesql($filtreniveauintervenants);
	troubletickets_echappesql($filtredernierintervenant);

	/* Vrifie les donnes */
	if (!is_numeric($filtreprojet)) {
		$filtreprojet = '';
	}
	if (!is_numeric($filtreclient)) {
		$filtreclient = '';
	}
	if ($filtrestatut != 'ouvert' && $filtrestatut != 'aucun' && $filtrestatut != 'tous') {
		/* $filtrestatut contient 0 ou un ou plusieurs identifiants de statuts */
		$filtrestatut = explode(",", $filtrestatut);
		/* Supprime les espaces et les valeurs non numriques */
		$filtretmp = $filtrestatut;
		$nbStatuts = count($filtrestatut);
		for ($i=0;$i<=$nbStatuts-1;$i++) {
			$filtrestatut[$i] = trim($filtrestatut[$i]);
			if (is_numeric($filtrestatut[$i])) {
				$filtretmp[] = $filtrestatut[$i];
			}
		}
		$filtrestatut = $filtretmp;
		if (count($filtrestatut) == 0) {
			$filtrestatut = '';
		}
	}
	/* $filtregravite contient un ou plusieurs identifiants de gravites ou la chaine aucun */
	if ($filtregravite != 'aucun' && $filtregravite != 'tous') {
		$filtregravite = explode(",", $filtregravite);
		/* Supprime les espaces et les valeurs non numriques */
		$filtretmp = $filtregravite;
		$nbGravites = count($filtregravite);
		for ($i=0;$i<=$nbGravites-1;$i++) {
			$filtregravite[$i] = trim($filtregravite[$i]);
			if (is_numeric($filtregravite[$i])) {
				$filtretmp[] = $filtregravite[$i];
			}
		}
		$filtregravite = $filtretmp;
		if (count($filtregravite) == 0) {
			$filtregravite = '';
		}
	}
	/* $filtrecategoriescloture contient un ou plusieurs identifiants de catgorie de clture ou la chaine 'aucun' */
	if ($filtrecategoriescloture != 'aucun' && $filtrecategoriescloture != 'tous') {
		$filtrecategoriescloture = explode(",", $filtrecategoriescloture);
		/* Supprime les espaces et les valeurs non numriques */
		$filtretmp = $filtrecategoriescloture;
		$nbCategories = count($filtrecategoriescloture);
		for ($i=0;$i<=$nbCategories-1;$i++) {
			$filtrecategoriescloture[$i] = trim($filtrecategoriescloture[$i]);
			if (is_numeric($filtrecategoriescloture[$i])) {
				$filtretmp[] = $filtrecategoriescloture[$i];
			}
		}
		$filtrecategoriescloture = $filtretmp;
		if (count($filtrecategoriescloture) == 0) {
			$filtrecategoriescloture = '';
		}
	}

	if (!is_numeric($filtreinterlocuteur)) {
		$filtreinterlocuteur = '';
	}
	if (!is_numeric($filtreniveauintervenants)) {
		$filtreniveauintervenants = '';
	}
	if (!is_numeric($filtredernierintervenant)) {
		$filtredernierintervenant = '';
	}

	$nbtickets = 0;

	$requete = "select `id` from `".TROUBLETICKETS_TICKET."`";
	$projetsUtilisateur = '';
	$estUtilisateurIntervenantDansProjets = array(); /* tableau index par les IDs des projets */
	if ($tientCompteDesDroitsDAcces) {
		//Droits d'accs sur les projets
		$projets = troubletickets_listeprojets();
		$nbProjets = count($projets);
		for ($i=0;$i<=$nbProjets-1;$i++) {
			$estUtilisateurIntervenantDansProjets[$projets[$i]->id] = troubletickets_adroitsprojets('intervenants', $projets[$i]->id);
			if (troubletickets_adroitsprojets('clients', $projets[$i]->id) || $estUtilisateurIntervenantDansProjets[$projets[$i]->id] || troubletickets_adroitsprojets('lecturetickets', $projets[$i]->id)) {
				if ($projetsUtilisateur == '') {
					$projetsUtilisateur = $projets[$i]->id;
				} else {
					$projetsUtilisateur .= ','.$projets[$i]->id;
				}
			}
		}
	}

	$whereexiste = false;

	if ($tientCompteDesDroitsDAcces) {
		if ($projetsUtilisateur != '') {
			$whereexiste = true;
			$requete .= " where `projet` IN($projetsUtilisateur)";
		} else {
			/* Rsultat impossible : permet d'avoir un filtre lorsque le client n'a pas de projets */
			$whereexiste = true;
			$requete .= " where `projet` = '1' and `projet` = '2'";
		}
	}

	/* Il faut vrifier si l'option est active pour chacun des projets */
	if ($tientCompteDesDroitsDAccesDesInterlocuteursSurLesTicketsDesAutresAuteurs) {
		$idUtilisateurCourant = troubletickets_idusercourant();
		if ($filtreprojet != '' && is_numeric($filtreprojet)) {
			$projetsTmp = troubletickets_listeprojets($filtreprojet);
		} else {
			$projetsTmp = troubletickets_listeprojets($projetsUtilisateur); /* Si $projetsUtilisateur = '', on rcupre tous les projets */
		}
		$IDProjetsAFiltrer = '';
		$IDProjetsANePasFiltrer = '';
		foreach ($projetsTmp as $projetTmp) {
			/* Vrifie que l'utilisateur n'est pas intervenant dans le projet */
			if (!isset($estUtilisateurIntervenantDansProjets[$projetTmp->id])) {
				$estUtilisateurIntervenantDansProjets[$projetTmp->id] = troubletickets_adroitsprojets('intervenants', $projetTmp->id);
			}
			if ($projetTmp->droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs == 'nevoitquelesticketsdontilestauteur' && !$estUtilisateurIntervenantDansProjets[$projetTmp->id]) {
				if ($IDProjetsAFiltrer == '') {
					$IDProjetsAFiltrer = $projetTmp->id;
				} else {
					$IDProjetsAFiltrer .= ','.$projetTmp->id;
				}
			} else {
				if ($IDProjetsANePasFiltrer == '') {
					$IDProjetsANePasFiltrer = $projetTmp->id;
				} else {
					$IDProjetsANePasFiltrer .= ','.$projetTmp->id;
				}
			}
		}
		if ($whereexiste) {
			$requete .= ' and ';
		} else {
			$whereexiste = true;
			$requete .= ' where ';
		}
		if ($IDProjetsAFiltrer == '') {
			if ($IDProjetsANePasFiltrer != '') {
				$requete .= ' (`projet` in('.$IDProjetsANePasFiltrer.'))';
			}
		} else {
			if ($IDProjetsANePasFiltrer == '') {
				$requete .= ' (`projet` in('.$IDProjetsAFiltrer.') and `auteur`=\''.$idUtilisateurCourant.'\')';
			} else {
				$requete .= ' (   (`projet` in('.$IDProjetsAFiltrer.') and `auteur`=\''.$idUtilisateurCourant.'\')   OR   (`projet` in('.$IDProjetsANePasFiltrer.'))   )';
			}
		}
	}

	//Filtres
	if ($filtreprojet != '') {
		if (is_numeric($filtreprojet)) {
			if ($whereexiste) {
				$requete .= " and `projet`=$filtreprojet";
			} else {
				$requete .= " where `projet`=$filtreprojet";
				$whereexiste = true;
			}
		}
	}
	if ($filtreclient != '') {
		if (is_numeric($filtreclient)) {
			//Rcupre les interlocuteurs du client
			$client = new TroubleTickets_Client($filtreclient);
			$interlocuteursclient = $client->interlocuteurs();
			$interlocuteurs = '';
			$nbInterlocuteurs = count($interlocuteursclient);
			for ($i=0;$i<=$nbInterlocuteurs-1;$i++) {
				if ($interlocuteurs == '') {
					$interlocuteurs = $interlocuteursclient[$i]->idutilisateur;
				} else {
					$interlocuteurs = $interlocuteurs.','.$interlocuteurs = $interlocuteursclient[$i]->idutilisateur;
				}
			}
			if ($interlocuteurs != '') {
				if ($whereexiste) {
					$requete .= " and `auteur` IN($interlocuteurs)";
				} else {
					$requete .= " where `auteur` IN($interlocuteurs)";
					$whereexiste = true;
				}
			} else {
				//Rsultat impossible : permet d'avoir un filtre lorsque le client n'a pas d'interlocuteurs
				if ($whereexiste) {
					$requete .= " and `auteur`='1' and `auteur`='2'";
				} else {
					$requete .= " where `auteur`='1' and `auteur`='2'";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtrestatut !== '') { //Si vide on rcupre tous les statuts
		if (is_array($filtrestatut)) { /* Tableau contenant les identifiants de statuts */
			/* Statuts du tickets : 1,2,5,6,7,8,9     ;     3,4 sont des statuts d'changes */
			/* Recherche de statuts */
			$statuttickettrouve = false;
			$statutechangetrouve = false;
			$statutsticket = array(1,2,5,6,7,8,9);
			$statutsechange = array(3,4);
			$requetestatutsticket = '';
			$requetestatutsechange = '';
			$nbStatuts = count($filtrestatut);
			for ($i=0;$i<=$nbStatuts-1;$i++) {
				if (in_array($filtrestatut[$i], $statutsticket)) {
					/* Statut ticket */
					if (!$statuttickettrouve) {
						$statuttickettrouve = true;
						if ($whereexiste) {
							$requetestatutsticket .= " and `statutticket` IN('$filtrestatut[$i]'";
						} else {
							$requetestatutsticket .= " where `statutticket` IN('$filtrestatut[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetestatutsticket .= ",'".$filtrestatut[$i]."'";
					}
				}
				if (in_array($filtrestatut[$i], $statutsechange)) {
					/* Statut change */
					if (!$statutechangetrouve) {
						$statutechangetrouve = true;
						if ($whereexiste) {
							$requetestatutsechange .= " and `statutechange` IN('$filtrestatut[$i]'";
						} else {
							$requetestatutsechange .= " where `statutechange` IN('$filtrestatut[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetestatutsechange .= ",'".$filtrestatut[$i]."'";
					}
				}
			}
			if ($statuttickettrouve) {
				$requete .= $requetestatutsticket.')';
			}
			if ($statutechangetrouve) {
				$requete .= $requetestatutsechange.')';
			}
		} else {
			if ($filtrestatut == 'ouvert') {
				if ($whereexiste) {
					$requete .= " and `statutticket` IN('1','2','3','4','5','6','7')";
				} else {
					$requete .= " where `statutticket` IN('1','2','3','4','5','6','7')";
					$whereexiste = true;
				}
			}
			if ($filtrestatut == 'aucun') {
				if ($whereexiste) {
					$requete .= " and `statutticket` = '1' and `statutticket` = '2'";
				} else {
					$requete .= " where `statutticket` = '1' and `statutticket` = '2'";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtregravite !== '') { //Si vide on rcupre toutes les gravits
		if (is_array($filtregravite)) { /* Tableau contenant les identifiants de gravites */
			/* gravites du tickets : 1,2,3,4 */
			/* Recherche de gravites */
			$gravitetickettrouve = false;
			$gravitesticket = array(1,2,3,4);
			$requetegravitesticket = '';
			$nbGravites = count($filtregravite);
			for ($i=0;$i<=$nbGravites-1;$i++) {
				if (in_array($filtregravite[$i], $gravitesticket)) {
					/* gravite ticket */
					if (!$gravitetickettrouve) {
						$gravitetickettrouve = true;
						if ($whereexiste) {
							$requetegravitesticket .= " and `gravite` IN('$filtregravite[$i]'";
						} else {
							$requetegravitesticket .= " where `gravite` IN('$filtregravite[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetegravitesticket .= ",'".$filtregravite[$i]."'";
					}
				}
			}
			if ($gravitetickettrouve) {
				$requete .= $requetegravitesticket.')';
			}
		} else {
			if ($filtregravite == 'aucun') {
				if ($whereexiste) {
					$requete .= " and `statutgravite` = '1' and `statutgravite` = '2'";
				} else {
					$requete .= " where `statutgravite` = '1' and `statutgravite` = '2'";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtrecategoriescloture !== '') { //Si vode on rcupre toutes les catgorie de clture
		if (is_array($filtrecategoriescloture)) { /* Tableau contenant les identifiants de catgorie de clture */
			/* gravites du tickets : 0,1,2,3,4 */
			/* Recherche de catgorie de clture */
			$categoriecloturetickettrouve = false;
			$categoriecloturesticket = array(0,1,2,3,4);
			$requetecategoriecloturesticket = '';
			$nbCategories = count($filtrecategoriescloture);
			for ($i=0;$i<=$nbCategories-1;$i++) {
				if (in_array($filtrecategoriescloture[$i], $categoriecloturesticket)) {
					/* categoriecloture ticket */
					if (!$categoriecloturetickettrouve) {
						$categoriecloturetickettrouve = true;
						if ($whereexiste) {
							$requetecategoriecloturesticket .= " and `categoriecloture` IN('$filtrecategoriescloture[$i]'";
						} else {
							$requetecategoriecloturesticket .= " where `categoriecloture` IN('$filtrecategoriescloture[$i]'";
							$whereexiste = true;
						}
					} else {
						$requetecategoriecloturesticket .= ",'".$filtrecategoriescloture[$i]."'";
					}
				}
			}
			if ($categoriecloturetickettrouve) {
				$requete .= $requetecategoriecloturesticket.')';
			}
		} else {
			if ($filtrecategoriescloture == 'aucun') {//si aucn selectionn aucun ticket ne peux tre retourn
				if ($whereexiste) {
					$requete .= " and 0 ";
				} else {
					$requete .= " where 0 ";
					$whereexiste = true;
				}
			}
		}
	}
	if ($filtreinterlocuteur != '') {
		if (is_numeric($filtreinterlocuteur)) {
			if ($whereexiste) {
				$requete .= " and `auteur`='$filtreinterlocuteur'";
			} else {
				$requete .= " where `auteur`='$filtreinterlocuteur'";
				$whereexiste = true;
			}
		}
	}
	if ($filtrerecherche != '') {
		if ($filtrerecherchetype == 'titres') {
			if ($whereexiste) {
				$requete .= " and `titre` like '%$filtrerecherche%'";
			} else {
				$requete .= " where `titre` like '%$filtrerecherche%'";
				$whereexiste = true;
			}
		}
		if ($filtrerecherchetype == 'descriptions') {
			if ($whereexiste) {
				$requete .= " and `description` like '%$filtrerecherche%'";
			} else {
				$requete .= " where `description` like '%$filtrerecherche%'";
				$whereexiste = true;
			}
		}
	}
	if ($filtreniveauintervenants != '') {
		if (is_numeric($filtreniveauintervenants)) {
			if ($whereexiste) {
				$requete .= " and `niveauintervenants`='$filtreniveauintervenants'";
			} else {
				$requete .= " where `niveauintervenants`='$filtreniveauintervenants'";
				$whereexiste = true;
			}
		}
	}
	if ($filtredernierintervenant != '') {
		if (is_numeric($filtredernierintervenant)) {
			if ($whereexiste) {
				$requete .= " and `dernierintervenant`='$filtredernierintervenant'";
			} else {
				$requete .= " where `dernierintervenant`='$filtredernierintervenant'";
				$whereexiste = true;
			}
		}
	}
	/* Filtre priode dates */
	if ($filtredatedebut != '' && $filtredatefin != '') {
		if ($filtredatemode == 'creation') {
			/* Filtre sur la date de cration du ticket */
			if ($whereexiste) {
				$requete .= " and `dateticket` >= '$filtredatedebut' and `dateticket` <= '$filtredatefin'";
			} else {
				$requete .= " where `dateticket` >= '$filtredatedebut' and `dateticket` <= '$filtredatefin'";
				$whereexiste = true;
			}
		} else {
			/* Filtre sur la date de dernire opration du ticket */
			if ($whereexiste) {
				$requete .= " and `datederniereoperation` >= '$filtredatedebut' and `datederniereoperation` <= '$filtredatefin'";
			} else {
				$requete .= " where `datederniereoperation` >= '$filtredatedebut' and `datederniereoperation` <= '$filtredatefin'";
				$whereexiste = true;
			}
		}
	}

	//Ordre
	if ($ordreobjet != '') {
		//Vrifie le filtre
		$filtres = array('id', 'statutticket', 'gravite', 'dateticket', 'datederniereoperation');
		if (in_array($ordreobjet, $filtres)) {
			$requete .= " order by $ordreobjet";
		} else {
			$requete .= " order by id";
		}
	} else {
		$requete .= " order by id";
	}
	if ($ordretype != '') {
		//Vrifie le filtre
		$filtres = array('asc', 'desc');
		if (in_array($ordretype, $filtres)) {
			$requete .= " $ordretype";
		} else {
			$requete .= " asc";
		}
	} else {
		$requete .= " desc";
	}

	//Multipages
	if ($nbticketsparpages != '' && $nbticketsparpages != 0) {
		if (is_numeric($pagecourante)) {
			/* Calcul de l'index */
			$index = ($nbticketsparpages * ($pagecourante - 1));
			$requete .= " limit ".$index." , ".$nbticketsparpages;
		}
	}

	$idrequete = 0;
	$erreurs = array();
	$res = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($res) != 0) {
		//Construction des objets Tickets
		$nbRes = count($res);
		for ($i=0;$i<=$nbRes-1;$i++) {
			$nbtickets++;
		}
	}
	return $nbtickets;
}

/* Renvoie la liste des statuts des tickets
   Attention : les id de statuts doivent tre diffrents de ceux des statuts echanges */
function troubletickets_listestatutstickets($statut='') {
	$statuts = array();
	if ($statut == '') {
		$statuts[] = array('id' => 1, 'nom' => troubletickets_traduire('In waiting of consideration'));
		$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
		$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
		$statuts[] = array('id' => 6, 'nom' => troubletickets_traduire('Demand of close accepted'));
		$statuts[] = array('id' => 7, 'nom' => troubletickets_traduire('Demand of close refused'));
		$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
		$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
	} else {
		switch($statut) {
			case '1':
				$statuts[] = array('id' => 1, 'nom' => troubletickets_traduire('In waiting of consideration'));
				break;
			case '2':
				$statuts[] = array('id' => 2, 'nom' => troubletickets_traduire('Under treatment'));
				break;
			case '5':
				$statuts[] = array('id' => 5, 'nom' => troubletickets_traduire('Demand of close'));
				break;
			case '6':
				$statuts[] = array('id' => 6, 'nom' => troubletickets_traduire('Demand of close accepted'));
				break;
			case '7':
				$statuts[] = array('id' => 7, 'nom' => troubletickets_traduire('Demand of close refused'));
				break;
			case '8':
				$statuts[] = array('id' => 8, 'nom' => troubletickets_traduire('Ticket non accepted'));
				break;
			case '9':
				$statuts[] = array('id' => 9, 'nom' => troubletickets_traduire('Closed ticket'));
				break;
		}
	}
	return $statuts;
}


function troubletickets_nomstatut($statutID) {
	$nom = troubletickets_listestatutstickets($statutID);
	return $nom[0]['nom'];
}
function troubletickets_nomgravite($graviteID) {
	$nom = troubletickets_listegravites($graviteID);
	return $nom[0]['nom'];
}
	
/* Retourne la couleur du ticket par rapport  son statut et le type de l'utilisateur qui le regarde
 * Couleur bleue : le ticket est en attente de rponse de l'autre entit
 * Couleur verte : le ticket est trait
 * Couleur rouge : le ticket est en attente d'une rponse de notre part
 */
function troubletickets_couleur($typeutilisateur='client', $statut, $idTicket) {
	$couleur = '#F5F5F5';
	if ($typeutilisateur == 'client') {
		switch($statut) {
			case '1': /* en attente de prise en compte */
			case '7': /* demande de clture refuse */
				$couleur = 'blue';
				break;
			case '2': /* en cours de traitement */
				$couleur = 'blue';
				$requete = "select `statutechange` from `".TROUBLETICKETS_ECHANGETICKET."` where ticket='$idTicket' order by dateechange desc";
				$idrequete = 0;
				$erreurs = array();
				$res = troubletickets_sql($requete, $erreurs, $idrequete);
				if (count($res) != 0) {
					$statutechange = $res[0]['statutechange'];
				} else {
					$statutechange = 4; /* retourne 4 (informations complmentaires) par dfaut */
				}
				/* la couleur peut tre rouge si le dernier change est en demande d'infos complmentaires */
				if ($statutechange == 3) {
					$couleur = 'red';
				}
				break;
			case '6': /* demande de clture accepte */
			case '9': /* ticket ferm */
				$couleur = 'green';
				break;
			case '5': /* demande de clture */
			case '8': /* ticket non accept */
				$couleur = 'red';
				break;
		}
	} else {
		switch($statut) {
			case '1': /* en attente de prise en compte */
			case '7': /* demande de clture refuse */
				$couleur = 'red';
				break;
			case '2': /* en cours de traitement */
				$couleur = 'orange';
				$requete = "select `statutechange` from `".TROUBLETICKETS_ECHANGETICKET."` where ticket='$idTicket' order by dateechange desc";
				$idrequete = 0;
				$erreurs = array();
				$res = troubletickets_sql($requete, $erreurs, $idrequete);
				if (count($res) != 0) {
					$statutechange = $res[0]['statutechange'];
				} else {
					$statutechange = 4; /* retourne 4 (informations complmentaires) par dfaut */
				}
				/* la couleur peut tre bleue si le dernier change est en demande d'infos complmentaires */
				if ($statutechange == 3) {
					$couleur = 'blue';
				}
				break;
			case '6': /* demande de clture accepte */
			case '9': /* ticket ferm */
				$couleur = 'green';
				break;
			case '5': /* demande de clture */
			case '8': /* ticket non accept */
				$couleur = 'blue';
				break;
		}
	}
	return $couleur;
}

/* Renvoie la liste des statuts des changes : ne tient pas compte du contexte
   Attention : les id de statuts doivent tre diffrents de ceux des statuts tickets */
function troubletickets_listestatutsechanges($statut='') {
	$statuts = array();
	if ($statut == '') {
		$statuts[] = array('id' => 3, 'nom' => troubletickets_traduire('Demand of complementary information'));
		$statuts[] = array('id' => 4, 'nom' => troubletickets_traduire('Complementary information'));
	} else {
		switch($statut) {
			case '3':
				$statuts[] = array('id' => 3, 'nom' => troubletickets_traduire('Demand of complementary information'));
				break;
			case '4':
				$statuts[] = array('id' => 4, 'nom' => troubletickets_traduire('Complementary information'));
				break;
		}
	}
	return $statuts;
}

/* Retourne les identifiants de clients dont fait partie l'utilisateur */
function troubletickets_idsclientutilisateur($idutilisateur) {
	$idsclient = array();
	$doublons = array();
	/* Liste tous les projets */
	$projets = troubletickets_listeprojets();
	/* Vrifie pour chaque projet si l'utilisateur a des droits clients */
	$nbProjets = count($projets);
	for ($i=0;$i<=$nbProjets-1;$i++) {
		if ($projets[$i]->alesdroits('clients')) {
			if (!in_array($projets[$i]->client, $doublons)) {
				$doublons[] = $projets[$i]->client;
				$idsclient[] = $projets[$i]->client;
			}
		}
	}
	return $idsclient;
}

/* Retourne les niveaux d'intervenants */
function troubletickets_niveauxintervenants() {
	$niveauxintervenants = array();
	$requete = "select `id`, `nom`, `niveauprincipal` from ".TROUBLETICKETS_NIVEAUINTERVENANTS;
	$idrequete = 0;
	$erreurs = array();
	$res = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($res) != 0) {
		//Construction des objets NiveauIntervenants
		$nbRes = count($res);
		for ($i=0;$i<=$nbRes-1;$i++) {
			if ($res[$i]['niveauprincipal'] == 2) {
				$res[$i]['niveauprincipal'] = true;
			} else {
				$res[$i]['niveauprincipal'] = false;
			}
			$niveauxintervenants[] = new TroubleTickets_NiveauIntervenants($res[$i]['id'], $res[$i]['nom'], $res[$i]['niveauprincipal']);
		}
	}
	return $niveauxintervenants;
}

/* Retourne le niveau d'intervenants principal */
function troubletickets_niveauintervenantsprincipal() {
	$requete = "select `id`, `nom`, `niveauprincipal` from `".TROUBLETICKETS_NIVEAUINTERVENANTS."` where `niveauprincipal`='2'";
	$idrequete = 0;
	$erreurs = array();
	$res = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($res) == 1) {
		//Construction de l'objet NiveauIntervenants
		$res[0]['niveauprincipal'] = true;
		return new TroubleTickets_NiveauIntervenants($res[0]['id'], $res[0]['nom'], $res[0]['niveauprincipal']);
	} else {
		return false;
	}
}

/* Retourne la liste de tous les intervenants dans les projets dont l'utilisateur courant est lui-mme intervenant
   Chaque valeur retourne est un tableau index (idutilisateur, nom, prenom, email) */
function troubletickets_listeintervenants() {
	$intervenants = array();

	$projets = troubletickets_listeprojets();
	$idutilisateurs = array(); /* empche les doublons */
	$nbProjets = count($projets);
	for ($i=0;$i<=$nbProjets-1;$i++) {
		//Vrifie les droits pour chaque projet
		if ($projets[$i]->alesdroits('intervenants')) {
			/* Rcupration des intervenants du projet */
			$contacts = $projets[$i]->contactsintervenants();
			$nbContacts = count($contacts);
			for ($j=0;$j<=$nbContacts-1;$j++) {
				if (!in_array($contacts[$j]->idutilisateur, $idutilisateurs)) {
					/* L'intervenant n'a pas encore t ajout dans la liste, on l'ajoute */
					$intervenants[] = array('idutilisateur' => $contacts[$j]->idutilisateur, 'nom' => $contacts[$j]->nom, 'prenom' => $contacts[$j]->prenom, 'email' => $contacts[$j]->email);
					$idutilisateurs[] = $contacts[$j]->idutilisateur;
				}
			}
		}
	}
	/* Tri alphabtique sur le nom */
//	$nbIntervenants = count($intervenants);
//	for ($i=0;$i<=$nbIntervenants-1;$i++) {
//		for ($k=0;$k<=$nbIntervenants-1;$k++) {
//			if ($k > 0) {
//				if (strcmp(strtolower($intervenants[$k]['nom']), strtolower($intervenants[$k-1]['nom'])) < 0) {
//					$copie = $intervenants[$k-1];
//					$intervenants[$k-1] = $intervenants[$k];
//					$intervenants[$k] = $copie;
//				}
//			}
//		}
//	}

	return $intervenants;
}

/* Recalcule la date de dernire opration des tickets (enregistre les dates dans la base de donnes) */
function troubletickets_recalculedatedederniereoperation() {
	/* Liste des tickets */
	$tickets = troubletickets_listetickets();
	foreach ($tickets as $ticket) {
		/* Listes des changes et des historiques d'un ticket (ordonnes par dates dcroissantes) */
		$echanges = $ticket->echanges();
		$historiques = $ticket->historique();
		$datederniereoperation = $ticket->dateticket; //On initialise  la date de cration du ticket
		if (count($echanges) > 0) {
			$datederniereoperation = $echanges[0]->dateechange; //On prend l'change le plus rcent
		}
		if (count($historiques) > 0) {
			//On vrifie si la date du dernier historique est plus rcente que l'autre : comparaison de timestamp
			$timestampActuel = mktime(mb_substr($datederniereoperation,11,2), mb_substr($datederniereoperation,14,2), mb_substr($datederniereoperation,17,2), mb_substr($datederniereoperation,5,2), mb_substr($datederniereoperation,8,2), mb_substr($datederniereoperation,0,4));
			$dateH = $historiques[0]->datehistorique;
			$timestampHistorique = mktime(mb_substr($dateH,11,2), mb_substr($dateH,14,2), mb_substr($dateH,17,2), mb_substr($dateH,5,2), mb_substr($dateH,8,2), mb_substr($dateH,0,4));
			if ($timestampHistorique > $timestampActuel) {
				$datederniereoperation = $historiques[0]->datehistorique;
			}
		}
		$ticket->datederniereoperation = $datederniereoperation;
		$ticket->enregistre();
	}

	global $babBody;
	$babBody->babecho('<div align="center"><b>La date de dernire opration a t recalcule pour '.count($tickets).' tickets</b></div>');
}
