<?php
/************************************************************************
 * OVIDENTIA http://www.ovidentia.org                                   *
 ************************************************************************
 * Copyright (c) 2008 by CANTICO ( http://www.cantico.fr )              *
 ************************************************************************/
include_once 'base.php';

//Chargement des fonctions
global $babAddonPhpPath;
global $babInstallPath;
include_once $babAddonPhpPath."fonctionsgen.php";
include_once $babAddonPhpPath."fonctions.php";
include_once $babInstallPath."utilit/devtools.php"; //section spcifique

//Lien en section Administrateur
function troubletickets_getAdminSectionMenus(&$url, &$text) {
	static $nbMenus=0;
	global $BAB_SESS_USERID;
	global $babAddonUrl;
	if (!$nbMenus && troubletickets_estauthentifie()) {
		$url = $babAddonUrl."admin&idx=configuration"; //index.php?tg=addon/troubletickets/admin
		$text = troubletickets_traduire("Trouble Tickets");
		$nbMenus++;
		return true;
	}
	return false;
}

//Lien en section Utilisateur
function troubletickets_getUserSectionMenus(&$url, &$text) {
	static $nbMenus=0;
	global $babAddonUrl;
	
	static $nbMenus=0;
	global $babAddonUrl;
	if (!$nbMenus && troubletickets_estauthentifie()) {
		/* Commence par vrifier la configuration pour savoir si le lien est plac en section Utilisateur */
		$res = troubletickets_configurationmodule();
		if ($res['lien'] != 2) {
			return false;
		}
		
		/* Vrifie si l'utilisateur est gestionnaire ou a des droits sur un projet
		 * Type de droits :
		 * clients : client, droits de dpots, d'echanges et droits de lecture
		 * lecturetickets : droit de lecture des tickets
		 * intervenants : intervenant, peut dposer des tickets, changer et a des droits de lecture
		 * mailsnouveauxtickets : notifi de nouveaux tickets crs par les clients
		 * mailsnouveauxticketsintervenants : notifi de nouveaux tickets crs par les intervenants
		 * mailsechangesclients : notifi des changes du client
		 * mailsechangesintervenants : notifi des changes de l'intervenant
		 */		
		if (troubletickets_estgestionnaire() || troubletickets_adroitsprojets('clients') || troubletickets_adroitsprojets('lecturetickets') || troubletickets_adroitsprojets('intervenants')) {
			$url = $babAddonUrl."user&idx=utilisateur"; //index.php?tg=addon/troubletickets/user
			$text = troubletickets_traduire("Trouble Tickets");
			$nbMenus++;
			return true;
		}
	}
	return false;
}

function troubletickets_onUserCreate( $id ) {
	return false;
}

function troubletickets_onUserDelete( $id ) {
	return false;
}

function troubletickets_onGroupCreate( $id ) {
	return false;
}

function troubletickets_onGroupDelete( $id ) {
	return false;
}

//Section spcifique du module
function troubletickets_onSectionCreate(&$title, &$content) {
	static $nbMenus=0;
	global $babAddonUrl;
	if (!$nbMenus && troubletickets_estauthentifie()) {
		/* Commence par vrifier la configuration pour savoir si le lien est plac en section Utilisateur */
		$res = troubletickets_configurationmodule();
		if ($res['lien'] != 3) {
			return false;
		}
		
		/* Vrifie si l'utilisateur est gestionnaire ou a des droits sur un projet
		 * Type de droits :
		 * clients : client, droits de dpots, d'echanges et droits de lecture
		 * lecturetickets : droit de lecture des tickets
		 * intervenants : intervenant, peut dposer des tickets, changer et a des droits de lecture
		 * mailsnouveauxtickets : notifi de nouveaux tickets crs par els clients
		 * mailsnouveauxticketsintervenants : notifi de nouveaux tickets crs par les intervenants
		 * mailsechangesclients : notifi des changes du client
		 * mailsechangesintervenants : notifi des changes de l'intervenant
		 */		
		if (troubletickets_estgestionnaire() || troubletickets_adroitsprojets('clients') || troubletickets_adroitsprojets('lecturetickets') || troubletickets_adroitsprojets('intervenants')) {
			$title = troubletickets_traduire("Trouble Tickets");
			$url = $babAddonUrl."user&idx=utilisateur"; //index.php?tg=addon/troubletickets/user
			$content = "<ul><li><a href=\"$url\">$title</a></li></ul>";
			$nbMenus++;
			return true;
		}		
	}
	return false;
}

//Installation ou mise  jour du module
function troubletickets_upgrade($version_base,$version_ini) {
	global $babBody;
	global $babUploadPath;
	$erreurs = array();
	
	//Cration du rpertoire dans le rpertoire d'upload s'il n'existe pas
	$repertoire=$babUploadPath."/addons/";
	if(!troubletickets_existerepertoire($repertoire)) {
		troubletickets_creationrepertoire($repertoire);
	}
	$repertoiremod=$repertoire."troubletickets";
	if(!troubletickets_existerepertoire($repertoiremod)) {
		troubletickets_creationrepertoire($repertoiremod);
	}

	//Cration des tables de donnes
	
	//Table troubletickets_droitsgest
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSGEST."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSGEST."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_configuration
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_CONFIGURATION."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_CONFIGURATION."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `lien` int(11) unsigned NOT NULL,
					  `expediteur_nom` varchar(255) NOT NULL,
					  `expediteur_mail` varchar(255) NOT NULL,
					  `permettre_modification_compte` int(11) unsigned NOT NULL,
					  `mails_intervenants_sans_contenus` int(11) unsigned NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ permettre_modification_compte s'il n'existe pas : version 2.5 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_CONFIGURATION."` LIKE 'permettre_modification_compte'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_CONFIGURATION."` ADD `permettre_modification_compte` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne  1 : on ne permet pas la modification des coordonnes par les utilisateurs */
		$requete = "UPDATE `".TROUBLETICKETS_CONFIGURATION."` SET `permettre_modification_compte` = '1'";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ mails_intervenants_sans_contenus s'il n'existe pas : version 4.4 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_CONFIGURATION."` LIKE 'mails_intervenants_sans_contenus'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_CONFIGURATION."` ADD `mails_intervenants_sans_contenus` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne  1 : on envoit les contenus de mails */
		$requete = "UPDATE `".TROUBLETICKETS_CONFIGURATION."` SET `mails_intervenants_sans_contenus` = '1'";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout de la configuration par dfaut si inexistante
	$requete = "select `id` from ".TROUBLETICKETS_CONFIGURATION;
	$resultats = troubletickets_sql($requete, $erreurs = array(), $idrequete='');
	if (count($resultats) == 0) {
		$requete = "insert into `".TROUBLETICKETS_CONFIGURATION."` ( `id` , `lien` , `expediteur_nom` , `expediteur_mail`, `permettre_modification_compte`, `mails_intervenants_sans_contenus` )
							  values ( '' , '1' , 'admin' , 'admin@mysite.com', '1', '1' )
							";
		$resultats = troubletickets_sql($requete, $erreurs = array(), $idrequete='');
	}
	
	//Table troubletickets_projet
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_PROJET."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_PROJET."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `nom` varchar(255) NOT NULL,
					  `type` int(11) unsigned NOT NULL,
					  `client` int(11) unsigned NOT NULL,
					  `statut` int(11) unsigned NOT NULL,
					  `auteur` int(11) unsigned NOT NULL,
					  `notifiertouslesinterlocuteurs` int(11) NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	/* Ajout de la colonne notifiertouslesinterlocuteurs en version 1.8 du module */
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_PROJET."` LIKE 'notifiertouslesinterlocuteurs'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_PROJET."` ADD `notifiertouslesinterlocuteurs` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne  1 : envoi  tous les interlocuteurs clients */
		$requete = "UPDATE `".TROUBLETICKETS_PROJET."` SET `notifiertouslesinterlocuteurs` = '1'";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	/* Ajout de la colonne droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs en version 6.2 du module */
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_PROJET."` LIKE 'droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_PROJET."` ADD `droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs` varchar(255) NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne  : envoi  tous les interlocuteurs clients */
		$requete = "UPDATE `".TROUBLETICKETS_PROJET."` SET `droitsdaccesdesinterlocuteurssurlesticketsdesautresauteurs` = 'interlocuteurpeutvoirlesticketsdesautres'";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_historiqueprojet
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_HISTORIQUEPROJET."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_HISTORIQUEPROJET."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `projet` int(11) unsigned NOT NULL,
					  `statut` int(11) unsigned NOT NULL,
					  `dateprojet` datetime default '0000-00-00 00:00:00' NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_clients
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_CLIENTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_CLIENTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_lecturetickets
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_LECTURETICKETS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_intervenants
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_INTERVENANTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_INTERVENANTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_mailsnouveauxtickets
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_mailsnouveauxticketsintervenants
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_MAILSNOUVEAUXTICKETSINTERVENANTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_mailsechangesclients
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESCLIENTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESCLIENTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_mailsechangesintervenants
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESINTERVENANTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_MAILSECHANGESINTERVENANTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_mailshistoriqueclients
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUECLIENTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUECLIENTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_droitsprojets_mailshistoriqueintervenants
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUEINTERVENANTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_DROITSPROJETS_MAILSHISTORIQUEINTERVENANTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `id_object` int(11) unsigned NOT NULL default '0',
					  `id_group` int(11) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`),
					  KEY `id_object` (`id_object`),
					  KEY `id_group` (`id_group`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_client
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_CLIENT."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_CLIENT."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `nom` varchar(255) NOT NULL,
					  `description` text NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_historiqueticket
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_HISTORIQUETICKET."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_HISTORIQUETICKET."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `ticket` int(11) unsigned NOT NULL,
					  `projet` int(11) unsigned NOT NULL,
					  `auteur` int(11) NOT NULL,
					  `statutticket` int(11) NOT NULL,
					  `description` text NOT NULL,
					  `gravite` int(11) NOT NULL,
					  `datehistorique` datetime default '0000-00-00 00:00:00' NOT NULL,
					  `type` int(11) NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ datemodification s'il n'existe pas : version 6.6 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_HISTORIQUETICKET."` LIKE 'datemodification'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_HISTORIQUETICKET."` ADD `datemodification` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_niveauintervenants : !!!!!!!! laisser la cration de la table avant la table TROUBLETICKETS_TICKET
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_NIVEAUINTERVENANTS."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_NIVEAUINTERVENANTS."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `nom` varchar(255) NOT NULL,
					  `niveauprincipal` int(11) NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du niveau 1 d'intervenants si inexistant
	$requete = "select `id` from ".TROUBLETICKETS_NIVEAUINTERVENANTS;
	$resultats = troubletickets_sql($requete, $erreurs = array(), $idrequete='');
	if (count($resultats) == 0) {
		$requete = "insert into `".TROUBLETICKETS_NIVEAUINTERVENANTS."` ( `id` , `nom` , `niveauprincipal` )
							  values ( '' , '".troubletickets_traduire('Team Support')."', '2' )
							";
		$resultats = troubletickets_sql($requete, $erreurs = array(), $idrequete='');
	}
	
	//Table troubletickets_ticket
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_TICKET."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_TICKET."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `projet` int(11) unsigned NOT NULL,
					  `reference` varchar(255) NOT NULL,
					  `auteur` int(11) NOT NULL,
					  `titre` varchar(255) NOT NULL,
					  `description` text NOT NULL,
					  `statutticket` int(11) unsigned NOT NULL,
					  `statutechange` int(11) unsigned NOT NULL,
					  `gravite` int(11) unsigned NOT NULL,
					  `dateticket` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					  `ticketcreeparintervenant` int(11) unsigned NOT NULL,
					  `niveauintervenants` int(11) unsigned NOT NULL,
					  `nomniveauintervenants` varchar(255) NOT NULL,
					  `dernierintervenant` int(11) NOT NULL,
					  `datederniereoperation` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					  `categoriecloture` int(11) unsigned DEFAULT '0' NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ ticketcreeparintervenant s'il n'existe pas : version 2.5 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_TICKET."` LIKE 'ticketcreeparintervenant'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_TICKET."` ADD `ticketcreeparintervenant` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne  1 : jusque l seuls les clients craient des tickets */
		$requete = "UPDATE `".TROUBLETICKETS_TICKET."` SET `ticketcreeparintervenant` = '1'";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ niveauintervenants s'il n'existe pas : version 3.5 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_TICKET."` LIKE 'niveauintervenants'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_TICKET."` ADD `niveauintervenants` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne  1 : jusque l seuls les clients craient des tickets */
		$requete = "UPDATE `".TROUBLETICKETS_TICKET."` SET `niveauintervenants` = '1'";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ dernierintervenant s'il n'existe pas : version 3.8 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_TICKET."` LIKE 'dernierintervenant'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_TICKET."` ADD `dernierintervenant` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne pour chaque ticket */
		$tickets = troubletickets_listetickets('', '', '', '', '', '', '', '', '', '', '', '', '', 'creation', '', '', false, false);
		for ($m=0;$m<=count($tickets)-1;$m++) {
			$dernierintervenant = $tickets[$m]->dernierintervenant();
			$tickets[$m]->dernierintervenant = $dernierintervenant;
			if ($dernierintervenant !== 0 && $dernierintervenant !== '') {
				$tickets[$m]->enregistre();
			}
		}
	}
	//Ajout du champ statutechange s'il n'existe pas : version 3.9 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_TICKET."` LIKE 'statutechange'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_TICKET."` ADD `statutechange` int(11) unsigned NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne pour chaque ticket */
		$tickets = troubletickets_listetickets('', '', '', '', '', '', '', '', '', '', '', '', '', 'creation', '', '', false, false);
		for ($m=0;$m<=count($tickets)-1;$m++) {
			$statutechange = $tickets[$m]->dernierstatutechanges();
			$tickets[$m]->statutechange = $statutechange;
			$tickets[$m]->enregistre();
		}
	}
	//Ajout du champ datederniereoperation s'il n'existe pas : version 4.1 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_TICKET."` LIKE 'datederniereoperation'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_TICKET."` ADD `datederniereoperation` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
		/* Initialise les valeurs de la colonne pour chaque ticket */
		troubletickets_recalculedatedederniereoperation();
	}
	
	//Ajout du champ categoriecloture s'il n'existe pas : version 7.4 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_TICKET."` LIKE 'categoriecloture'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_TICKET."` ADD `categoriecloture` int(11) unsigned DEFAULT '0' NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_echangeticket
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_ECHANGETICKET."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_ECHANGETICKET."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `ticket` int(11) unsigned NOT NULL,
					  `projet` int(11) unsigned NOT NULL,
					  `auteur` int(11) NOT NULL,
					  `type` int(11) NOT NULL,
					  `description` text NOT NULL,
					  `dateechange` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					  `statutechange` int(11) unsigned NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	//Ajout du champ datemodification s'il n'existe pas : version 6.6 du module
	$requete = "SHOW COLUMNS from `".TROUBLETICKETS_ECHANGETICKET."` LIKE 'datemodification'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		/* Ajoute la colonne dans la table */
		$requete = "ALTER TABLE `".TROUBLETICKETS_ECHANGETICKET."` ADD `datemodification` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_fichierechange
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_FICHIERECHANGETICKET."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_FICHIERECHANGETICKET."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `ticket` int(11) unsigned NOT NULL,
					  `projet` int(11) unsigned NOT NULL,
					  `type` int(11) unsigned NOT NULL,
					  `echange` int(11) unsigned NOT NULL,
					  `datefichier` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					  `auteur` int(11) NOT NULL,
					  `nom` varchar(255) NOT NULL,
					  `description` varchar(255) NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_antif5
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_ANTIF5."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_ANTIF5."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `valeurformulaire` varchar(255) NOT NULL,
					  `date` DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_contactannuaire
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_CONTACTANNUAIRE."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_CONTACTANNUAIRE."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `nom` varchar(255) NOT NULL,
					  `prenom` varchar(255) NOT NULL,
					  `email` varchar(255) NOT NULL,
					  `type` varchar(255) NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	//Table troubletickets_compteutilisateur
	$requete = "SHOW TABLES LIKE '".TROUBLETICKETS_COMPTEUTILISATEUR."'";
	$idrequete = 0;
	$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	if (count($resultats) == 0) {
		$requete = "CREATE TABLE `".TROUBLETICKETS_COMPTEUTILISATEUR."` (
					  `id` int(11) unsigned NOT NULL auto_increment,
					  `idutilisateur` int(11) unsigned NOT NULL,
					  `nomimageavatar` varchar(255) NOT NULL,
					  `typeimageavatar` varchar(255) NOT NULL,
					  `largeurimageavatar` int(11) unsigned NOT NULL,
					  `hauteurimageavatar` int(11) unsigned NOT NULL,
					  `mantisidentifiant` varchar(255) NOT NULL,
					  `mantismotdepasse` varchar(255) NOT NULL,
					  PRIMARY KEY  (`id`)
					)";
		$idrequete = 0;
		$resultats = troubletickets_sql($requete, $erreurs, $idrequete);
	}
	
	return true;
}

function troubletickets_onPackageAddon() {
	return true;
}

function troubletickets_onDeleteAddon() {
	return true;
}
?>
