<?php

/* Statistiques pour le gestionnaire */
function troubletickets_statistiques($donnees, $erreurs) {

	class troubletickets_statistiques
	{
		//Variables

		function troubletickets_statistiques($donnees, $erreurs) {
			global $babAddonUrl;

			$mode = $donnees['mode']; //generalites, traitement, export, frequences, support
			if ($donnees['mode'] == '') {
				if (troubletickets_valeurcookie('troubletickets_statistiques_mode') == '') {
					$mode = 'generalites';
				} else {
					$mode = troubletickets_valeurcookie('troubletickets_statistiques_mode');
				}
			}

			/* *****************************Section gauche***************************** */

			$this->tperiodeanalyse = troubletickets_traduire('Period of analysis');
			$this->tmenu = troubletickets_traduire('Menu');

			$this->urlgeneralites = $babAddonUrl.'user&amp;idx=statistiques&amp;mode=generalites';
			$this->urltraitement = $babAddonUrl.'user&amp;idx=statistiques&amp;mode=traitement';
			$this->urlexport = $babAddonUrl.'user&amp;idx=statistiques&amp;mode=export';
			$this->urlfrequences = $babAddonUrl.'user&amp;idx=statistiques&amp;mode=frequences';
			$this->urlsupport = $babAddonUrl.'user&amp;idx=statistiques&amp;mode=support';
			$this->urlevolution = $babAddonUrl.'user&amp;idx=statistiques_evolution';
			$this->tgeneralites = troubletickets_traduire('Generality');
			$this->ttraitement = troubletickets_traduire('Treatment');
			$this->texport = troubletickets_traduire('Export');
			$this->tfrequences = troubletickets_traduire('Frequencies');
			$this->tsupport = troubletickets_traduire('Contract of support');
			$this->tevolution = troubletickets_traduire('Ticket number Evolution');

			/* Affichage du calendrier : on utilise des cookies pour connatre le mode d'affichage */
			/* Jour en cours */
			$numerojourencours = date('j');
			$numeromoisencours = date('n');
			$numeroanneeencours = date('Y');

			/* Rcupration des modes par url ou cookies */
			if ($donnees['modecalendrier'] != '') {
				$modecalendrier = $donnees['modecalendrier'];
			} else {
				$modecalendrier = troubletickets_valeurcookie('troubletickets_statistiques_modecalendrier'); //pasdefiltre, anne, trimestre ou mois
			}
			if ($modecalendrier != 'anne' && $modecalendrier != 'trimestre' && $modecalendrier != 'mois' && $modecalendrier != 'pasdefiltre') {
				$modecalendrier = 'mois';
			}
			$this->modecalendrier = $modecalendrier;
			if ($donnees['annee'] != '') {
				$annee = $donnees['annee'];
			} else {
				$annee = troubletickets_valeurcookie('troubletickets_statistiques_annee');
			}
			if (!is_numeric($annee)) {
				$annee = $numeroanneeencours; //Anne en cours
			} else {
				/* L'anne doit tre comprise entre 2000 et 2050 */
				if ($annee > 2050 || $annee < 2000) {
					$annee = $numeroanneeencours; //Anne en cours
				}
			}
			if ($donnees['mois'] != '') {
				$mois = $donnees['mois'];
			} else {
				$mois = troubletickets_valeurcookie('troubletickets_statistiques_mois');
			}
			if (!is_numeric($mois)) {
				$mois = $numeromoisencours; //Mois en cours
			} else {
				$tabmois = array(1,2,3,4,5,6,7,8,9,10,11,12);
				if (!in_array($mois, $tabmois)) {
					$mois = $numeromoisencours; //Mois en cours
				}
			}
			if ($donnees['trimestre'] != '') {
				$trimestre = $donnees['trimestre'];
			} else {
				$trimestre = troubletickets_valeurcookie('troubletickets_statistiques_trimestre');
			}
			$tabtrimestre = array(1,2,3,4);
			if (!in_array($trimestre, $tabtrimestre)) {
				$trimestre = 1;
			}
			$this->numtrimestre = $trimestre;

			/* Enregistrement des cookies */
			if ($mode != 'genererexportcsv') {
				troubletickets_creecookie('troubletickets_statistiques_mode', $mode, 0);
			}
			troubletickets_creecookie('troubletickets_statistiques_modecalendrier', $modecalendrier, 0);
			troubletickets_creecookie('troubletickets_statistiques_mois', $mois, 0);
			troubletickets_creecookie('troubletickets_statistiques_annee', $annee, 0);
			troubletickets_creecookie('troubletickets_statistiques_trimestre', $trimestre, 0);

			$calendrier = troubletickets_vuecalendrier($mois, $annee);
			$this->calendrier = '<table border="0" cellpadding="2" cellspacing="0">
									<tr>
										<td align="center"><i>L</i></td>
										<td align="center"><i>M</i></td>
										<td align="center"><i>M</i></td>
										<td align="center"><i>J</i></td>
										<td align="center"><i>V</i></td>
										<td align="center"><i>S</i></td>
										<td align="center"><i>D</i></td>
									</tr>';
			$compteur = 0;
			for ($i=0;$i<=count($calendrier)-1;$i++) {
				if ($compteur == 0 && $i != 0) {
					$this->calendrier .= '</tr>
										 <tr>';
				}
				$this->calendrier .= '<td align="center">'.$calendrier[$i]['numerojour'].'</td>';
				$compteur++;
				if ($compteur > 6) {
					$compteur = 0;
				}
			}
			$this->calendrier .= '	</tr>
								 </table>';
			$this->affichercalendrier = false;
			if ($modecalendrier == 'mois') {
				$this->affichercalendrier = true;
			}

			/* Mode */
			$this->tmodeannee = troubletickets_traduire('Y');
			$this->tmodemois = troubletickets_traduire('M');
			$this->tmodetrimestre = troubletickets_traduire('T');
			$this->tmodepasdefiltre = troubletickets_traduire('X');
			$this->tannee = troubletickets_traduire('Year');
			$this->tmois = troubletickets_traduire('Month');
			$this->ttrimestre = troubletickets_traduire('Quarter');
			$this->tpasdefiltre = troubletickets_traduire('No filter');
			$this->urlmodeannee = $babAddonUrl.'user&amp;idx=statistiques&amp;modecalendrier=anne';
			$this->urlmodemois = $babAddonUrl.'user&amp;idx=statistiques&amp;modecalendrier=mois';
			$this->urlmodetrimestre = $babAddonUrl.'user&amp;idx=statistiques&amp;modecalendrier=trimestre';
			$this->urlmodepasdefiltre = $babAddonUrl.'user&amp;idx=statistiques&amp;modecalendrier=pasdefiltre';
			/* Liste des annes */
			$this->listeannees = '';
			if ($annee > 2000) {
				$anneeprecedente = $annee - 1;
				$this->listeannees .= '<a href="'.$babAddonUrl.'user&amp;idx=statistiques&amp;annee='.$anneeprecedente.'"><img src="'.troubletickets_urltemplatesmodule().'images/tab_left.gif" alt="" title="" style="position:relative;top: 4px;" /></a> ';
			}
			$this->listeannees .= '<select name="annee" onchange="forms.troubletickets_statistiques.submit()">';
			for ($i=2000;$i<=2050;$i++) {
				if ($annee == $i) {
					$this->listeannees .= '<option value="'.$i.'" selected="selected">'.$i.'</option>';
				} else {
					$this->listeannees .= '<option value="'.$i.'">'.$i.'</option>';
				}
			}
			$this->listeannees .= '</select>';
			if ($annee < 2050) {
				$anneesuivante = $annee + 1;
				$this->listeannees .= ' <a href="'.$babAddonUrl.'user&amp;idx=statistiques&amp;annee='.$anneesuivante.'"><img src="'.troubletickets_urltemplatesmodule().'images/tab_right.gif" alt="" title="" style="position:relative;top: 4px;" /></a>';
			}
			$this->afficherlisteannees = false;
			if ($modecalendrier != 'pasdefiltre') {
				$this->afficherlisteannees = true;
			}
			/* Liste des mois */
			$this->listemois = '';
			if ($mois > 1) {
				$moisprecedent = $mois - 1;
				$this->listemois .= '<a href="'.$babAddonUrl.'user&amp;idx=statistiques&amp;mois='.$moisprecedent.'"><img src="'.troubletickets_urltemplatesmodule().'images/tab_left.gif" alt="" title="" style="position:relative;top: 4px;" /></a> ';
			}
			$this->listemois .= '<select name="mois" onchange="forms.troubletickets_statistiques.submit()">';
			for ($i=1;$i<=12;$i++) {
				switch ($i) {
					case '1':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('January').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('January').'</option>';
						}
						break;
					case '2':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('February').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('February').'</option>';
						}
						break;
					case '3':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('March').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('March').'</option>';
						}
						break;
					case '4':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('April').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('April').'</option>';
						}
						break;
					case '5':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('May').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('May').'</option>';
						}
						break;
					case '6':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('June').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('June').'</option>';
						}
						break;
					case '7':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('July').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('July').'</option>';
						}
						break;
					case '8':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('August').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('August').'</option>';
						}
						break;
					case '9':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('September').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('September').'</option>';
						}
						break;
					case '10':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('October').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('October').'</option>';
						}
						break;
					case '11':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('November').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('November').'</option>';
						}
						break;
					case '12':
						if ($mois == $i) {
							$this->listemois .= '<option value="'.$i.'" selected="selected">'.troubletickets_traduire('December').'</option>';
						} else {
							$this->listemois .= '<option value="'.$i.'">'.troubletickets_traduire('December').'</option>';
						}
						break;
				}
			}
			$this->listemois .= '</select>';
			if ($mois < 12) {
				$moissuivant = $mois + 1;
				$this->listemois .= ' <a href="'.$babAddonUrl.'user&amp;idx=statistiques&amp;mois='.$moissuivant.'"><img src="'.troubletickets_urltemplatesmodule().'images/tab_right.gif" alt="" title="" style="position:relative;top: 4px;" /></a>';
			}
			$this->afficherlistemois = false;
			if ($modecalendrier == 'mois') {
				$this->afficherlistemois = true;
			}
			/* Liste des trimestres */
			$this->urltrimestre1 = $babAddonUrl.'user&amp;idx=statistiques&amp;trimestre=1';
			$this->urltrimestre2 = $babAddonUrl.'user&amp;idx=statistiques&amp;trimestre=2';
			$this->urltrimestre3 = $babAddonUrl.'user&amp;idx=statistiques&amp;trimestre=3';
			$this->urltrimestre4 = $babAddonUrl.'user&amp;idx=statistiques&amp;trimestre=4';
			/* Affichage des mois d'une anne */
			$this->moisannee = '';
			if ($modecalendrier == 'anne') {
				$this->moisannee .= '<table border="0" cellspacing="2" cellpadding="2">';
				$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('January').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('July').'</td></tr>';
				$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('February').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('August').'</td></tr>';
				$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('March').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('September').'</td></tr>';
				$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('April').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('October').'</td></tr>';
				$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('May').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('November').'</td></tr>';
				$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('June').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('December').'</td></tr>';
				$this->moisannee .= '</table>';
			}
			if ($modecalendrier == 'trimestre') {
				$this->moisannee .= '<table border="0" cellspacing="2" cellpadding="2">';
				if ($trimestre == 1) {
					$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('January').'</td><td>'.troubletickets_traduire('July').'</td></tr>';
					$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('February').'</td><td>'.troubletickets_traduire('August').'</td></tr>';
					$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('March').'</td><td>'.troubletickets_traduire('September').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('April').'</td><td>'.troubletickets_traduire('October').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('May').'</td><td>'.troubletickets_traduire('November').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('June').'</td><td>'.troubletickets_traduire('December').'</td></tr>';
				}
				if ($trimestre == 2) {
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('January').'</td><td>'.troubletickets_traduire('July').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('February').'</td><td>'.troubletickets_traduire('August').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('March').'</td><td>'.troubletickets_traduire('September').'</td></tr>';
					$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('April').'</td><td>'.troubletickets_traduire('October').'</td></tr>';
					$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('May').'</td><td>'.troubletickets_traduire('November').'</td></tr>';
					$this->moisannee .= '	<tr><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('June').'</td><td>'.troubletickets_traduire('December').'</td></tr>';
				}
				if ($trimestre == 3) {
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('January').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('July').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('February').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('August').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('March').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('September').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('April').'</td><td>'.troubletickets_traduire('October').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('May').'</td><td>'.troubletickets_traduire('November').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('June').'</td><td>'.troubletickets_traduire('December').'</td></tr>';
				}
				if ($trimestre == 4) {
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('January').'</td><td>'.troubletickets_traduire('July').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('February').'</td><td>'.troubletickets_traduire('August').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('March').'</td><td>'.troubletickets_traduire('September').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('April').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('October').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('May').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('November').'</td></tr>';
					$this->moisannee .= '	<tr><td>'.troubletickets_traduire('June').'</td><td class="troubletickets_stats_moisanneeselectionne">'.troubletickets_traduire('December').'</td></tr>';
				}
				$this->moisannee .= '</table>';
			}
			$this->affichermoisannee = false;
			if ($modecalendrier == 'anne' || $modecalendrier == 'trimestre') {
				$this->affichermoisannee = true;
			}

			/* Affichage des annes slectionnes en mode pasdefiltre */
			$this->annees = '';
			if ($modecalendrier == 'pasdefiltre') {
				/* Rcupre l'anne du premier ticket et l'anne du dernier ticket */
				$premierticket = troubletickets_listetickets('id','asc','','','','','','','',1,1,'','','','','', false, false);
				$dernierticket = troubletickets_listetickets('id','desc','','','','','','','',1,1,'','','','','', false, false);
				$anneedebut = date('Y');
				$anneefin = date('Y');
				if (count($premierticket) == 1) {
					$date = troubletickets_decomposedate($premierticket[0]->dateticket, 'sqldatetime');
					$anneedebut = $date['annee'];
				}
				if (count($dernierticket) == 1) {
					$date = troubletickets_decomposedate($dernierticket[0]->dateticket, 'sqldatetime');
					$anneefin = $date['annee'];
				}
				$this->annees .= '<table border="0" cellspacing="0" cellpadding="2">';
				$compteur = 0;
				for ($i=$anneedebut;$i<=$anneefin;$i++) {
					if ($compteur == 0) {
						$this->annees .= '<tr>';
					}
					$this->annees .= '<td class="troubletickets_stats_anneeselectionne">'.$i.'</td>';
					if ($compteur == 1) {
						$this->annees .= '</tr>';
					}
					$compteur++;
					if ($compteur > 1) {
						$compteur = 0;
					}
				}
				if ($compteur == 1) {
					$this->annees .= '<td> </td></tr>';
				}
				if ($compteur == 2) {
					$this->annees .= '</tr>';
				}
				$this->annees .= '</table>';
			}
			$this->afficherannees = false;
			if ($modecalendrier == 'pasdefiltre') {
				$this->afficherannees = true;
			}

			$this->afficherboutonok = false;
			if ($modecalendrier != 'pasdefiltre') {
				$this->afficherboutonok = true;
			}

			/* *****************************Corps***************************** */

			$this->corps = '';
			$this->aide = '';

			/* Calcul de la priode de filtre : format SQL DATETIME (2008-03-03 17:12:26) */
			$datedebut = '';
			$datefin = '';
			if ($modecalendrier == 'anne') {
				$datedebut = $annee.'-01-01 00:00:00';
				$datefin = $annee.'-12-31 23:59:59';
			}
			if ($modecalendrier == 'mois') {
				if ($mois < 10) {
					$datedebut = $annee.'-0'.$mois.'-01 00:00:00';
				} else {
					$datedebut = $annee.'-'.$mois.'-01 00:00:00';
				}
				/* Nombre de jours dans le mois */
				$timestamppremierjourdumois = mktime(12, 0, 0, $mois, 1, $annee);
				$nbjoursdanslemois = date('t', $timestamppremierjourdumois); /* de 28  31 jours */
				if ($mois < 10) {
					$datefin = $annee.'-0'.$mois.'-'.$nbjoursdanslemois.' 23:59:59';
				} else {
					$datefin = $annee.'-'.$mois.'-'.$nbjoursdanslemois.' 23:59:59';
				}
			}
			if ($modecalendrier == 'trimestre') {
				if ($trimestre == 1) {
					$datedebut = $annee.'-01-01 00:00:00';
					$datefin = $annee.'-03-31 23:59:59';
				}
				if ($trimestre == 2) {
					$datedebut = $annee.'-04-01 00:00:00';
					$datefin = $annee.'-06-30 23:59:59';
				}
				if ($trimestre == 3) {
					$datedebut = $annee.'-07-01 00:00:00';
					$datefin = $annee.'-09-30 23:59:59';
				}
				if ($trimestre == 4) {
					$datedebut = $annee.'-10-01 00:00:00';
					$datefin = $annee.'-12-31 23:59:59';
				}
			}

			if ($mode == 'generalites') {
				/* Statistiques clients et projets */

				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';

				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques sur les clients et projets</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';

				$listeprojets = troubletickets_listeprojets();
				$nbprojets = count($listeprojets);
				$this->corps .= 'Nombre total de projets : <b>'.$nbprojets.'</b><br />';

				$listeclients = troubletickets_listeclients();
				$nbclients = count($listeclients);
				$this->corps .= 'Nombre total de clients : <b>'.$nbclients.'</b><br />';

				if ($nbclients != 0) { //Division par zro
					$nbmoyenprojetsparclient = round($nbprojets / $nbclients, 2);
				} else {
					$nbmoyenprojetsparclient = 0;
				}
				$this->corps .= 'Nombre moyen de projets par client : <b>'.$nbmoyenprojetsparclient.'</b><br />';

				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				$this->corps .= '<br />';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';

				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques sur les intervenants</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';

				$nbintervenants = 0;
				$nbtotalintervenants = 0;
				$tabidintervenants = array();
				for ($i=0;$i<=count($listeprojets)-1;$i++) {
					$inter = $listeprojets[$i]->contactsintervenants();
					for ($j=0;$j<=count($inter)-1;$j++) {
						if (!in_array($inter[$j]->idutilisateur, $tabidintervenants)) {
							$nbintervenants++;
							$tabidintervenants[] = $inter[$j]->idutilisateur;
						}
					}
					$nbtotalintervenants += count($inter);
				}
				$this->corps .= 'Nombre total d\'intervenants : <b>'.$nbintervenants.'</b><br />';
				if ($nbprojets != 0) { //Division par zro
					$nbmoyenintervenantsparprojet = round($nbtotalintervenants / $nbprojets, 2);
				} else {
					$nbmoyenintervenantsparprojet = 0;
				}
				$this->corps .= 'Nombre moyen d\'intervenants par projet : <b>'.$nbmoyenintervenantsparprojet.'</b><br />';

				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				/* Statistiques tickets */

				$this->corps .= '<br />';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';

				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques sur les tickets</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';

				$listetickets = troubletickets_listetickets('','','','','','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbtickets = count($listetickets);
				$this->corps .= 'Nombre total de tickets : <b>'.$nbtickets.'</b><br />';

				$listeticketsouverts = troubletickets_listetickets('','','','','1,2,5,6,7','','','','','', '', '', '', 'creation', $datedebut, $datefin, false, false);
				$nbticketsouverts = count($listeticketsouverts);
				$this->corps .= 'Nombre de tickets ouverts : <b>'.$nbticketsouverts.'</b><br />';

				$listeticketsouvertsencloture = troubletickets_listetickets('','','','','5,6','','','','','', '', '', '', 'creation', $datedebut, $datefin, false, false);
				$nbticketsouvertsencloture = count($listeticketsouvertsencloture);
				$this->corps .= 'dont tickets ouverts en demande de clture : <b>'.$nbticketsouvertsencloture.'</b><br />';

				$nbticketsfermes = $nbtickets - $nbticketsouverts;
				$this->corps .= 'Nombre de tickets ferms : <b>'.$nbticketsfermes.'</b><br />';

				$nbticketsnonacceptetab = troubletickets_listetickets('','','','','8','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsnonaccepte = count($nbticketsnonacceptetab);

				$this->corps .= 'dont tickets non accepts : <b>'.$nbticketsnonaccepte.'</b><br />';



				/* Statistiques statuts des tickets
				 * 1 : en attente de prise en compte
				 * 2 : en cours de traitement
				 * 3 : demande d'informations complmentaires
				 * 4 : informations complmentaires
				 * 5 : demande de clture
				 * 6 : demande de clture accepte
				 * 7 : demande de clture refuse
				 * 8 : ticket non accept
				 * 9 : ticket ferm
				 */

				$nbticketsenattentetab = troubletickets_listetickets('','','','','1','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsenattente = count($nbticketsenattentetab);
				$nbticketsencourstab = troubletickets_listetickets('','','','','2','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsencours = count($nbticketsencourstab);
				$nbticketsendemandetab = troubletickets_listetickets('','','','','5','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsendemande = count($nbticketsendemandetab);
				$nbticketsendemandeaccepteetab = troubletickets_listetickets('','','','','6','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsendemandeacceptee = count($nbticketsendemandeaccepteetab);
				$nbticketsendemanderefuseetab = troubletickets_listetickets('','','','','7','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsendemanderefusee = count($nbticketsendemanderefuseetab);
				$nbticketsnonacceptetab = troubletickets_listetickets('','','','','8','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsnonaccepte = count($nbticketsnonacceptetab);
				$nbticketsfermetab = troubletickets_listetickets('','','','','9','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsferme = count($nbticketsfermetab);

				/* Image Camembert des statuts ouverts/traits/ferms */
				$this->urlimagestatutstickets = $babAddonUrl.'user&amp;idx=statistiques_imagestatutstickets&amp;nbticketsouverts='.($nbticketsouverts - $nbticketsouvertsencloture).'&amp;nbticketsfermes='.$nbticketsfermes.'&amp;nbticketstraites='.$nbticketsouvertsencloture;
				if (($nbticketsouverts - $nbticketsouvertsencloture) != 0 || $nbticketsfermes != 0 || $nbticketsouvertsencloture != 0) { //On affiche pas l'image si aucune donne
					$this->corps .= '<br />
									 <div width="100%" align="center">
										<img src="'.$this->urlimagestatutstickets.'" alt="" title="" />
									 </div>
									 <br />';
				}

				/* Image Camembert de tous les statuts (sauf tickets ferms) */
				$this->urlimagetousstatutstickets = $babAddonUrl.'user&amp;idx=statistiques_imagetousstatutstickets&amp;nbticketsenattente='.$nbticketsenattente.'&amp;nbticketsencours='.$nbticketsencours.'&amp;nbticketsendemande='.$nbticketsendemande.'&amp;nbticketsendemandeacceptee='.$nbticketsendemandeacceptee.'&amp;nbticketsendemanderefusee='.$nbticketsendemanderefusee.'&amp;nbticketsnonaccepte='.$nbticketsnonaccepte;
				if ($nbticketsenattente != 0 || $nbticketsencours != 0 || $nbticketsendemande != 0 || $nbticketsendemandeacceptee != 0 || $nbticketsendemanderefusee != 0 || $nbticketsnonaccepte != 0 || $nbticketsferme != 0) { //On affiche pas l'image si aucune donne
					$this->corps .= '<div width="100%" align="center">
										<img src="'.$this->urlimagetousstatutstickets.'" alt="" title="" />
									 </div>
									 <br />';
				}

				/* Statistiques sur la gravit
				 * 1 : mineur
				 * 2 : bloquant
				 * 3 : grave
				 * 4 : amlioration
				 */

				$nbticketsmineurtab = troubletickets_listetickets('','','','','','1','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsmineur = count($nbticketsmineurtab);
				$nbticketsbloquanttab = troubletickets_listetickets('','','','','','2','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsbloquant = count($nbticketsbloquanttab);
				$nbticketsgravetab = troubletickets_listetickets('','','','','','3','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsgrave = count($nbticketsgravetab);
				$nbticketsameliorationtab = troubletickets_listetickets('','','','','','4','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsamelioration = count($nbticketsameliorationtab);
				$nbticketsouvertsmineurtab = troubletickets_listetickets('','','','','1,2,5,6,7','1','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsouvertsmineur = count($nbticketsouvertsmineurtab);
				$nbticketsouvertsbloquanttab = troubletickets_listetickets('','','','','1,2,5,6,7','2','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsouvertsbloquant = count($nbticketsouvertsbloquanttab);
				$nbticketsouvertsgravetab = troubletickets_listetickets('','','','','1,2,5,6,7','3','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsouvertsgrave = count($nbticketsouvertsgravetab);
				$nbticketsouvertsameliorationtab = troubletickets_listetickets('','','','','1,2,5,6,7','4','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketsouvertsamelioration = count($nbticketsouvertsameliorationtab);

				/* Image Camembert des gravits */
				$this->urlimagegravitestickets = $babAddonUrl.'user&amp;idx=statistiques_imagegravitestickets&amp;nbticketsmineur='.$nbticketsmineur.'&amp;nbticketsbloquant='.$nbticketsbloquant.'&amp;nbticketsgrave='.$nbticketsgrave.'&amp;nbticketsamelioration='.$nbticketsamelioration;
				if ($nbticketsmineur != 0 || $nbticketsbloquant != 0 || $nbticketsgrave != 0 || $nbticketsamelioration != 0) { //On affiche pas l'image si aucune donne
					$this->corps .= '<div width="100%" align="center">
										<img src="'.$this->urlimagegravitestickets.'" alt="" title="" />
									 </div>
									 <br />';
				}

				/* Image Camembert des gravits sur tickets ouverts */
				$this->urlimagegravitesticketsouverts = $babAddonUrl.'user&amp;idx=statistiques_imagegravitesticketsouverts&amp;nbticketsmineur='.$nbticketsouvertsmineur.'&amp;nbticketsbloquant='.$nbticketsouvertsbloquant.'&amp;nbticketsgrave='.$nbticketsouvertsgrave.'&amp;nbticketsamelioration='.$nbticketsouvertsamelioration;
				if ($nbticketsouvertsmineur != 0 || $nbticketsouvertsbloquant != 0 || $nbticketsouvertsgrave != 0 || $nbticketsouvertsamelioration != 0) { //On affiche pas l'image si aucune donne
					$this->corps .= '<div width="100%" align="center">
										<img src="'.$this->urlimagegravitesticketsouverts.'" alt="" title="" />
									 </div>';
				}
				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				$this->corps .= '<br />';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';

				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Rpartition des tickets par client</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';

				$this->corps .= '
					<table border="1" style="border-collapse:collapse;" cellpadding="4" width="100%">
					<tr>
					<th rowspan="2" width="25%" align="center">Client</th>
					<th rowspan="2" width="15%" align="center">Tickets crs pendant la priode</th>
					<th rowspan="2" width="15%" align="center">Pourcentage du total</th>
					<th colspan="2" width="30%" align="center">Statut actuel</th>
					</tr>
					<tr>
					<th align="center">Ouverts</th>
					<th align="center">Ferms</th>
					</tr>
				';






				$listeclients = troubletickets_listeclients();
				$nbclients = count($listeclients);

// 				$listeticketstotal = troubletickets_listetickets('','','','','1,2,5,6,7,8,9','','','','','','','','','creation', $datedebut, $datefin, false, false);
// 				$nbticketstotal = count($listeticketstotal);

				$ticketsParClient = array();

				$nbticketstotal = 0;
				foreach ($listeclients as $client) {

					$ticketsclientouverts = troubletickets_listetickets('','','',$client->id,'1,2,5,6,7','','','','','','','','','creation', $datedebut, $datefin, false, false);
					$ticketsclientfermes = troubletickets_listetickets('','','',$client->id,'8,9','','','','','','','','','creation', $datedebut, $datefin, false, false);
					$nbticketsclientouverts = count($ticketsclientouverts);
					$nbticketsclientfermes = count($ticketsclientfermes);

					$nbticketsclient = $nbticketsclientouverts + $nbticketsclientfermes;

					$nbticketstotal += $nbticketsclient;

					$ticketsParClient[$client->id] = array(
						'client' => $client,
						'ouverts' => $nbticketsclientouverts,
						'fermes' => $nbticketsclientfermes,
						'total' => $nbticketsclient,
						'total_sort' => sprintf('%06d', $nbticketsclient)
					);
				}

				bab_Sort::asort($ticketsParClient, 'total_sort');

				$ticketsParClient = array_reverse($ticketsParClient, true);

				foreach ($ticketsParClient as $clientId => &$tickets) {

					$client = $tickets['client'];
					$nbticketsclientouverts = $tickets['ouverts'];
					$nbticketsclientfermes = $tickets['fermes'];
					$nbticketsclient = $tickets['total'];


					if ($nbticketstotal === 0) {
						$pourcentageclient = '-';
					} else {
						$pourcentageclient = round((100 * $nbticketsclient) / $nbticketstotal);
					}

					$tickets['pourcentage'] = $pourcentageclient;

					if ($nbticketsclient === 0) {
						$pourcentageclientouverts = '-';
						$pourcentageclientfermes = '-';
					} else {
						$pourcentageclientouverts = round((100 * $nbticketsclientouverts) / $nbticketsclient);
						$pourcentageclientfermes = round((100 * $nbticketsclientfermes) / $nbticketsclient);
					}
					$this->corps .= '
						<tr>
							<td>' . $client->nom . '</td>
							<td align="right">' . $nbticketsclient . '</td>
							<td align="right">' . $pourcentageclient . '%</td>
							<td align="right">' . $pourcentageclientouverts . '%</td>
							<td align="right">' . $pourcentageclientfermes . '%</td>
						</tr>
					';

				}

				$this->corps .= '
					</table>
				';

				/* Image Camembert repartition par client */

				if ($nbticketstotal > 0 && count($ticketsParClient) > 0) {
					$this->urlimagerepartitionparclient = $babAddonUrl.'user&amp;idx=statistiques_imagerepartitionparclient';
					foreach ($ticketsParClient as $clientId => &$tickets) {
						$this->urlimagerepartitionparclient .= '&amp;clients[' . $clientId . ']=' . $tickets['client']->nom;
						$this->urlimagerepartitionparclient .= '&amp;nb_tickets[' . $clientId . ']=' . $tickets['pourcentage'];
					}
					$this->corps .= '
						<br />
						<div width="100%" align="center">
							<img src="'.$this->urlimagerepartitionparclient.'" alt="" title="" />
						</div>
						';
				}


				$this->corps .= '</div>';
				$this->corps .= '</div>';

				/*NEW STATS*/
				
				$this->corps .= '<br />';
				
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				
				global $babDB;
				
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques des tickets ouverts (*)</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';
				/*OUVERT*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND troubletickets_ticket.statutticket IN ('1','2','7')
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvert = $arr['nb_ticket'];
				$this->corps .= 'Nombre de tickets ouverts : <b>'.$nbTicketOuvert.'</b><br />';
				
				/*OUVERT CHEZ CANTICO*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND ( troubletickets_ticket.statutticket IN ('1','7') or ( troubletickets_ticket.statutticket = 2 AND troubletickets_ticket.statutechange IN('0','4') ))
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvertCantico = $arr['nb_ticket'];
				$this->corps .= 'Nombre de tickets ouverts chez les intervenants : <b>'.$nbTicketOuvertCantico.'</b><br />';
				
				/*OUVERT CHEZ CANTICO niv1*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND troubletickets_ticket.niveauintervenants = 1
						AND ( troubletickets_ticket.statutticket IN ('1','7') or ( troubletickets_ticket.statutticket = 2 AND troubletickets_ticket.statutechange IN('0','4') ))
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvertCanticoNiv1 = $arr['nb_ticket'];
				$this->corps .= 'dont: -tickets ouverts chez niveau 1: <b>'.$nbTicketOuvertCanticoNiv1.'</b><br />';
				
				/*OUVERT CHEZ CANTICO niv2*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND troubletickets_ticket.niveauintervenants = 2
						AND ( troubletickets_ticket.statutticket IN ('1','7') or ( troubletickets_ticket.statutticket = 2 AND troubletickets_ticket.statutechange IN('0','4') ))
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvertCanticoNiv2 = $arr['nb_ticket'];
				$this->corps .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-tickets ouverts chez niveau 2: <b>'.$nbTicketOuvertCanticoNiv2.'</b><br />';
				
				/*OUVERT CHEZ CLIENT*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND troubletickets_ticket.statutticket = 2
						AND troubletickets_ticket.statutechange = 3
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvertClient = $arr['nb_ticket'];
				$this->corps .= 'Nombre de tickets ouverts chez les clients : <b>'.$nbTicketOuvertClient.'</b><br />';
				
				$this->corps .= '</div>';
				$this->corps .= '</div>';
				
				/*OUVERT SUR LA PERIODE*/
				$this->corps .= '<br />';
				
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				
				global $babDB;
				
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques sur la priode</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';
				require_once $GLOBALS['babInstallPath'] . '/utilit/dateTime.php';
				
				if(!isset($_GET['datedeb'])){
					$dateDebPeriode = new BAB_DateTime(date('Y'), date('m'), date('d'));
					if($dateDebPeriode->getDayOfWeek()>2){
						$difDay = $dateDebPeriode->getDayOfWeek()-1;
					}else{
						$difDay = $dateDebPeriode->getDayOfWeek()-1+7;
					}
					$dateDebPeriode->add(-$difDay);
				}else{
					if($_GET['datedeb'] == ''){
						$dateDebPeriode = new BAB_DateTime(2004, date('m'), date('d'));
					}else{
						$dateDebPeriode = BAB_DateTime::fromUserInput($_GET['datedeb']);
					}
				}
				
				if(!isset($_GET['datefin'])){
					$dateEndPeriode = new BAB_DateTime(date('Y'), date('m'), date('d'), 23,59,59);
					$dateEndPeriode->add((-$difDay+6));
				}else{
					if($_GET['datefin'] == ''){
						$dateEndPeriode = new BAB_DateTime(2025, date('m'), date('d'), 23,59,59);
					}else{
						$dateEndPeriode = BAB_DateTime::fromUserInput($_GET['datefin']);
						$dateEndPeriode->setTime(23, 59, 59);
					}
				}
				
				//form de priode
				$this->corps .= '<form method="GET" action="#"><input type="hidden" name="tg" value="'.$_GET['tg'].'">';
				$this->corps .= '<input type="hidden" name="idx" value="'.$_GET['idx'].'">';
				$this->corps .= '<label for="datedeb">Date de dbut:</label><input size="12" type="text" value="'.$dateDebPeriode->getDayOfMonth().'-'.$dateDebPeriode->getMonth().'-'.$dateDebPeriode->getYear().'" name="datedeb">&nbsp;&nbsp;';
				$this->corps .= '<label for="datefin">Date de fin:</label><input size="12" type="text" value="'.$dateEndPeriode->getDayOfMonth().'-'.$dateEndPeriode->getMonth().'-'.$dateEndPeriode->getYear().'" name="datefin">&nbsp;';
				$this->corps .= '<input type="submit" value="Valider" name="submit"><br /></form>';
				$this->corps .= '<table width="100%" cellpadding="4" border="1" style="border-collapse:collapse;"><tbody>';
				
				$this->corps .= '<tr style="background-color:#DDD;"><td>Statistique</td><td>Tous</td><td>Hors projets et amliorations</td></tr>';
				
				//$dateDebPeriode = date('Y-m-d');
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND dateticket > '".$dateDebPeriode->getIsoDateTime()."'
						AND dateticket < '".$dateEndPeriode->getIsoDateTime()."'";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvertPeriodeTous = $arr['nb_ticket'];
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND dateticket > '".$dateDebPeriode->getIsoDateTime()."'
						AND dateticket < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketOuvertPeriodeHPA = $arr['nb_ticket'];
				$this->corps .= '<tr>';
				$this->corps .= '<td>Nombre de tickets ouverts sur la priode</td>';
				$this->corps .= '<td align="right"><b>'.$nbTicketOuvertPeriodeTous.'</b></td>';
				$this->corps .= '<td align="right"><b>'.$nbTicketOuvertPeriodeHPA.'</b></td>';
				$this->corps .= '</tr>';
				
				/*FERMER SUR LA PERIODE*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND datederniereoperation > '".$dateDebPeriode->getIsoDateTime()."'
						AND datederniereoperation < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.statutticket IN ('5','6','9')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketFermePeriodeTous = $arr['nb_ticket'];
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND datederniereoperation > '".$dateDebPeriode->getIsoDateTime()."'
						AND datederniereoperation < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.statutticket IN ('5','6','9')
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbTicketFermePeriodeHPA = $arr['nb_ticket'];
				$this->corps .= '<tr>';
				$this->corps .= '<td>Nombre de tickets ferms ou en demande de clture sur la priode</td>';
				$this->corps .= '<td align="right"><b>'.$nbTicketFermePeriodeTous.'</b></td>';
				$this->corps .= '<td align="right"><b>'.$nbTicketFermePeriodeHPA.'</b></td>';
				$this->corps .= '</tr>';
				
				/*INTERVENTION DE CANTICO SUR LA PERIODE*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet, troubletickets_echangeticket
						WHERE troubletickets_projet.id = troubletickets_echangeticket.projet
						AND troubletickets_ticket.id = troubletickets_echangeticket.ticket
						AND troubletickets_echangeticket.type = 2
						AND dateechange > '".$dateDebPeriode->getIsoDateTime()."'
						AND dateechange < '".$dateEndPeriode->getIsoDateTime()."'";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbInterventionPeriodeTous = $arr['nb_ticket'];
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet, troubletickets_echangeticket
						WHERE troubletickets_projet.id = troubletickets_echangeticket.projet
						AND troubletickets_ticket.id = troubletickets_echangeticket.ticket
						AND troubletickets_projet.type IN ('1','2')
						AND troubletickets_echangeticket.type = 2
						AND dateechange > '".$dateDebPeriode->getIsoDateTime()."'
						AND dateechange < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbInterventionPeriodeHPA = $arr['nb_ticket'];
				$this->corps .= '<tr>';
				$this->corps .= '<td>Nombre d\'interventions du support sur la priode (**)</td>';
				$this->corps .= '<td align="right"><b>'.$nbInterventionPeriodeTous.'</b></td>';
				$this->corps .= '<td align="right"><b>'.$nbInterventionPeriodeHPA.'</b></td>';
				$this->corps .= '</tr>';
				$this->corps .= '</tr>';
				
				/*ECHANGE CLIENT SUR LA PERIODE*/
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet, troubletickets_echangeticket
						WHERE troubletickets_projet.id = troubletickets_echangeticket.projet
						AND troubletickets_ticket.id = troubletickets_echangeticket.ticket
						AND troubletickets_echangeticket.type = 1
						AND dateechange > '".$dateDebPeriode->getIsoDateTime()."'
						AND dateechange < '".$dateEndPeriode->getIsoDateTime()."'";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbEchangePeriodeTous = $arr['nb_ticket'];
				$req = "SELECT COUNT(*) as nb_ticket
						FROM troubletickets_ticket, troubletickets_projet, troubletickets_echangeticket
						WHERE troubletickets_projet.id = troubletickets_echangeticket.projet
						AND troubletickets_ticket.id = troubletickets_echangeticket.ticket
						AND troubletickets_projet.type IN ('1','2')
						AND troubletickets_echangeticket.type = 1
						AND dateechange > '".$dateDebPeriode->getIsoDateTime()."'
						AND dateechange < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.gravite IN('1','2','3')";
				$res = $babDB->db_query($req);
				$arr = $babDB->db_fetch_assoc($res);
				$nbEchangePeriodeHPA = $arr['nb_ticket'];
				$this->corps .= '<tr>';
				$this->corps .= '<td>Nombre d\'change clients sur la priode (**)</td>';
				$this->corps .= '<td align="right"><b>'.$nbEchangePeriodeTous.'</b></td>';
				$this->corps .= '<td align="right"><b>'.$nbEchangePeriodeHPA.'</b></td>';
				$this->corps .= '</tr>';
				
				/*FERMER SUR LA PERIODE par catgorie de fermetutre*/
				$req = "SELECT COUNT(troubletickets_ticket.id) as nb_ticket, categoriecloture as categoriecloture
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND datederniereoperation > '".$dateDebPeriode->getIsoDateTime()."'
						AND datederniereoperation < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.statutticket = '9'
						GROUP BY categoriecloture";
				$res = $babDB->db_query($req);
				$nbTicketByCloseCateAll = array('0'=>'0','1'=>'0','2'=>'0','3'=>'0','4'=>'0');
				while($arr = $babDB->db_fetch_assoc($res)){
					$nbTicketByCloseCateAll[$arr['categoriecloture']] = $arr['nb_ticket'];
				}
				
				$req = "SELECT COUNT(troubletickets_ticket.id) as nb_ticket, categoriecloture as categoriecloture
						FROM troubletickets_ticket, troubletickets_projet
						WHERE troubletickets_projet.id = troubletickets_ticket.projet
						AND troubletickets_projet.type IN ('1','2')
						AND datederniereoperation > '".$dateDebPeriode->getIsoDateTime()."'
						AND datederniereoperation < '".$dateEndPeriode->getIsoDateTime()."'
						AND troubletickets_ticket.statutticket  = '9'
						AND troubletickets_ticket.gravite IN('1','2','3')
						GROUP BY categoriecloture";
				$res = $babDB->db_query($req);
				while($arr = $babDB->db_fetch_assoc($res)){
					$nbTicketByCloseCateProject[$arr['categoriecloture']] = $arr['nb_ticket'];
				}
				
				foreach($nbTicketByCloseCateAll as $k => $v){
					$cat = troubletickets_listcategoriesclotures($k);
					$v2 = isset($nbTicketByCloseCateProject[$k])?$nbTicketByCloseCateProject[$k]:'0';
					$this->corps .= '<tr>';
					$this->corps .= '<td>Nombre de tickets ferms en catgorie: '.$cat['0']['nom'].'</td>';
					$this->corps .= '<td align="right"><b>'.$v.'</b></td>';
					$this->corps .= '<td align="right"><b>'.$v2.'</b></td>';
					$this->corps .= '</tr>';
				}
				
				
				$this->corps .= '</tbody></table>';
				$this->corps .= '</div>';
				$this->corps .= '</div>';
				
				/////END NEW STATS
				
				/* Aide */
				$this->aide = " La slection de la priode a pour effet d'analyser tous les tickets ouverts pendant cette priode.<br />
							   	Un ticket trait est un ticket ouvert et en demande de clture ou demande de clture accepte.<br />
							   	Un ticket ferm est un ticket au statut ferm ou non accept.<br />
								(*) Regroupent uniquement les tickets ou interventions sur les tickets qui ne sont pas des amliorations,<br />
								et qui ne sont pas sur des projets.<br />
								(**)Ne prend en compte que les informations complmentaires, les demandes d'informations et les demandes de clture.";
			
			}

			if ($mode == 'traitement') {
				/* Nombre de tickets total, ouverts et ferms */
				$listetickets = troubletickets_listetickets('','','','','','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbtickets = count($listetickets);

				$listeticketsouverts = troubletickets_listetickets('','','','','1,2,5,6,7','','','','','', '', '', '', 'creation', $datedebut, $datefin, false, false);
				$nbticketsouverts = count($listeticketsouverts);

				$listeticketsfermes = troubletickets_listetickets('','','','','8,9','','','','','', '', '', '', 'creation', $datedebut, $datefin, false, false);
				$nbticketsfermes = count($listeticketsfermes);

				/* Nombre moyen d'changes sur tous les tickets */

				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques sur les changes</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';

				$this->corps .= 'Nombre total de tickets : <b>'.$nbtickets.'</b><br />';
				$nbechanges = 0;
				for ($i=0;$i<=count($listetickets)-1;$i++) {
					$echanges = $listetickets[$i]->echanges();
					$historique = $listetickets[$i]->historique();
					$nbechanges += count($echanges);
					$nbechanges += count($historique);
				}
				if ($nbtickets != 0) { //Division par zro
					$nbmoyenechanges = round($nbechanges/$nbtickets,2);
				} else {
					$nbmoyenechanges = 0;
				}
				$this->corps .= 'Nombre total d\'changes : <b>'.$nbechanges.'</b><br />';
				$this->corps .= 'Nombre moyen d\'changes par ticket : <b>'.$nbmoyenechanges.'</b><br />';

				/* Nombre moyen d'changes sur les tickets ferms */
				$this->corps .= 'Nombre total de tickets ferms : <b>'.$nbticketsfermes.'</b><br />';
				$nbechangesfermes = 0;
				for ($i=0;$i<=count($listeticketsfermes)-1;$i++) {
					$echanges = $listeticketsfermes[$i]->echanges();
					$historique = $listeticketsfermes[$i]->historique();
					$nbechangesfermes += count($echanges);
					$nbechangesfermes += count($historique);
				}
				if ($nbticketsfermes != 0) { //Division par zro
					$nbmoyenechangesfermes = round($nbechangesfermes/$nbticketsfermes,2);
				} else {
					$nbmoyenechangesfermes = 0;
				}
				$this->corps .= 'Nombre total d\'changes sur les tickets ferms : <b>'.$nbechangesfermes.'</b><br />';
				$this->corps .= 'Nombre moyen d\'changes par ticket ferm : <b>'.$nbmoyenechangesfermes.'</b><br />';

				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				/* Temps de traitement */
				$this->corps .= '<br />';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Statistiques sur les temps de traitement</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';
				$listeticketstraites = troubletickets_listetickets('','','','','5,6,9','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketstraites = count($listeticketstraites);
				$this->corps .= 'Nombre total de tickets traits : <b>'.$nbticketstraites.'</b><br />';

				/* Calcul du temps de traitement moyen avec tickets traits, du plus court et du plus long */
				$totaltempstraitement = 0; //secondes
				for ($i=0;$i<=count($listeticketstraites)-1;$i++) {
					$datecreationsql = $listeticketstraites[$i]->dateticket;
					if ($listeticketstraites[$i]->statutticket == 5) {
						/* Le ticket est en demande de clture */
						$datecloturesql = $listeticketstraites[$i]->datederniereoperation;
					} else {
						/* On recherche dans les historiques la date de demande de clture, si on trouve pas on prend la date de fermeture */
						$historique = $listeticketstraites[$i]->historique();
						$trouve = false;
						for ($j=0;$j<=count($historique)-1;$j++) {
							if ($historique[$j]->statutticket == 5 && !$trouve) {
								$datecloturesql = $historique[$j]->datehistorique;
								$trouve = true;
							}
						}
						if (!$trouve) {
							$datecloturesql = $listeticketstraites[$i]->datederniereoperation;
						}
					}
					/* Temps de traitement */
					$temps = troubletickets_timestampdatetime($datecloturesql) - troubletickets_timestampdatetime($datecreationsql);
					$totaltempstraitement += $temps;
					if (!isset($tempstraitementlepluslong)) {
						$tempstraitementlepluslong = $temps; //secondes
						$idtickettempstraitementlepluslong = $listeticketstraites[$i]->id;
					}
					if (!isset($tempstraitementlepluscourt)) {
						$tempstraitementlepluscourt = $temps; //secondes
						$idtickettempstraitementlepluscourt = $listeticketstraites[$i]->id;
					}
					if ($temps > $tempstraitementlepluslong) {
						$tempstraitementlepluslong = $temps;
						$idtickettempstraitementlepluslong = $listeticketstraites[$i]->id;
					}
					if ($temps < $tempstraitementlepluscourt) {
						$tempstraitementlepluscourt = $temps;
						$idtickettempstraitementlepluscourt = $listeticketstraites[$i]->id;
					}
				}
				if ($nbticketstraites == 0) { //Division par zro
					$tempstmp = 0;
				} else {
					$tempstmp = round($totaltempstraitement/$nbticketstraites);
				}
				if (!isset($tempstraitementlepluslong)) {
					$tempstraitementlepluslong = 0; //secondes
					$idtickettempstraitementlepluslong = '';
				}
				if (!isset($tempstraitementlepluscourt)) {
					$tempstraitementlepluscourt = 0; //secondes
					$idtickettempstraitementlepluscourt = '';
				}
				$tempsmoyentraitement = troubletickets_formatesecondesduree($tempstmp);
				$this->corps .= 'Temps de traitement moyen d\'un ticket : <b>'.$tempsmoyentraitement['textefr'].'</b><br />';
				$tempsmoyentraitementlepluscourt = troubletickets_formatesecondesduree($tempstraitementlepluscourt);
				$this->corps .= 'Temps de traitement le plus court d\'un ticket : <b>'.$tempsmoyentraitementlepluscourt['textefr'].'</b><br />';
				if ($idtickettempstraitementlepluscourt != '') {
					$this->corps .= '&nbsp;&nbsp;&nbsp;Voir le ticket en question : <a href="'.$babAddonUrl.'user&amp;idx=detailticket&amp;idticket='.$idtickettempstraitementlepluscourt.'">Ticket '.$idtickettempstraitementlepluscourt.'</a><br />';
				}
				$tempsmoyentraitementlepluslong = troubletickets_formatesecondesduree($tempstraitementlepluslong);
				$this->corps .= 'Temps de traitement le plus long d\'un ticket : <b>'.$tempsmoyentraitementlepluslong['textefr'].'</b><br />';
				if ($idtickettempstraitementlepluslong != '') {
					$this->corps .= '&nbsp;&nbsp;&nbsp;Voir le ticket en question : <a href="'.$babAddonUrl.'user&amp;idx=detailticket&amp;idticket='.$idtickettempstraitementlepluslong.'">Ticket '.$idtickettempstraitementlepluslong.'</a><br />';
				}
				/* Calcul du temps de traitement moyen avec tickets ouverts et ferms, du plus court et du plus long */

				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				/* Aide */
				$this->aide = " La slection de la priode a pour effet d'analyser tous les tickets ouverts pendant cette priode<br />
							   	Un ticket trait est un ticket ouvert et en demande de clture ou demande de clture accepte<br />
							   	Un ticket ferm est un ticket au statut ferm ou non accept<br />
							   	Le dlai de traitement correspond  la dure qui spare la date de cration d'un ticket et sa demande de clture (sa fermeture s'il n'y a pas eu de demande).<br />";
			}

			if ($mode == 'frequences') {
				$this->corps .= '<br />';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Frquences de cration des tickets par les clients</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';
				/* Rcupre tous les clients */
				$listeclients = troubletickets_listeclients();
				$nbclients = count($listeclients);
				$this->corps .= 'Nombre total de clients : <b>'.$nbclients.'</b><br />';

				/* Total des tickets */
				$listeticketstotal = troubletickets_listetickets('','','','','','','','','','','','','','creation', $datedebut, $datefin, false, false);
				$nbticketstotal = count($listeticketstotal);
				$this->corps .= 'Nombre total de tickets : <b>'.$nbticketstotal.'</b><br />';

				/* Liste des tickets par clients */
				$this->corps .= '<br />
								 <table cellspacing="0" cellpadding="0" border="1" width="100%">';
				$this->corps .= '	<tr>
										<td width="30%"><b>Clients</b></td>
										<td><b>Pourcentages</b></td>
										<td width="30%"><b>Total</b></td>
									</tr>';
				for ($i=0;$i<=count($listeclients)-1;$i++) {
					$interlocuteursclient = $listeclients[$i]->interlocuteurs();
					$nbticketsclientouverts = 0;
					$nbticketsclientfermes = 0;
					$contenuinterlocuteurs = '';
					for ($j=0;$j<=count($interlocuteursclient)-1;$j++) {
						$ticketsouvertsinterlocuteur = troubletickets_listetickets('','','',$listeclients[$i]->id,'1,2,5,6,7','',$interlocuteursclient[$j]->idutilisateur,'','','','','','','creation', $datedebut, $datefin, false, false);
						$ticketsfermesinterlocuteur = troubletickets_listetickets('','','',$listeclients[$i]->id,'8,9','',$interlocuteursclient[$j]->idutilisateur,'','','','','','','creation', $datedebut, $datefin, false, false);
						$nbticketsinterlocuteurouverts = count($ticketsouvertsinterlocuteur);
						$nbticketsinterlocuteurfermes = count($ticketsfermesinterlocuteur);
						$nbticketsclientouverts += count($ticketsouvertsinterlocuteur);
						$nbticketsclientfermes += count($ticketsfermesinterlocuteur);
						if (($nbticketsinterlocuteurouverts+$nbticketsinterlocuteurfermes) == 0) {
							$pourcentageinterlocuteur = 0;
						} else {
							if ($nbticketstotal != 0) { //Division par zro
								$pourcentageinterlocuteur = round((($nbticketsinterlocuteurouverts+$nbticketsinterlocuteurfermes)*100)/$nbticketstotal);
							} else {
								$pourcentageinterlocuteur = 0;
							}
						}
						$contenuinterlocuteurs .= '<tr>
													<td style="border-top: none;border-bottom: none;">&nbsp;&nbsp;'.$interlocuteursclient[$j]->nom().' '.$interlocuteursclient[$j]->prenom().'</td>
												  	<td style="border-top: none;border-bottom: none;">
												  		<table width="'.$pourcentageinterlocuteur.'%" cellspacing="0" cellpadding="0">
															<tr width="100%">
																<td width="100%" bgcolor="teal" height="15">

																</td>
															</tr>
														</table>
												  	</td>
												  	<td style="border-top: none;border-bottom: none;">
												  		'.($nbticketsinterlocuteurouverts+$nbticketsinterlocuteurfermes).' tickets
												  	</td>
												  </tr>';
					}
					if ($nbticketsclientouverts == 0) {
						$pourcentageclientouverts = 0;
					} else {
						if ($nbticketstotal != 0) { //Division par zro
							$pourcentageclientouverts = round(($nbticketsclientouverts*100)/$nbticketstotal);
						} else {
							$pourcentageclientouverts = 0;
						}
					}
					if ($nbticketsclientfermes == 0) {
						$pourcentageclientfermes = 0;
					} else {
						$pourcentageclientfermes = round(($nbticketsclientfermes*100)/$nbticketstotal);
					}
					if (($pourcentageclientfermes+$pourcentageclientouverts) == 0) { //Division par zro
						$tmp1 = 0;
						$tmp2 = 0;
					} else {
						$tmp1 = round($pourcentageclientfermes / ($pourcentageclientfermes+$pourcentageclientouverts) * 100);
						$tmp2 = round($pourcentageclientouverts / ($pourcentageclientouverts+$pourcentageclientfermes) * 100);
					}

					$this->corps .= '<tr>
										<td>'.$listeclients[$i]->nom.'</td>
										<td>
											<table width="'.($pourcentageclientfermes+$pourcentageclientouverts).'%" cellspacing="0" cellpadding="0">
												<tr width="100%">
													<td width="'.$tmp1.'%" bgcolor="maroon" height="15">

													</td>
													<td width="'.$tmp2.'%" bgcolor="green" height="15">

													</td>
												</tr>
											</table>
										</td>';
					$this->corps .= '	<td><span style="color: maroon;">'.$nbticketsclientfermes.' tickets ferms</span> et <span style="color: green;">'.$nbticketsclientouverts.' tickets ouverts</span></td>';
					$this->corps .= $contenuinterlocuteurs;
				}
				$this->corps .= '</table>';

				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				/* Aide */
				$this->aide = "La slection de la priode a pour effet d'analyser tous les tickets ouverts pendant cette priode<br />
							   	Un ticket trait est un ticket ouvert et en demande de clture ou demande de clture accepte<br />
							   	Un ticket ferm est un ticket au statut ferm ou non accept<br />";
			}

			if ($mode == 'export') {
				$this->corps .= '<script type="text/javascript">
					<!--

					/* Fonction qui sauvegarde un cookie
					   Si expiration n\'existe pas, le cookie ne fonctionne que pendant la session sur le site
					   Pour supprimer un cookie, il faut mettre expiration  0
					   Exemple : troubletickets_savecookie("count", 10, (new Date(2010, 12).getTime())); */
					function troubletickets_savecookie(nom, valeur, expiration) {
						if (expiration != undefined && expiration != "") {
							var timestamp = new Date(expiration);
							document.cookie = nom + "=" + escape(valeur) + "; expires=" + timestamp.toGMTString();
						} else {
							document.cookie = nom + "=" + escape(valeur) + "; expires=";
						}
					}

					/* Fonction qui rcupre les donnes d\'un cookie
					   Renvoie undefined si le cookie n\'est pas dfini */
					function troubletickets_recupcookie(nom) {
						var cookies = document.cookie.split(/;/);
						for(var i=0;i<=cookies.length - 1;i++) {
							var cook = cookies[i].split(/=/);
							//Suppression des espaces avant et aprs le nom du cookie
							cook[0] = cook[0].replace(/(^\s*)|(\s*$)/g,"");
							if (cook[0] == nom) {
								return unescape(cook[1]);
							}
						}
						return "";
					}

					/* Affiche ou cache les filtres */
					function troubletickets_stats_affichecachefiltres() {
						if (jQuery("#troubletickets_stats_tablefiltres").css("display") == "none") {
							jQuery("#troubletickets_stats_tablefiltres").show();
							jQuery("#troubletickets_stats_tablefiltres").attr("width", "100%");
							troubletickets_savecookie(\'troubletickets_stats_affichefiltres\', 1);
						} else {
							jQuery("#troubletickets_stats_tablefiltres").hide();
							jQuery("#troubletickets_stats_tablefiltres").attr("width", "100%");
							troubletickets_savecookie(\'troubletickets_stats_affichefiltres\', 0);
						}
					}

					// -->
					</script>
					';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Export des donnes au format CSV</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';

				/* Affichage des filtres */
				$this->corps .= '<table align="center" cellpadding="0" cellspacing="0">
									<tr valign="top">
										<td width="6" class="troubletickets_stats_blocfiltres-gauche"> </td>
										<td class="troubletickets_stats_blocfiltres-fond">
											<a href="#" onclick="troubletickets_stats_affichecachefiltres();return false;">'.troubletickets_traduire('Manage filters').'</a>
										</td>
										<td width="6" class="troubletickets_stats_blocfiltres-droite"> </td>
									</tr>
								 </table>
								 <table width="100%" cellpadding="5" cellspacing="0" border="1" class="troubletickets_tableblancfondnoir" id="troubletickets_stats_tablefiltres">
									<tr valign="top">
										<td width="20%">';
				/* Titres colonne gauche */
				$menu = troubletickets_valeurcookie('troubletickets_export_menu');
				if ($menu != 'statutsgravites' && $menu != 'clientsprojets') {
					$menu = 'statutsgravites';
				}
				troubletickets_creecookie('troubletickets_export_menu', $menu, 0);

				if ($menu == 'statutsgravites') {
					$this->corps .= '<div><a href="#" onclick="troubletickets_export_affichecolonnedroite(this, \'statutsgravites\');return false;" class="troubletickets_export_menuselectionne">'.troubletickets_traduire('Statutes and gravities').'</a></div>';
				} else {
					$this->corps .= '<div><a href="#" onclick="troubletickets_export_affichecolonnedroite(this, \'statutsgravites\');return false;" class="troubletickets_export_menunonselectionne">'.troubletickets_traduire('Statutes and gravities').'</a></div>';
				}
				if ($menu == 'clientsprojets') {
					$this->corps .= '<div><a href="#" onclick="troubletickets_export_affichecolonnedroite(this, \'clientsprojets\');return false;" class="troubletickets_export_menuselectionne">'.troubletickets_traduire('Customers and projects').'</a></div>';
				} else {
					$this->corps .= '<div><a href="#" onclick="troubletickets_export_affichecolonnedroite(this, \'clientsprojets\');return false;" class="troubletickets_export_menunonselectionne">'.troubletickets_traduire('Customers and projects').'</a></div>';
				}

				$this->corps .= '		</td>
										<td width="80%" height="150">
											<div id="troubletickets_export_colonnedroite">
											</div>
										</td>
									</tr>
								</table>';

				/* Bouton Export */
				$this->tgenerer = troubletickets_traduire('Generate the export CSV file');
				$this->urlgenerer = $babAddonUrl.'user&amp;idx=statistiques&amp;mode=genererexportcsv';

				$this->corps .= '<br />
								 <table align="center">
									<tr valign="middle">
										<td>
											<a style="outline:none;" href="'.$this->urlgenerer.'"><img src="'.troubletickets_urltemplatesmodule().'images/ark2.gif" alt="" title="" /></a>
										</td>
										<td>
											<h3>'.$this->tgenerer.'</h3>
										</td>
									</tr>
								 </table>
								 <br />';

				$this->corps .= '	</div>';
				$this->corps .= '</div>';

				$this->corps .= '
								<script type="text/javascript">
								<!--

								/* Ds que le DOM est charg */
								jQuery(document).ready( function() {
									/* Affiche le bouton Filtres sur la liste si cookie existe */
									$valeurcookie = troubletickets_recupcookie(\'troubletickets_stats_affichefiltres\');
									if ($valeurcookie != undefined) {
										if ($valeurcookie == 1) {
											troubletickets_stats_affichecachefiltres();
										}
									}
								});

								// -->
							</script>

				';

				/* Aide */
				$this->aide = "La slection de la priode a pour effet d'analyser tous les tickets ouverts pendant cette priode<br />";
			}

			if ($mode == 'genererexportcsv') {
				set_time_limit(3600); //Fixe le temps maximum d'excution d'un script

				$nomscolonnes = array('ticket_id', 'ticket_reference', 'ticket_auteurid', 'ticket_auteurnom', 'ticket_titre', 'ticket_description', 'ticket_statutid', 'ticket_statutnom', 'ticket_graviteid', 'ticket_gravitenom', 'ticket_datecreation', 'projet_id', 'projet_nom', 'echange_id', 'echange_auteurid', 'echange_auteurnom', 'echange_description', 'echange_datecreation', 'echange_type', 'echange_statutid', 'echange_statutnom', 'echange_nbfichiers', 'vieduticket_id', 'vieduticket_auteurid', 'vieduticket_auteurnom', 'vieduticket_description', 'vieduticket_datecreation', 'vieduticket_type');
				$donnees = array();

				/* Rcupration des cookies */
				$filtreprojet = troubletickets_valeurcookie('troubletickets_export_filtreprojet');
				$filtreclient = troubletickets_valeurcookie('troubletickets_export_filtreclient');
				$filtreinterlocuteur = troubletickets_valeurcookie('troubletickets_export_filtreinterlocuteur');
				$filtregravite = troubletickets_valeurcookie('troubletickets_export_filtregravite');
				$filtrecategoriescloture = troubletickets_valeurcookie('troubletickets_export_filtrecategoriecloture');
				$filtrestatut = troubletickets_valeurcookie('troubletickets_export_filtrestatut');

				/* Vrification des donnes */
				if (!is_numeric($filtreprojet)) {
					$filtreprojet = '';
				}
				if (!is_numeric($filtreclient)) {
					$filtreclient = '';
				}
				if (!is_numeric($filtreinterlocuteur)) {
					$filtreinterlocuteur = '';
				}

				/* Rcupration des tickets */
				$listetickets = troubletickets_listetickets('id', 'asc', $filtreprojet, $filtreclient, $filtrestatut, $filtregravite, $filtreinterlocuteur, '', '', '', '', '', '', 'creation', $datedebut, $datefin, false, false, $filtrecategoriescloture);
				/* Une ligne de l'export est soit la cration d'un ticket, un change du ticket ou une vie du ticket */
				$nblistetickets = count($listetickets);
				for ($i=0;$i<=$nblistetickets-1;$i++) {
					$t = $listetickets[$i];
					/* Cration du ticket */
					$fiche = troubletickets_ficheannuaire($t->auteur);
					$projet = troubletickets_listeprojets($t->projet);
					$donnees[] = array($t->id, $t->reference, $t->auteur, $fiche['sn'].' '.$fiche['givenname'], $t->titre, $t->description, $t->statutticket, $t->nomstatut(), $t->gravite, $t->nomgravite(), $t->dateticket, $t->projet, $projet[0]->nom, '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');

					/* Echanges et historiques */
					$afficheechanges = array();
					$affichehistoriques = array();
					//Reconstruit chaque echange et historique
					$echanges = $t->echanges();
					for($j=0;$j<=count($echanges)-1;$j++) {
						$idechange = $echanges[$j]->id;
						$idauteur = $echanges[$j]->auteur;
						$auteur = troubletickets_ficheannuaire($echanges[$j]->auteur);
						$auteurechange = $auteur['sn'].' '.$auteur['givenname'];
						$descriptionechange = $echanges[$j]->description;
						$dateechange = $echanges[$j]->dateechange;
						$statutechange = $echanges[$j]->statutechange;
						$statut = troubletickets_listestatutsechanges($echanges[$j]->statutechange);
						$statutechangenom = $statut[0]['nom'];
						if ($echanges[$j]->type == '1') {
							$type = 'client';
						} else {
							$type = 'intervenant';
						}
						//Liste des fichiers de l'change
						$fichiersechange = $echanges[$j]->fichiers();
						$nbfichiersechange = count($fichiersechange);

						$tab = array($t->id, $t->reference, $t->auteur, $fiche['sn'].' '.$fiche['givenname'], $t->titre, $t->description, '', '', '', '', $t->dateticket, $t->projet, $projet[0]->nom, $idechange, $idauteur, $auteurechange, $descriptionechange, $dateechange, $type, $statutechange, $statutechangenom, $nbfichiersechange, '', '', '', '', '', '');

						$date = $echanges[$j]->dateechange;
						$date = substr($date,0,4).substr($date,5,2).substr($date,8,2).substr($date,11,5);
						$afficheechanges[] = array($date, $tab);
					}
					$historique = $t->historique();
					for($j=0;$j<=count($historique)-1;$j++) {
						$idhistorique = $historique[$j]->id;
						$idauteur = $historique[$j]->auteur;
						$auteur = troubletickets_ficheannuaire($historique[$j]->auteur);
						$auteurhistorique = $auteur['sn'].' '.$auteur['givenname'];
						$descriptionhistorique = $historique[$j]->description;
						$datehistorique = $historique[$j]->datehistorique;
						$statuthistorique = $historique[$j]->statutticket;
						$statut = troubletickets_listestatutstickets($historique[$j]->statutticket);
						$statuthistoriquenom = $statut[0]['nom'];
						$gravitehistorique = $historique[$j]->gravite;
						$gravite = troubletickets_listegravites($historique[$j]->gravite);
						$gravitehistoriquenom = $gravite[0]['nom'];
						if ($historique[$j]->type == '1') {
							$type = 'client';
						} else {
							$type = 'intervenant';
						}

						$tab = array($t->id, $t->reference, $t->auteur, $fiche['sn'].' '.$fiche['givenname'], $t->titre, $t->description, $statuthistorique, $statuthistoriquenom, $gravitehistorique, $gravitehistoriquenom, $t->dateticket, $t->projet, $projet[0]->nom, '', '', '', '', '', '', '', '', '', $idhistorique, $idauteur, $auteurhistorique, $descriptionhistorique, $datehistorique, $type);

						$date = $historique[$j]->datehistorique;
						$date = substr($date,0,4).substr($date,5,2).substr($date,8,2).substr($date,11,5);
						$affichehistoriques[] = array($date, $tab);
					}
					//Tri les tableaux par dates
					$nbAfficheEchanges = count($afficheechanges);
					for ($j=0;$j<=$nbAfficheEchanges-1;$j++) {
						for ($k=0;$k<=$nbAfficheEchanges-1;$k++) {
							if ($k > 0) {
								if (strcmp(strtolower($afficheechanges[$k][0]), strtolower($afficheechanges[$k-1][0])) > 0) {
									$copie = $afficheechanges[$k-1];
									$afficheechanges[$k-1] = $afficheechanges[$k];
									$afficheechanges[$k] = $copie;
								}
							}
						}
					}
					$nbAfficheHistorique = count($affichehistoriques);
					for ($j=0;$j<=$nbAfficheHistorique-1;$j++) {
						for ($k=0;$k<=$nbAfficheHistorique-1;$k++) {
							if ($k > 0) {
								if (strcmp(strtolower($affichehistoriques[$k][0]), strtolower($affichehistoriques[$k-1][0])) > 0) {
									$copie = $affichehistoriques[$k-1];
									$affichehistoriques[$k-1] = $affichehistoriques[$k];
									$affichehistoriques[$k] = $copie;
								}
							}
						}
					}
					//Regroupe les donnes changes et historiques
					$indexe = 0;
					$indexh = 0;

					for ($j=0;$j<=$nbAfficheEchanges+$nbAfficheHistorique-1;$j++) {
						if (isset($afficheechanges[$indexe])) {
							if (isset($affichehistoriques[$indexh])) {
								//On vrifie la date la plus rcente entre l'change et l'historique
								if (strcmp(strtolower($afficheechanges[$indexe][0]), strtolower($affichehistoriques[$indexh][0])) > 0) {
									$donnees[] = $afficheechanges[$indexe][1];
									$indexe++;
								} else {
									$donnees[] = $affichehistoriques[$indexh][1];
									$indexh++;
								}
							} else {
								//Il n'y a plus d'historiques, on rcupre donc les derniers echanges
								$donnees[] = $afficheechanges[$indexe][1];
								$indexe++;
							}
						} else {
							//Il n'y a plus d'echanges, on rcupre donc les derniers historiques
							$donnees[] = $affichehistoriques[$indexh][1];
							$indexh++;
						}
					}
				}
				troubletickets_exportcsv($nomscolonnes, $donnees, ';', 'troubletickets_stats_'.troubletickets_datedujour('j-m-a').'.csv');
			}
			
			if ($mode == 'support') {
				$this->corps .= '<br />';
				$this->corps .= '<div width="100%" class="troubletickets_stats_blocbleu">';
				
				$this->corps .= '<div class="troubletickets_stats_blocbleu_titre">Rpartition des tickets par client</div>';
				$this->corps .= '<div class="troubletickets_stats_blocbleu_contenu">';
				
				$this->corps .= '
									<table border="1" style="border-collapse:collapse;" cellpadding="4" width="100%">
									<tr>
									<th align="center">Client en contrat de support</th>
									<th align="center">Date de dernire intervention</th>
									</tr>
								';
				global $babDB;
				$req = "SELECT troubletickets_client.nom, max(troubletickets_echangeticket.dateechange) as dateechange
						FROM troubletickets_echangeticket, troubletickets_client, troubletickets_projet
						WHERE troubletickets_projet.client = troubletickets_client.id
						AND troubletickets_echangeticket.projet = troubletickets_projet.id
						AND troubletickets_projet.type = 1
						AND troubletickets_projet.statut = 1
						GROUP BY troubletickets_client.id
						ORDER BY max(troubletickets_echangeticket.dateechange) ASC
				";
				$res = $babDB->db_query($req);
				
				while($arr = $babDB->db_fetch_assoc($res)){
				
					$this->corps .= '
										<tr>
											<td>' . $arr['nom'] . '</td>
											<td align="right">' . $arr['dateechange'] . '</td>
										</tr>
									';
				}
					
				$this->corps .= '
									</table>
								';
				
				
				$this->corps .= '</div>';
				$this->corps .= '</div>';
			}
		}
	}
	//Cration de l'objet et appel de la fonction babPrintTemplate
	//Interface
	$interface_objets = array();
	$interface_fichiers = array();
	$interface_templates = array();
	$interface_bandeau_statistiques = new troubletickets_interface_bandeau_statistiques($erreurs);
	$interface_objets[] = $interface_bandeau_statistiques;
	$interface_fichiers[] = "interface.html";
	$interface_templates[] = "interface_bandeau_statistiques";
	//Contenu
	$interface_contenu = new troubletickets_statistiques($donnees, $erreurs);
	$interface_objets[] = $interface_contenu;
	$interface_fichiers[] = "userpages2.html";
	$interface_templates[] = "statistiques";
	troubletickets_template($interface_objets, $interface_fichiers, $interface_templates, true);
}

/* Statistiques : affiche l'image sur les statuts des tickets */
function troubletickets_statistiques_imagestatutstickets($donnees, &$erreurs) {
	$nbticketstotal = $donnees['nbticketsouverts'] + $donnees['nbticketstraites'] + $donnees['nbticketsfermes'];
	if ($nbticketstotal != 0) {
		$donnees2 = array($donnees['nbticketsouverts'], $donnees['nbticketstraites'], $donnees['nbticketsfermes']);
		$legendes = array(troubletickets_traduire('Open tickets').' ('.$donnees['nbticketsouverts'].')', troubletickets_traduire('Treated tickets').' ('.$donnees['nbticketstraites'].')', troubletickets_traduire('Tickets closed').' ('.$donnees['nbticketsfermes'].')');
		$camembert = new TroubleTickets_StatistiquesCamembert(troubletickets_traduire('General status of tickets'), troubletickets_traduire('Total number of tickets').' : '.$nbticketstotal, 500, 250, $donnees2, $legendes);
		$camembert->affiche();
	}
}

/* Statistiques : affiche l'image sur tous les statuts des tickets */
function troubletickets_statistiques_imagetousstatutstickets($donnees, &$erreurs) {
	$nbticketstotal = $donnees['nbticketsenattente'] + $donnees['nbticketsencours'] + $donnees['nbticketsendemande'] + $donnees['nbticketsendemandeacceptee'] + $donnees['nbticketsendemanderefusee'] + $donnees['nbticketsnonaccepte'];
	if ($nbticketstotal != 0) {
		$donnees2 = array($donnees['nbticketsenattente'], $donnees['nbticketsencours'], $donnees['nbticketsendemande'], $donnees['nbticketsendemandeacceptee'], $donnees['nbticketsendemanderefusee'], $donnees['nbticketsnonaccepte']);
		$legendes = array(troubletickets_traduire('In waiting').' ('.$donnees['nbticketsenattente'].')', troubletickets_traduire('Under treatment').' ('.$donnees['nbticketsencours'].')', troubletickets_traduire('In demand of close').' ('.$donnees['nbticketsendemande'].')', troubletickets_traduire('In close accepted').' ('.$donnees['nbticketsendemandeacceptee'].')', troubletickets_traduire('In close refused').' ('.$donnees['nbticketsendemanderefusee'].')', troubletickets_traduire('Non accepteds').' ('.$donnees['nbticketsnonaccepte'].')');
		$camembert = new TroubleTickets_StatistiquesCamembert(troubletickets_traduire('Status of tickets'), troubletickets_traduire('Total number of tickets').' : '.$nbticketstotal, 500, 250, $donnees2, $legendes);
		$camembert->affiche();
	}
}

/* Statistiques : affiche l'image sur les gravits */
function troubletickets_statistiques_imagegravitestickets($donnees, &$erreurs) {
	$nbticketstotal = $donnees['nbticketsmineur'] + $donnees['nbticketsbloquant'] + $donnees['nbticketsgrave'] + $donnees['nbticketsamelioration'];
	if ($nbticketstotal != 0) {
		$donnees2 = array($donnees['nbticketsmineur'], $donnees['nbticketsbloquant'], $donnees['nbticketsgrave'], $donnees['nbticketsamelioration']);
		$legendes = array(troubletickets_traduire('Minor').' ('.$donnees['nbticketsmineur'].')', troubletickets_traduire('Blocking').' ('.$donnees['nbticketsbloquant'].')', troubletickets_traduire('Grave').' ('.$donnees['nbticketsgrave'].')', troubletickets_traduire('Improvement').' ('.$donnees['nbticketsamelioration'].')');
		$camembert = new TroubleTickets_StatistiquesCamembert(troubletickets_traduire('Severities of tickets'), troubletickets_traduire('Total number of tickets').' : '.$nbticketstotal, 500, 250, $donnees2, $legendes);
		$camembert->affiche();
	}
}

/* Statistiques : affiche l'image sur les gravits des tickets ouverts */
function troubletickets_statistiques_imagegravitesticketsouverts($donnees, &$erreurs) {
	$nbticketstotal = $donnees['nbticketsmineur'] + $donnees['nbticketsbloquant'] + $donnees['nbticketsgrave'] + $donnees['nbticketsamelioration'];
	if ($nbticketstotal != 0) {
		$donnees2 = array($donnees['nbticketsmineur'], $donnees['nbticketsbloquant'], $donnees['nbticketsgrave'], $donnees['nbticketsamelioration']);
		$legendes = array(troubletickets_traduire('Minor').' ('.$donnees['nbticketsmineur'].')', troubletickets_traduire('Blocking').' ('.$donnees['nbticketsbloquant'].')', troubletickets_traduire('Grave').' ('.$donnees['nbticketsgrave'].')', troubletickets_traduire('Improvement').' ('.$donnees['nbticketsamelioration'].')');
		$camembert = new TroubleTickets_StatistiquesCamembert(troubletickets_traduire('Severities of opened tickets'), troubletickets_traduire('Total number of tickets').' : '.$nbticketstotal, 500, 250, $donnees2, $legendes);
		$camembert->affiche();
	}
}

/* Statistiques : affiche l'image sur la repartition des tickets par client */
function troubletickets_statistiques_imagerepartitionparclient($clients, $nb_tickets) {
	$legendes = array();
	$donnees2 = array();
	$count = 0;
	foreach ($clients as $clientId => $nom) {
		if ($count >= 10) {
			$donnees2[$count] += $nb_tickets[$clientId] . '%';
			$legendes[$count] = 'Autres (' . $donnees2[$count] . '%%)';
		} else {
			$legendes[$count] = bab_abbr($nom, BAB_ABBR_FULL_WORDS, 40) . ' (' . $nb_tickets[$clientId] . '%%)';
			$donnees2[$count] = $nb_tickets[$clientId] . '%';
			$count++;
		}
	}
	$camembert = new TroubleTickets_StatistiquesCamembert(troubletickets_traduire('Tickets by client'), '', 650, 250, $donnees2, $legendes);
	$camembert->affiche();
}

/* Affiche le contenu de la colonne droite des filtres pour l'export CSV */
function troubletickets_export_colonnedroite($donnees, $erreurs) {
	$html = '';
	$menu = $donnees['menu'];
	if ($menu != 'statutsgravites' && $menu != 'clientsprojets') {
		$menu = troubletickets_valeurcookie('troubletickets_export_menu');
	}
	if ($menu != 'statutsgravites' && $menu != 'clientsprojets') {
		$menu = 'statutsgravites';
	}
	/* Enregistrement de la valeur du menu par cookie */
	troubletickets_creecookie('troubletickets_export_menu', $menu, 0);

	/* Affiche la colonne droite en rapport au menu slectionn */
	if ($menu == 'statutsgravites') {
		$html = troubletickets_export_colonnedroitestatutsgravites();
	}
	if ($menu == 'clientsprojets') {
		$html .= '<table width="100%" border="0" cellpadding="5" cellspacing="0">
					<tr valign="top">
						<td width="30%">';
		$html .= troubletickets_export_colonnedroiteclients();
		$html .= '		</td>
						<td width="30%">';
		$html .= troubletickets_export_colonnedroiteinterlocuteurs();
		$html .= '		</td>
						<td width="30%">';
		$html .= troubletickets_export_colonnedroiteprojets();
		$html .= '		</td>
						<td width="10%">
							<img id="troubletickets_export_ajaxchargement" src="'.troubletickets_urltemplatesmodule().'images/ajax-loader.gif" alt="" title="" />
						</td>
					</tr>
				  </table>';
	}

	/* die permet de recevoir le contenu sans le contenu d'Ovidentia (bannire, balise html...) */
	$charset = 'ISO-8859-15';
	if (class_exists('bab_charset')) {
		$charset = bab_charset::getIso();
	}
	header('Content-type: text/html; charset='.$charset);
	die($html);
}

/* Export : affiche les filtres sur les statuts et gravits */
function troubletickets_export_colonnedroitestatutsgravites() {
	$html = '';

	global $babPhpSelf, $babAddonTarget;

	/* Rcupration du cookie statut */
	/* $filtrestatut contient un ou plusieurs identifiants de statuts */
	$filtrestatuttmp = explode(",", troubletickets_valeurcookie('troubletickets_export_filtrestatut'));
	$filtrestatut = array();
	$touslesfiltres = array(1,2,3,4,5,6,7,8,9);
	for ($i=0;$i<=count($filtrestatuttmp)-1;$i++) {
		/* Supprime les espaces et les valeurs non numriques */
		$filtrestatuttmp[$i] = trim($filtrestatuttmp[$i]);
		if (in_array($filtrestatuttmp[$i], $touslesfiltres)) {
			$filtrestatut[] = $filtrestatuttmp[$i];
		}
	}

	/* Rcupration du cookie gravit */
	/* $filtregravite contient un ou plusieurs identifiants de gravits */
	$filtregravitetmp = explode(",", troubletickets_valeurcookie('troubletickets_export_filtregravite'));
	$filtregravite = array();
	$touslesfiltres = array(1,2,3,4);
	for ($i=0;$i<=count($filtregravitetmp)-1;$i++) {
		/* Supprime les espaces et les valeurs non numriques */
		$filtregravitetmp[$i] = trim($filtregravitetmp[$i]);
		if (in_array($filtregravitetmp[$i], $touslesfiltres)) {
			$filtregravite[] = $filtregravitetmp[$i];
		}
	}

	/* Rcupration du cookie Catgorie de clture */
	/* $filtrecategoriescloture contient un ou plusieurs identifiants de Catgorie de clture */
	$filtrecategoriescloturetmp = explode(",", troubletickets_valeurcookie('troubletickets_export_filtrecategoriecloture'));
	$filtrecategoriescloture = array();
	$touslesfiltres = array(0,1,2,3,4);
	for ($i=0;$i<=count($filtrecategoriescloturetmp)-1;$i++) {
		/* Supprime les espaces et les valeurs non numriques */
		$filtrecategoriescloturetmp[$i] = trim($filtrecategoriescloturetmp[$i]);
		if (in_array($filtrecategoriescloturetmp[$i], $touslesfiltres)) {
			$filtrecategoriescloture[] = $filtrecategoriescloturetmp[$i];
		}
	}

	/* Affiche la liste des statuts et des gravits */
	$html .= '<script type="text/javascript">
				<!--

				/* Slectionne tous les statuts ouverts */
				function troubletickets_selectionnestatutsouverts() {
					/* On dslectionne tout */
					jQuery(".troubletickets_statutcheckbox").removeAttr("checked");

					/* On coche les statuts */
					jQuery(".troubletickets_statutcheckbox").each(function(i) {
						$valeur = jQuery(this).attr("value");
						if ($valeur == 1 || $valeur == 2 || $valeur == 5 || $valeur == 6 || $valeur == 7) {
							jQuery(this).attr("checked", "checked");
						}
					});
					troubletickets_savecookie("troubletickets_export_filtrestatut", "ouvert");
				}

				/* Relance l\'affichage de la colonne droite */
				function troubletickets_export_colonnedroite() {
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_colonnedroite", function(data){
						jQuery("#troubletickets_export_colonnedroite").html(data);
					});
				}

				/* Ds que le DOM est charg */
				jQuery(document).ready( function() {
					/* Initialise les statuts */
					';
				for ($i=0;$i<=count($filtrestatut)-1;$i++) {
					$html .= 'jQuery(".troubletickets_statutcheckbox").each(function(i) {
									$valeur = jQuery(this).attr("value");
									if ($valeur == '.$filtrestatut[$i].') {
										jQuery(this).attr("checked", "checked");
									}
							  });';
				}
	$html .= '/* Initialise les gravits */
			  ';
				for ($i=0;$i<=count($filtregravite)-1;$i++) {
					$html .= 'jQuery(".troubletickets_gravitecheckbox").each(function(i) {
									$valeur = jQuery(this).attr("value");
									if ($valeur == '.$filtregravite[$i].') {
										jQuery(this).attr("checked", "checked");
									}
							  });';
				}
				
	$html .= '/* Initialise les Catgorie de clture */
			  ';
				for ($i=0;$i<=count($filtrecategoriescloture)-1;$i++) {
					$html .= 'jQuery(".troubletickets_categoriescloturecheckbox").each(function(i) {
									$valeur = jQuery(this).attr("value");
									if ($valeur == '.$filtrecategoriescloture[$i].') {
										jQuery(this).attr("checked", "checked");
									}
							  });';
				}
	$html .= '	});

				// -->
			  </script>';
	global $babPhpSelf, $babAddonTarget;
	$html .= '<table width="100%" border="0" cellpadding="5" cellspacing="0">
				<tr valign="top">
					<td width="30%">';
	$html .= '			<b>'.troubletickets_traduire('Statutes').' :</b><br />';
	$html .= '			<form name="recherchetickets" method="post" action="'.$babPhpSelf.'">
							<table>
								<tr valign="top">
									<td>
										<input type="hidden" name="tg" value="'.$babAddonTarget.'/user" />
										<input type="hidden" name="idx" value="export_statutsenregistres" />
										<input type="checkbox" name="statuts[]" value="1" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('In waiting of consideration').'<br />';
	$html .= '							<input type="checkbox" name="statuts[]" value="2" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('Under treatment').'<br />';
	$html .= '							<input type="checkbox" name="statuts[]" value="5" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('Demand of close').'<br />';
	$html .= '							<input type="checkbox" name="statuts[]" value="6" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('Demand of close accepted').'<br />';
	$html .= '							<input type="checkbox" name="statuts[]" value="7" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('Demand of close refused').'<br />';
	$html .= '							<input type="checkbox" name="statuts[]" value="8" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('Ticket non accepted').'<br />';
	$html .= '							<input type="checkbox" name="statuts[]" value="9" class="troubletickets_statutcheckbox" /> '.troubletickets_traduire('Closed ticket').'<br />
									</td>
									<td>
										<input type="submit" value="'.troubletickets_traduire('OK').'" />
									</td>
								</tr>
							</table>
						</form>
						<br />
						<a href="#" class="troubletickets_stats_cocherstatutsouverts" onclick="troubletickets_selectionnestatutsouverts();return false;">'.troubletickets_traduire('Check all statutes of opened tickets').'</a>';
	$html .= '		</td>
					<td width="30%">';
	$html .= '			<b>'.troubletickets_traduire('Gravities').' :</b><br />';
	$html .= '			<form name="recherchetickets" method="post" action="'.$babPhpSelf.'">
							<table>
								<tr valign="top">
									<td>
										<input type="hidden" name="tg" value="'.$babAddonTarget.'/user" />
										<input type="hidden" name="idx" value="export_gravitesenregistres" />
										<input type="checkbox" name="gravites[]" value="1" class="troubletickets_gravitecheckbox" /> '.troubletickets_traduire('Minor').'<br />';
	$html .= '							<input type="checkbox" name="gravites[]" value="2" class="troubletickets_gravitecheckbox" /> '.troubletickets_traduire('Blocking').'<br />';
	$html .= '							<input type="checkbox" name="gravites[]" value="3" class="troubletickets_gravitecheckbox" /> '.troubletickets_traduire('Engrave').'<br />';
	$html .= '							<input type="checkbox" name="gravites[]" value="4" class="troubletickets_gravitecheckbox" /> '.troubletickets_traduire('Improvement').'<br />';
	$html .= '						</td>
									<td>
										<input type="submit" value="'.troubletickets_traduire('OK').'" />
									</td>
								</tr>
							</table>
						</form>';
	$html .= '		</td>';
	if(troubletickets_adroitsprojets('intervenants')){
		$html .= '	<td width="30%">';
		$html .= '		<b>'.troubletickets_traduire('Categorie de clture').' :</b><br />';
		$html .= '		<form name="recherchetickets" method="post" action="'.$babPhpSelf.'">
							<table>
								<tr valign="top">
									<td>
										<input type="hidden" name="tg" value="'.$babAddonTarget.'/user" />
										<input type="hidden" name="idx" value="controlesfiltres_categoriesclotureenregistres" />
										<input type="checkbox" name="categoriescloture[]" value="0" class="troubletickets_categoriescloturecheckbox" /> '.troubletickets_traduire('Undifined').'<br />';
		$html .= '						<input type="checkbox" name="categoriescloture[]" value="1" class="troubletickets_categoriescloturecheckbox" /> '.troubletickets_traduire('Integration Bug').'<br />';
		$html .= '						<input type="checkbox" name="categoriescloture[]" value="2" class="troubletickets_categoriescloturecheckbox" /> '.troubletickets_traduire('Coding Bug').'<br />';
		$html .= '						<input type="checkbox" name="categoriescloture[]" value="3" class="troubletickets_categoriescloturecheckbox" /> '.troubletickets_traduire('Usage issue').'<br />';
		$html .= '						<input type="checkbox" name="categoriescloture[]" value="4" class="troubletickets_categoriescloturecheckbox" /> '.troubletickets_traduire('Enhancement').'<br />
									</td>
									<td>
										<input type="submit" value="'.troubletickets_traduire('OK').'" />
									</td>
								</tr>
							</table>
						</form>';
		$html .= '	</td>';
	}
	$html .= '		<td width="10%">
						<img id="troubletickets_export_ajaxchargement" src="'.troubletickets_urltemplatesmodule().'images/ajax-loader.gif" alt="" title="" />
					</td>
				</tr>
			  </table>';

	return $html;
}

/* Filtre statuts enregistrs */
function troubletickets_export_statutsenregistres($donnees, $erreurs) {
	/* $statuts peut contenir un ou plusieurs identifiants de statuts ou la valeur 'aucun', ou la valeur 'ouvert' */
	$valeurs = array(1, 2, 3, 4, 5, 6, 7, 8, 9);
	$statuts = '';
	if (count($donnees['statuts']) == 0) {
		$statuts = 'aucun';
	} else {
		for ($i=0;$i<=count($donnees['statuts'])-1;$i++) {
			if (in_array($donnees['statuts'][$i], $valeurs)) {
				if ($statuts == '') {
					$statuts .= $donnees['statuts'][$i];
				} else {
					$statuts .= ','.$donnees['statuts'][$i];
				}
			}
		}
	}

	troubletickets_creecookie('troubletickets_export_filtrestatut', $statuts);

	/* Retourne sur la liste des tickets */
	global $babPhpSelf, $babAddonTarget;
	header("Location: ".$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=statistiques&mode=export');
}

/* Filtres gravits enregistrs */
function troubletickets_export_gravitesenregistres($donnees, $erreurs) {
	/* $gravites peut contenir un ou plusieurs identifiants de gravites ou la valeur 'aucun' */
	$valeurs = array(1, 2, 3, 4);
	$gravites = '';
	if (count($donnees['gravites']) == 0) {
		$gravites = 'aucun';
	} else {
		for ($i=0;$i<=count($donnees['gravites'])-1;$i++) {
			if (in_array($donnees['gravites'][$i], $valeurs)) {
				if ($gravites == '') {
					$gravites .= $donnees['gravites'][$i];
				} else {
					$gravites .= ','.$donnees['gravites'][$i];
				}
			}
		}
	}

	troubletickets_creecookie('troubletickets_export_filtregravite', $gravites);

	/* Retourne sur la liste des tickets */
	global $babPhpSelf, $babAddonTarget;
	header("Location: ".$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=statistiques&mode=export');
}

/* Filtres categories de la cloture enregistrs */
function troubletickets_export_categoriesclotureenregistres($donnees, $erreurs) {
	/* $categoriescloture peut contenir un ou plusieurs identifiants de categories de la cloture ou la valeur 'aucun' */
	$valeurs = array(0, 1, 2, 3, 4);
	$categoriescloture = '';
	if (count($donnees['categoriescloture']) == 0) {
		$categoriescloture = 'aucun';
	} else {
		for ($i=0;$i<=count($donnees['categoriescloture'])-1;$i++) {
			if (in_array($donnees['categoriescloture'][$i], $valeurs)) {
				if ($categoriescloture == '') {
					$categoriescloture .= $donnees['categoriescloture'][$i];
				} else {
					$categoriescloture .= ','.$donnees['categoriescloture'][$i];
				}
			}
		}
	}
	
	troubletickets_creecookie('troubletickets_export_filtrecategoriecloture', $categoriescloture);
	
	/* Retourne sur la liste des tickets */
	global $babPhpSelf, $babAddonTarget;
	header("Location: ".$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=statistiques&mode=export');
}

/* Export : affiche les filtres sur les clients */
function troubletickets_export_colonnedroiteclients() {
	$html = '';

	global $babPhpSelf, $babAddonTarget;

	/* Rcupration du cookie client */
	$filtreclient = troubletickets_valeurcookie('troubletickets_export_filtreclient');
	if (!is_numeric($filtreclient)) {
		$filtreclient = '';
	}

	/* Rcupration du cookie de recherche client */
	$filtrerechercheclient = troubletickets_valeurcookie('troubletickets_export_filtrerechercheclient');

	/* Affiche la liste des clients */
	$html .= '<script type="text/javascript">
				<!--

				var troubletickets_rechercherclient_valeur = "";

				/* Relance l\'affichage de la colonne droite */
				function troubletickets_export_colonnedroiteclients() {
					jQuery("#troubletickets_export_ajaxchargement").show();
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_colonnedroite", function(data){
						jQuery("#troubletickets_export_colonnedroite").html(data);
						jQuery("#troubletickets_export_ajaxchargement").hide();

						troubletickets_rechercherclient_valeur = jQuery("#troubletickets_rechercherclient").val();

						/* Ajoute un focus sur le champ de saisie */
						jQuery("#troubletickets_rechercherclient").focus();
					});
				}

				/* Un client est cliqu */
				function troubletickets_clientclique(client) {
					jQuery("#troubletickets_export_ajaxchargement").show();
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_clientclique&client="+client, function(data) {
						jQuery("#troubletickets_export_ajaxchargement").hide();
						troubletickets_export_colonnedroiteclients();
					});
				}

				/* Recherche d\'un client */
				function troubletickets_rechercheclient(recherche) {
					if (troubletickets_rechercherclient_valeur != jQuery("#troubletickets_rechercherclient").val()) { /* Permet d\'viter de recharger la page et de remettre le focus en fin de ligne si on ne fait que bouger avec les flches */
						troubletickets_savecookie("troubletickets_export_filtrerechercheclient", recherche);
						troubletickets_export_colonnedroiteclients();
					}
				}

				/* Ds que le DOM est charg */
				jQuery(document).ready( function() {

				});

				// -->
			  </script>';

	$listeclients = troubletickets_listeclients();

	$html .= '<div class="troubletickets_stats_menuinterieur">'.troubletickets_traduire('Customers').'</div><br />';
	$html .= '<input name="rechercherclient" id="troubletickets_rechercherclient" value="'.$filtrerechercheclient.'" size="10" onkeyup="troubletickets_rechercheclient(this.value);" /> '.troubletickets_traduire('Search').'<br /><br />';
	if ($filtreclient == '') {
		$html .= '<a href="#" class="troubletickets_clientselectionne" onclick="troubletickets_clientclique(\'\');return false;">'.troubletickets_traduire('All the customers').'</a><br />';
	} else {
		$html .= '<a href="#" class="troubletickets_clientnonselectionne" onclick="troubletickets_clientclique(\'\');return false;">'.troubletickets_traduire('All the customers').'</a><br />';
	}
	$html .= '<ul class="troubletickets_stats_listeentrees">';
	for ($i=0;$i<=count($listeclients)-1;$i++) {
		if ($filtrerechercheclient == '') {
			if ($filtreclient == $listeclients[$i]->id) {
				$html .= '<li><a href="#" class="troubletickets_clientselectionne" onclick="troubletickets_clientclique('.$listeclients[$i]->id.');return false;">'.$listeclients[$i]->nom.'</a></li>';
			} else {
				$html .= '<li><a href="#" class="troubletickets_clientnonselectionne" onclick="troubletickets_clientclique('.$listeclients[$i]->id.');return false;">'.$listeclients[$i]->nom.'</a></li>';
			}
		} else {
			if (troubletickets_chaineexiste($listeclients[$i]->nom, $filtrerechercheclient, false, false)) {
				if ($filtreclient == $listeclients[$i]->id) {
					$html .= '<li><a href="#" class="troubletickets_clientselectionne" onclick="troubletickets_clientclique('.$listeclients[$i]->id.');return false;">'.$listeclients[$i]->nom.'</a></li>';
				} else {
					$html .= '<li><a href="#" class="troubletickets_clientnonselectionne" onclick="troubletickets_clientclique('.$listeclients[$i]->id.');return false;">'.$listeclients[$i]->nom.'</a></li>';
				}
			}
		}
	}
	$html .= '</ul>';

	return $html;
}

/* Fonction appele en Ajax lorsqu'on clique sur le filtre client */
function troubletickets_export_clientclique($donnees, $erreurs) {
	/* Rcupration du cookie client */
	$filtreclient = $donnees['client'];
	if (!is_numeric($filtreclient)) {
		$filtreclient = '';
	}
	/* Sauvegarde du cookie */
	troubletickets_creecookie('troubletickets_export_filtreclient', $filtreclient, 0);
	if ($filtreclient == '') {
		/* On supprime le cookie de recherche client */
		troubletickets_supprimecookie('troubletickets_export_filtrerechercheclient');
	}
	/* On supprime le cookie des interlocuteurs et des projets */
	troubletickets_supprimecookie('troubletickets_export_filtreinterlocuteur');
	troubletickets_supprimecookie('troubletickets_export_filtreprojet');
}

/* Export : affiche les filtres sur les interlocuteurs */
function troubletickets_export_colonnedroiteinterlocuteurs() {
	$html = '';

	global $babPhpSelf, $babAddonTarget;

	/* Rcupration du cookie interlocuteur */
	$filtreinterlocuteur = troubletickets_valeurcookie('troubletickets_export_filtreinterlocuteur');
	if (!is_numeric($filtreinterlocuteur)) {
		$filtreinterlocuteur = '';
	}

	/* Rcupration du cookie de recherche client */
	$filtrerechercheinterlocuteur = troubletickets_valeurcookie('troubletickets_export_filtrerechercheinterlocuteur');

	$html .= '<script type="text/javascript">
				<!--

				var troubletickets_rechercherinterlocuteur_valeur = "";

				/* Relance l\'affichage de la colonne droite */
				function troubletickets_export_colonnedroiteinterlocuteurs() {
					jQuery("#troubletickets_export_ajaxchargement").show();
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_colonnedroite", function(data){
						jQuery("#troubletickets_export_colonnedroite").html(data);
						jQuery("#troubletickets_export_ajaxchargement").hide();

						troubletickets_rechercherinterlocuteur_valeur = jQuery("#troubletickets_rechercherinterlocuteur").val();

						/* Ajoute un focus sur le champ de saisie */
						jQuery("#troubletickets_rechercherinterlocuteur").focus();
					});
				}

				/* Un interlocuteur est cliqu */
				function troubletickets_interlocuteurclique(interlocuteur) {
					jQuery("#troubletickets_export_ajaxchargement").show();
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_interlocuteurclique&interlocuteur="+interlocuteur, function(data) {
						jQuery("#troubletickets_export_ajaxchargement").hide();
						troubletickets_export_colonnedroiteinterlocuteurs();
					});
				}

				/* Recherche d\'un interlocuteur */
				function troubletickets_rechercheinterlocuteur(recherche) {
					if (troubletickets_rechercherinterlocuteur_valeur != jQuery("#troubletickets_rechercherinterlocuteur").val()) { /* Permet d\'viter de recharger la page et de remettre le focus en fin de ligne si on ne fait que bouger avec les flches */
						troubletickets_savecookie("troubletickets_export_filtrerechercheinterlocuteur", recherche);
						troubletickets_export_colonnedroiteinterlocuteurs();
					}
				}

				/* Ds que le DOM est charg */
				jQuery(document).ready( function() {

				});

				// -->
			  </script>';

	/* Rcupration du cookie client */
	$filtreclient = troubletickets_valeurcookie('troubletickets_export_filtreclient');
	if (is_numeric($filtreclient)) {
		$listeclients = troubletickets_listeclients($filtreclient);
		if (count($listeclients) == 1) {
			/* On liste les interlocuteurs */
			$html .= '<div class="troubletickets_stats_menuinterieur">'.troubletickets_traduire('Interlocutors').'</div><br />';
			$html .= '<input name="rechercherinterlocuteur" id="troubletickets_rechercherinterlocuteur" value="'.$filtrerechercheinterlocuteur.'" size="10" onkeyup="troubletickets_rechercheinterlocuteur(this.value);" /> '.troubletickets_traduire('Search').'<br /><br />';
			if ($filtreinterlocuteur == '') {
				$html .= '<a href="#" class="troubletickets_interlocuteurselectionne" onclick="troubletickets_interlocuteurclique(\'\');return false;">'.troubletickets_traduire('All the interlocutors customers').'</a><br />';
			} else {
				$html .= '<a href="#" class="troubletickets_interlocuteurnonselectionne" onclick="troubletickets_interlocuteurclique(\'\');return false;">'.troubletickets_traduire('All the interlocutors customers').'</a><br />';
			}
			$html .= '<ul class="troubletickets_stats_listeentrees">';
			$interlocuteurs = $listeclients[0]->interlocuteurs();
			for ($i=0;$i<=count($interlocuteurs)-1;$i++) {
				if ($filtrerechercheinterlocuteur == '') {
					if ($filtreinterlocuteur == $interlocuteurs[$i]->idutilisateur) {
						$html .= '<li><a href="#" class="troubletickets_interlocuteurselectionne" onclick="troubletickets_interlocuteurclique('.$interlocuteurs[$i]->idutilisateur.');return false;">'.$interlocuteurs[$i]->nom().' '.$interlocuteurs[$i]->prenom().'</a></li>';
					} else {
						$html .= '<li><a href="#" class="troubletickets_interlocuteurnonselectionne" onclick="troubletickets_interlocuteurclique('.$interlocuteurs[$i]->idutilisateur.');return false;">'.$interlocuteurs[$i]->nom().' '.$interlocuteurs[$i]->prenom().'</a></li>';
					}
				} else {
					if (troubletickets_chaineexiste($interlocuteurs[$i]->nom().' '.$interlocuteurs[$i]->prenom(), $filtrerechercheinterlocuteur, false, false)) {
						if ($filtreinterlocuteur == $interlocuteurs[$i]->idutilisateur) {
							$html .= '<li><a href="#" class="troubletickets_interlocuteurselectionne" onclick="troubletickets_interlocuteurclique('.$interlocuteurs[$i]->idutilisateur.');return false;">'.$interlocuteurs[$i]->nom().' '.$interlocuteurs[$i]->prenom().'</a></li>';
						} else {
							$html .= '<li><a href="#" class="troubletickets_interlocuteurnonselectionne" onclick="troubletickets_interlocuteurclique('.$interlocuteurs[$i]->idutilisateur.');return false;">'.$interlocuteurs[$i]->nom().' '.$interlocuteurs[$i]->prenom().'</a></li>';
						}
					}
				}
			}
			$html .= '</ul>';
		}
	}

	return $html;
}

/* Fonction appele en Ajax lorsqu'on clique sur le filtre interlocuteur */
function troubletickets_export_interlocuteurclique($donnees, $erreurs) {
	/* Rcupration du cookie interlocuteur */
	$filtreinterlocuteur = $donnees['interlocuteur'];
	if (!is_numeric($filtreinterlocuteur)) {
		$filtreinterlocuteur = '';
	}
	/* Sauvegarde du cookie */
	troubletickets_creecookie('troubletickets_export_filtreinterlocuteur', $filtreinterlocuteur, 0);
	if ($filtreinterlocuteur == '') {
		/* On supprime le cookie de recherche interlocuteur */
		troubletickets_supprimecookie('troubletickets_export_filtrerechercheinterlocuteur');
	}
}

/* Export : affiche les filtres sur les projets */
function troubletickets_export_colonnedroiteprojets() {
	$html = '';

	global $babPhpSelf, $babAddonTarget;

	/* Rcupration du cookie projet */
	$filtreprojet = troubletickets_valeurcookie('troubletickets_export_filtreprojet');
	if (!is_numeric($filtreprojet)) {
		$filtreprojet = '';
	}

	/* Rcupration du cookie de recherche client */
	$filtrerechercheprojet = troubletickets_valeurcookie('troubletickets_export_filtrerechercheprojet');

	$html .= '<script type="text/javascript">
				<!--

				var troubletickets_rechercherprojet_valeur = "";

				/* Relance l\'affichage de la colonne droite */
				function troubletickets_export_colonnedroiteprojets() {
					jQuery("#troubletickets_export_ajaxchargement").show();
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_colonnedroite", function(data){
						jQuery("#troubletickets_export_colonnedroite").html(data);
						jQuery("#troubletickets_export_ajaxchargement").hide();

						troubletickets_rechercherprojet_valeur = jQuery("#troubletickets_rechercherprojet").val();

						/* Ajoute un focus sur le champ de saisie */
						jQuery("#troubletickets_rechercherprojet").focus();
					});
				}

				/* Un projet est cliqu */
				function troubletickets_projetclique(projet) {
					jQuery("#troubletickets_export_ajaxchargement").show();
					/* Appel en Ajax */
					jQuery.get("'.$babPhpSelf.'?tg='.$babAddonTarget.'/user&idx=export_projetclique&projet="+projet, function(data) {
						jQuery("#troubletickets_export_ajaxchargement").hide();
						troubletickets_export_colonnedroiteprojets();
					});
				}

				/* Recherche d\'un projet */
				function troubletickets_rechercheprojet(recherche) {
					if (troubletickets_rechercherprojet_valeur != jQuery("#troubletickets_rechercherprojet").val()) { /* Permet d\'viter de recharger la page et de remettre le focus en fin de ligne si on ne fait que bouger avec les flches */
						troubletickets_savecookie("troubletickets_export_filtrerechercheprojet", recherche);
						troubletickets_export_colonnedroiteprojets();
					}
				}

				/* Ds que le DOM est charg */
				jQuery(document).ready( function() {

				});

				// -->
			  </script>';

	/* Rcupration du cookie client */
	$filtreclient = troubletickets_valeurcookie('troubletickets_export_filtreclient');
	if (is_numeric($filtreclient)) {
		$listeclients = troubletickets_listeclients($filtreclient);
		if (count($listeclients) == 1) {
			/* On liste les projets */
			$html .= '<div class="troubletickets_stats_menuinterieur">'.troubletickets_traduire('Projects').'</div><br />';
			$html .= '<input name="rechercherprojet" id="troubletickets_rechercherprojet" value="'.$filtrerechercheprojet.'" size="10" onkeyup="troubletickets_rechercheprojet(this.value);" /> '.troubletickets_traduire('Search').'<br /><br />';
			if ($filtreprojet == '') {
				$html .= '<a href="#" class="troubletickets_projetselectionne" onclick="troubletickets_projetclique(\'\');return false;">'.troubletickets_traduire('All the projects').'</a><br />';
			} else {
				$html .= '<a href="#" class="troubletickets_projetnonselectionne" onclick="troubletickets_projetclique(\'\');return false;">'.troubletickets_traduire('All the projects').'</a><br />';
			}
			$html .= '<ul class="troubletickets_stats_listeentrees">';
			$projets = $listeclients[0]->projets();
			for ($i=0;$i<=count($projets)-1;$i++) {
				if ($filtrerechercheprojet == '') {
					if ($filtreprojet == $projets[$i]->id) {
						$html .= '<li><a href="#" class="troubletickets_projetselectionne" onclick="troubletickets_projetclique('.$projets[$i]->id.');return false;">'.$projets[$i]->nom.'</a></li>';
					} else {
						$html .= '<li><a href="#" class="troubletickets_projetnonselectionne" onclick="troubletickets_projetclique('.$projets[$i]->id.');return false;">'.$projets[$i]->nom.'</a></li>';
					}
				} else {
					if (troubletickets_chaineexiste($projets[$i]->nom, $filtrerechercheprojet, false, false)) {
						if ($filtreprojet == $projets[$i]->id) {
							$html .= '<li><a href="#" class="troubletickets_projetselectionne" onclick="troubletickets_projetclique('.$projets[$i]->id.');return false;">'.$projets[$i]->nom.'</a></li>';
						} else {
							$html .= '<li><a href="#" class="troubletickets_projetnonselectionne" onclick="troubletickets_projetclique('.$projets[$i]->id.');return false;">'.$projets[$i]->nom.'</a></li>';
						}
					}
				}
			}
			$html .= '</ul>';
		}
	}

	return $html;
}

/* Fonction appele en Ajax lorsqu'on clique sur le filtre projet */
function troubletickets_export_projetclique($donnees, $erreurs) {
	/* Rcupration du cookie projet */
	$filtreprojet = $donnees['projet'];
	if (!is_numeric($filtreprojet)) {
		$filtreprojet = '';
	}
	/* Sauvegarde du cookie */
	troubletickets_creecookie('troubletickets_export_filtreprojet', $filtreprojet, 0);
	if ($filtreprojet == '') {
		/* On supprime le cookie de recherche projet */
		troubletickets_supprimecookie('troubletickets_export_filtrerechercheprojet');
	}
}

?>